; TITLE      : The CrackStop Remover *full source*
; VERSION    : 1.2
; AUTHOR     : Christoph Gabler
; DATE       : 5th of june in 1999
; PROG TYPE  : Tricky hardware breakpoint unpacker
; WORKS WITH : CS 1.0b, 1.01, 1.02, 1.03, 1.03 update
; USED MUSIC : No idea

; ADDITIONAL INFORMATION :
; The following source shows a nice possibility of how to fool both int1
; modification and clearing of DRx without using an own IDT and at the
; same time beeing able to unpack *all* CS versions.

code segment
org  100h
assume cs:code,ds:code
.386p

Start:

jmp short over_copyright
db 0Dh,0Ah,'*pURE nONSeNSE, pURE fUN*',0Dh,0Ah
over_copyright:

Call Clear_HW
Mov Ecx, 01030000h
Jecxz Start

Call Logo

Cmp DS:byte ptr [80h], 00
Jne OkPara

		mov	ah,9
                mov     dx,offset data_30       ; ('')
		int	21h			; DOS Services  ah=function 09h
TillHere:

Call Clear_Hw
Mov Bx, 100h
Mov Cx, TillHere - Start
KillMem2:
Mov CS:byte ptr [Bx], '?'
Inc Bx
Loop KillMem2
Mov Ax, 4C01h
Int 21h

DisplText:
Push Bx
Mov Al, CS:byte ptr [Bx]
Int 29h
Mov Cx, 0FFFFh
delay:
PushAd
PopAd
PushA
PopA
Loop delay

Pop Bx
Inc Bx
Cmp CS:byte ptr [Bx], '$'
Jne DisplText
Ret

OkPara:
Mov Bh, 00
Mov Bl, Ds:[80h]
Mov DS:byte ptr [81h+Bx], 00

Mov Bx, Offset hwbrktext
Call DisplText

MainCode:

Mov Dx, offset HWBrkPoint0
Mov Ax, 2501h
Int 21h

Mov Dx, Cs
Mov Bx, 103h     ; CS:103h
Mov Ax, 0103h    ; Write, DR3
Call SetBreak
Mov Ax, 0003h    ; DR3
Call EnableBreak
Nop
BreakHere:
Nop

Mov Cx, 12h
Mov Al, 00
Mov Di, 100h
Repz
Stosb

Cmp CS:byte ptr [103h], 12h    ; let a brkpoint eccour
Cmp Ax, 0BDFh
Jne BreakError

Call Clear_HW
Mov Ah, 9
Mov Dx, Offset Bootup2
Int 21h

; Open file, read file to 100h, Jmp 100h

Mov Ax, 3D02h
Xor Cx, Cx
Mov Dx, 82h
Int 21h
Jc Open_Error
Mov Di, Ax

Mov Bx, Ax
mov al, 02
xor cx, cx
xor dx, dx
mov ah, 42h   ; Filepointer to end of file.
Int 21h       
Mov CS:word ptr [FileSize], Ax
Mov CS:word ptr [FileSize2], Dx
Mov CS:word ptr [FileSize3], Dx

cwd
mov ax,4200h                ; Filepointer to begin.
Xor Cx,Cx
Xor Dx,Dx
Mov Bx, Di
int 21h

Mov Ah, 3Fh
Mov Bx, Di
Mov Dx, Offset Image
Mov Cx, 9000h
Int 21h        ; Read header

Cmp DS:word ptr [Image], 'ZM'
Je Exefound
Cmp DS:word ptr [Image], 'MZ'
Je Exefound
Mov Ah, 9
Mov Dx, Offset Comfile
Int 21h
Int 20h

Exefound:
cwd
Mov Dx, CS:word ptr [Image+8]               ; Get .EXE header size
iMul Dx, 16d
Mov CS:word ptr [Exe_Header], Dx

Mov Ax, CS:word ptr [Image+10h]             ; Get .EXE SP value
Mov CS:word ptr [Exe_Sp], Ax

Mov Cx, CS:word ptr [Image+16h]             ; Get .EXE offset
Cmp CS:word ptr [Image+0Eh], Cx
Jne RealExe
Mov CS:byte ptr [NoExe], 1
Sub Cx, Cx
RealExe:
Mov CS:word ptr [Exe_Offset], Cx

Mov Dx, CS:word ptr [Exe_Header]
mov ax,4200h                           ; Filepointer to module start.
Xor Cx,Cx
Mov Bx, Di
int 21h

Mov Dx, CS:word ptr [Image+0Eh]             ; Get .EXE Stack Segment
Mov CS:word ptr [Exe_SS], Dx

Mov Dx, CS:word ptr [Image+14h]             ; Get .EXE IP
Mov CS:word ptr [Exe_IP], Dx

Mov Ax, Cs
Add Ax, 1000h
Mov DS, Ax
Mov CS:word ptr [Exe_CS], Ax

Mov EBP, CS:dword ptr [FileSize]
pUSH dS

Mov Si, CS:word ptr [Exe_CS]
Add Si, 10h
Mov Ds, Si
Cmp CS:byte ptr [NoExe], 1
Je OverNormal
Sub Si, 10h
OverNormal:
Mov CS:word ptr [Exe_Ds], Si

Xor Dx, Dx
Cmp CS:byte ptr [NoExe], 1
Jne OkAsAlways
Add Dx, 100h
OkAsAlways:

ReadFile:
Mov Ah, 3Fh
Mov Bx, Di
Mov Cx, 2000h
Int 21h        ; Read whole file to EXE_CS:EXE_IP
Add CS:word ptr [FileSize2], Ax

Mov Ax, Ds
Add Ax, 200h
Mov Ds, Ax
Cmp Ebp, 2000h
Jbe FinishRead
Sub Ebp, 2000h
Jmp ReadFile

FinishRead:
pOP dS

mov ax,4200h                           ; Filepointer to module start.
Cwd
Mov Dx, CS:word ptr [Exe_Header]
Xor Cx,Cx
Mov Bx, Di
int 21h

Mov Bx, Di
Mov Ah, 3Eh
Int 21h

Mov Es, CS:word ptr [Exe_DS]

Push Cs
Pop Ds

Xor Si, Si
Xor Di, Di
Mov Cx, 0FFh
REPZ
MOVSB                    ; Move CX bytes from DS:SI to ES:DI

Mov Bx, CS:word ptr [Exe_CS]
Add Bx, CS:word ptr [Exe_Offset]
Add Bx, 10h
Mov CS:word ptr [Exe_CS], Bx

Push Cs
Pop Ds

; Check if file really CrackStopped!
Mov Ax, Es
Add Ax, 10h
Mov Bx, CS:word ptr [FileSize3]
Shl Bx, 0Ch
Add Ax, Bx
Mov Es, Ax
Push Es
Mov Bx, CS:word ptr [FileSize2]
Mov Cx, 100d
Check_if_CS0:
Cmp ES:dword ptr [Bx-100d], 0EAFBEB59h   ; 59,eb,fb,ea
Je Detected
Inc Bx
Loop Check_if_CS0

Mov Es, CS:word ptr [Exe_CS]
Mov Bx, CS:word ptr [Exe_IP]
Cmp ES:dword ptr [Bx], 0FFBB48B4h
Je Detected
Jmp Cs_Error

Detected:
Pop Es
Push Cs
Pop Ds

; Get CrackStop signature!
Mov Bx, CS:word ptr [FileSize2]
Mov Cx, 2000d
Check_if_CS:
Cmp ES:dword ptr [Bx-2000d], '0.1v'       ; 'v1.0'
Je Detected2
Inc Bx
Loop Check_if_CS

Detected2:
Push Bx

Mov Dx, Offset HWBrkPoint
Mov Ax, 2501h
Int 21h

; INT1 bypass!
Push Ds
Xor Ax, Ax
Mov Ds, Ax
Xor DS:dword ptr [4], 48484848h
Pop Ds

; Set up the hw breakpoint adress
Xor Dx, Dx
Mov Bx, 000Ch   ; Break on write to 0000:000Ch
Mov Ax, 0101h   ; Write, DR1
Call SetBreak

Mov Ax, 0001h
Call EnableBreak

Mov Ah, 9
Mov Dx, Offset CS_Found
Int 21h

Pop Bx
Add Bx, 76d
Cmp ES:dword ptr [Bx-1997d], ' :ot'  ; to:
Je Regged

Jmp BackAgain

Regged:
Mov Ah, 9
Mov Dx, Offset CS_Regged
Int 21h
Mov CS:byte ptr [ReggedVersion], 1
Jmp overthis1

BackAgain:

Mov Ah, 9
Mov Dx, Offset CS_ShareWare
Int 21h
overthis1:

pUSH cS
pOP eS

Mov Ah,9
Mov Dx, Offset Success0
Int 21h

; Set up the registers!

Mov Ds, CS:word ptr [Exe_DS]
Push Ds
Pop Es

CLi
Mov Dx, Ds
Cmp CS:byte ptr [NoExe], 1
Je NoNormExe
Mov Dx, CS:word ptr [Exe_SS]   ; Header SS
Mov Ax, Cs
Add Dx, Ax
Add Dx, 1010h
NoNormExe:
Mov SS, Dx
Mov Sp, CS:word ptr [Exe_Sp]
STi

Mov DS:word ptr [80h], 00

Xor Bp, Bp
Mov Dx, Ds
Xor Ax, Ax
Xor Bx, Bx
Xor Cx, Cx
Mov Di, Sp
Mov Si, CS:word ptr [Exe_Ip]

; Launch victim file!
Jmp CS:dword ptr [Exe_Ip]


;++
; New Hardware breakpoint handler for version CrackStop
;

HWBrkPoint:

Mov CS:word ptr [Save_Ax], Ax
Mov CS:word ptr [Save_Bx], Bx
Mov CS:word ptr [Save_Cx], Cx
Mov CS:word ptr [Save_Dx], Dx
Mov CS:word ptr [Save_Di], Di
Mov CS:word ptr [Save_Si], Si

Cmp CS:byte ptr [BypassINT1], 04
Jne NotRightBreak

; Check if 1.0b version or not!
Mov Si, Es
Pop Bx  ; IP
Pop Es  ; CS
Push Es Bx
Cmp ES:byte ptr [Bx], 9Ch
Je NotCS10b
Mov CS:byte ptr [Version10bcheck], 1
NotCS10b:
Mov Es, Si

Mov Si, Ds
Push Cs
Pop Ds
Mov Ah, 9
Mov Dx, Offset First
Int 21h
Mov Ds, Si

; Bypass CrackStop's INT1 encryption [another time]
Push Ds
Xor Ax, Ax
Mov Ds, Ax
mov cx, 4
mov bx, 4
Mov DS:word ptr [Bx], Offset HWBrkPoint2
Mov DS:word ptr [Bx+2], Cs

Xorme2:
Xor DS:byte ptr [Bx], 0BDh
Xor DS:byte ptr [Bx], 51h
Xor DS:byte ptr [Bx], 48h
Inc Bx
Loop Xorme2
Pop Ds

Call Clear_HW

Cmp CS:byte ptr [Version10bcheck], 1
Je Over_Bypass
Mov Si, Es
Pop Bx  ; Get IP
Pop Es  ; Get CS
Push Es
Cmp ES:word ptr [Bx+0Ch], 0375h
Jne Not_Updated_Version

Xor Ax, Ax
Add Bx, 0Eh
Add Bx, Ax
Push Bx
Mov Es, Si
Jmp Over_Bypass


Not_Updated_Version:
Mov Al, ES:byte ptr [Bx+0Dh]  ; Get JNE xxh value to jump over 386+ code!
Mov Ah, 00
Add Bx, 0Eh
Add Bx, Ax
Push Bx
Mov Es, Si
Over_Bypass:

Mov Dx, CS:word ptr [Exe_CS]
Mov Bx, CS:word ptr [Exe_IP]
Mov Ax, 0103h                 ; On Write method, DR3
Call SetBreak

Mov Ax, 0003h
Call EnableBreak

Mov Ax, CS:word ptr [Save_Ax]
Mov Bx, CS:word ptr [Save_Bx]
Mov Cx, CS:word ptr [Save_Cx]
Mov Dx, CS:word ptr [Save_Dx]
Mov Di, CS:word ptr [Save_Di]
Mov Si, CS:word ptr [Save_Si]
Iret

NotRightBreak:
Mov Es, Si

Cmp CS:byte ptr [BypassINT1], 00
Je Bypass1
Cmp CS:byte ptr [BypassINT1], 01
Je Bypass2

Jmp BypassNothing

Bypass1:
Mov Eax, 51515151h
Jmp BypassNow
Bypass2:
Mov Eax, 0BDBDBDBDh

BypassNow:

; INT1 bypass!
Push Ds
Xor Bx, Bx
Mov Ds, Bx
Xor DS:dword ptr [4], Eax
Pop Ds

BypassNothing:

Inc CS:byte ptr [BypassINT1]

Mov Ax, CS:word ptr [Save_Ax]
Mov Bx, CS:word ptr [Save_Bx]
Mov Cx, CS:word ptr [Save_Cx]
Mov Dx, CS:word ptr [Save_Dx]
Mov Di, CS:word ptr [Save_Di]
Mov Si, CS:word ptr [Save_Si]
Iret

BypassINT1 db 00

FileName db 'UNPACKED.EXE',00
Handle db 0,0
Version10bcheck db 0
ReggedVersion db 0
Signature db 0FFh,0BBh,48h,0B4h
Second db 10h,' SECOND BREAKPOiNT REACHED',0Dh,0Ah,'$'
First  db 10h,' FiRST BREAKPOiNT REACHED',0Dh,0Ah,'$'
Success0 db ' UNPACKiNG FiLE',0Dh,0Ah,'$'
Success db  ' UNPACKED.EXE WRiTTEN AND DONE!',0Dh,0Ah,'$'
BootUp db 'NOT AVAILABLE',0Dh,0Ah,'$'
BootUp2 db 'AVAILABLE',0Dh,0Ah,'$'
hwbrktext db ' HARDWARE BREAKPOINTS ','$'
Comfile db ' ERROR: WOULD YOU BE SO KiND TO ONLY SPECiFY .EXE FiLES?!',0Dh,0Ah,'$'
CS_Found     db ' CRACKSTOP DETECTED',0Dh,0Ah,'$'
CS_Regged    db ' REGiSTERED VERSiON FOUND',0Dh,0Ah,'$'
CS_ShareWare db ' SHAREWARE VERSiON FOUND',0Dh,0Ah,'$'
Reconstruct  db ' RECONSTRUCTiNG HEADER VALUES',0Dh,0Ah,'$'
ErrorMsg db 0Dh,0Ah
         db 'Please boot to plain DOS, no exotic memory manager nor Windows allowed!',0Dh,0Ah,'$'
ErrorMsg3  db ' ERROR: FiLE NOT FOUND',0Dh,0Ah,'$'
ErrorMsg4  db ' ERROR: FiLE DOESN''T SEEM TO BE PROTECTED WiTH CRACKSTOP!',0Dh,0Ah
           db '         (C)ontinue or (A)bort unpacking?',0Dh,0Ah,'$'

BreakError:
Mov Ah, 9
Mov Dx, Offset Bootup
Int 21h
Mov Ah, 9
Mov Dx, Offset ErrorMsg
Int 21h
Call Clear_HW
Mov Ax,4C01h
Int 21h
Open_Error:
Mov Ah, 9
Mov Dx, Offset ErrorMsg3
Int 21h
Call Clear_HW
Mov Ax,4C03h
Int 21h

CS_Error:
Mov Ah, 9
Mov Dx, Offset ErrorMsg4
Int 21h
Int16again:
Xor Ax, Ax
Int 16h
Cmp Al, 'c'
Je Detected
Cmp Al, 'a'
Je AbortUnpack
Jmp Int16again
AbortUnpack:
Mov Ax,4C01h
Int 21h


Clear_HW:
	      cli
	      xor eax,eax
	      mov dr7,eax     ; defeat hw breakpoints
	      mov dr0,eax
	      mov dr1,eax
	      mov dr2,eax
	      mov dr3,eax
	      sti
Ret

;++
; New Hardware breakpoint handler [dump/reconstruct]
;
HWBrkPoint2:

Xor Esi, Esi
Mov Si, Cx   ; Save filesize (cs bug)

Push Ds
Pop Es

Call Clear_Hw

Push Cs
Pop Ds

Mov Bp, Es

Mov Ah, 9
Mov Dx, Offset Second
Int 21h

Mov Dx, Offset FileName
Xor Cx, Cx
Mov Ah, 3Ch      ; Create file "UNPACKED.EXE"
Int 21h
Mov Di, Ax

Mov Ah, 9
Mov Dx, Offset Reconstruct
Int 21h

; Reconstruct old header

Xor Ecx, Ecx
Mov Cx, CS:word ptr [Filesize]
Mov Ax, CS:word ptr [FileSize3]
Shl Eax, 10h
Add Ecx, Eax
Sub Ecx, ESi   ; Save filesize
Sub Ecx, 333h + 29d
Cmp CS:byte ptr [Version10bcheck], 1
Jne OverAdd
Add Ecx, 2
OverAdd:

Cmp CS:byte ptr [ReggedVersion], 1
Jne OverAdd2
Add ECx, 100h
OverAdd2:
Mov CS:word ptr [SaveSize], Cx
Push Cx
Shr Ecx, 10h
Mov CS:word ptr [FileSize3], Cx
Pop Cx

; Image+2 and +4
Mov Ax, Cx
Mov Dx, Cx
And Ah, 1                       ; mod 512
Mov Cl, 9                       ; 2**9 = 512
Shr Dx, Cl                       
Inc Dx

Mov CS:word ptr [Image+2], Ax

Mov Cx, CS:word ptr [FileSize3]
Mov Bx, Cx
Imul Cx, 7Fh
Add Dx, Cx
Mov CS:word ptr [Image+4], Dx
Add CS:word ptr [Image+4], Bx

Mov Ax, Sp                          ;
Add Ax, 06h                         ; SP
Mov CS:word ptr [Image+10h], Ax     ;

Pop Bx  ; Get Ip                    ;
Pop Ds  ; Get Cs                    ;
Add Bx, 15h ; Modify because we aren't at real RETF
Push Ds Bx                          ; IP
Mov Ax, DS:word ptr [Bx+1]          ;
Mov CS:word ptr [Image+14h], Ax     ;   

Mov Ax, Ss                          ; -ES    ;
Mov Dx, Es
Sub Ax, Dx
Sub Ax, 20h                         ; -10h   ;   -> SS
Mov CS:word ptr [Image+0Eh], Ax     ; SS     ;

Mov Dx, Es
Mov Cx, Ss
Cmp Cx, Dx
Jne ReallyAnExe
Mov CS:word ptr [Image+16h], Dx
ReallyAnExe:
Add CS:word ptr [Image+0Eh], 10h    ; -10h   ;   -> SS  
notdothis:

Mov Ax, DS:word ptr [Bx+3]          ; CS
Sub Ax, 10h                         ;
Mov Dx, Es
Sub Ax, Dx
Mov CS:word ptr [Image+16h], Ax     ; -> CodeSegment Offset

Push Cs
Pop Ds
Mov Dx, Offset Image
Mov Cx, CS:word ptr [Exe_Header]
Mov Bx, Di

Mov Ah, 40h      ; Write old header to unpacked file
Int 21h

Mov Dx, Bp       ;
Add Dx, 10h      ; Point to DS+10:0000
Mov Ds, Dx       ;
Xor Ecx, Ecx
Xor Eax, Eax
Mov Cx, CS:word ptr [SaveSize]
Sub Cx, CS:word ptr [Exe_Header]
Mov Ax, CS:word ptr [FileSize3]
Shl Eax, 10h
Add Eax, Ecx
Mov Ebp, Eax     ; EBP=Filesize

Mov Bx, Di
Xor Dx, Dx
Cmp Ebp, 2000h
Jbe LastWrite

WriteFile:
Mov Bx, Di
Xor Dx, Dx
Mov Cx, 2000h
Mov Ah, 40h      ; Write unpacked image to disk
Int 21h
Mov Ax, Ds
Add Ax, 200h
Mov Ds, Ax
Sub Ebp, 2000h

Cmp Ebp, 2000h
Jbe LastWrite
Jmp WriteFile
LastWrite:
Mov Bx, Di
Xor Dx, Dx
Mov Cx, Bp
Mov Ah, 40h      ; Last write to disk
Int 21h

Push Cs
Pop Ds

Mov Ah, 3Eh
Mov Bx, Di
Int 21h

Mov Ah, 9
Mov Dx, Offset Success
Int 21h

exittodos:
Mov Ax, 4C00h
Int 21h

Save_Ax db 0,0
Save_Bx db 0,0
Save_Cx db 0,0
Save_Dx db 0,0
Save_Di db 0,0
Save_Si db 0,0
SaveEntry db 0,0
Save_XX db 0,0

HWBrkPoint0:
Pop Bx ; IP
Push Bx
Mov Ax, 0BDFh
IRet

db 00,'[HW BRKPOiNT ENGiNE 1.0]',00

FileSize db 0,0
FileSize2 db 0,0
FileSize3 db 0,0
SaveSize db 0,0
Exe_Ip db 0,0
Exe_Cs db 0,0
Exe_Header db 0,0
Exe_Offset db 0,0
Exe_SS db 0,0
Exe_Sp db 0,0
Exe_Ds db 0,0
NoExe db 0

;++
; Set hardware breakpoint
; Entry:
;	DX:BX	- segment:offset
;	AL	- num
;	AH	- type
;		    = 0 - execution
;		    = 1 - write
;		    = 3 - access
; Return:
;	NC	- if no error
;	CY	- if error occured
;--

        SetBreak proc

	pushad
	movzx	esi,dx
	shl	esi,4
	movzx	edi,bx
	add	esi,edi
	cmp	al,0
	jne	@@10
	mov	dr0,esi
@@10:	cmp	al,1
	jne	@@20
	mov	dr1,esi
@@20:	cmp	al,2
	jne	@@30
	mov	dr2,esi
@@30:	cmp	al,3
	ja	@@Err
	jne	@@40
	mov	dr3,esi
@@40:	mov	cl,al
	and	ah,0Fh			; Leave cond and len only
	movzx	ebx,ax
	xor	bl,bl
	shl	ebx,8
	mov	edx,0FFF0FFFFh
	shl	cl,2
	shl	ebx,cl
	shl	edx,cl			; Shift mask
	mov	bl,02h			; Global enable
	mov	dl,03h			; Mask both G&L enable bits
	shr	cl,1
	shl	bl,cl
	shl	dl,cl
	xor	dl,0FFh			; Invert mask
	mov	bh,2			; By setting this bit we make
					; CPU to point CS:IP exactly to
					; instruction that cause
					; breakpoint interrupt
	mov	dh,0FCh			; Mask is ready

	mov	eax,dr7
	and	eax,edx
	or	eax,ebx
	mov	dr7,eax
	popad
	clc
	ret
@@Err:	stc
	ret
	endp

;++
; Enable hardware breakpoint
; Entry:
;	AL	- num
; Return:
;	NC	- if no error
;	CY	- if error occured
; This procedure doesn't return error if al exceeds 3 and just
; enables nothing in this case.
;--

        EnableBreak proc
	push	eax			;
	push	ecx			;

	xor	ah,ah			;
	movzx	ecx,al			;
	shl	ecx,1			;
	inc	ecx			;
	mov	eax,dr7			;
	bts	eax,ecx			;
	mov	dr7,eax			;

	pop	ecx			;
	pop	eax			;
	ret				;
	endp				;

Logo:
		push	cs
		pop	ds
		jmp	short loc_1
data_1		db	7
data_2		db	0Dh, 0Ah, '$'
data_3		db	0FFh
		db	24h
loc_1:
		mov	si,offset data_3
loc_2:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_3			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_1
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_2
loc_3:
		mov	ah,9
		mov	dx,offset data_2	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_4
data_4		db	9
data_5		db	0Dh, 0Ah, '$'
data_6		db	20h
		db	0C4h
		db	40 dup (0C4h)
		db	24h
loc_4:
		mov	si,offset data_6
loc_5:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_6			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_4
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_5
loc_6:
		mov	ah,9
		mov	dx,offset data_5	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_7
data_8		db	0Fh
data_9		db	0Dh, 0Ah, '$'
data_10		db	20h
		db	0CDh
                db      4 dup (0CDh)
		db	 10h, 10h
                db      ' THE CRACKSTOP REMOVER 1.2 '
		db	 11h, 11h,0CDh
                db      4 dup (0CDh)
		db	24h
loc_7:
		mov	si,offset data_10
loc_8:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_9			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_8
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_8
loc_9:
		mov	ah,9
		mov	dx,offset data_9	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_10
data_13		db	0Fh
data_14		db	0Dh, 0Ah, '$'
data_15		db	20h
		db	0CDh
		db	40 dup (0CDh)
		db	24h
loc_10:
		mov	si,offset data_15
loc_11:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_12			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_13
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_11
loc_12:
		mov	ah,9
		mov	dx,offset data_14	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_13
data_17		db	0Fh
data_18		db	0Dh, 0Ah, '$'
data_19		dw	2020h, 2020h, 2020h
		db	 20h,0FFh
		db	' Coded by Christoph Gabler'
		db	0FFh
		db	7 dup (0FFh)
		db	24h
loc_13:
		mov	si,offset data_19
loc_14:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_15			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_17
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_14
loc_15:
		mov	ah,9
		mov	dx,offset data_18	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_16
data_21		db	9
data_22		db	0Dh, 0Ah, '$'
data_23		db	20h
		db	0C4h
		db	40 dup (0C4h)
		db	24h
loc_16:
		mov	si,offset data_23
loc_17:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_18			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_21
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_17
loc_18:
		mov	ah,9
		mov	dx,offset data_22	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_19
data_25		db	0Fh
data_26		db	0Dh, 0Ah, '$'
data_27		db	0FFh
		db	24h
loc_19:
		mov	si,offset data_27
loc_20:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_21			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_25
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_20
loc_21:
		mov	ah,9
		mov	dx,offset data_26	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_22
data_28		db	7
data_29		db	0Dh, 0Ah, '$'
data_30         db      ''
                db      'USAGE: CSR.EXE [FILE_TO_UNPACK]'
		db	'$'
loc_22:

		push	cs
		pop	ds
                jmp     short abc_1
abcd_1          db      7
abcd_2          db      0Dh, 0Ah, '$'
abcd_3          dw      4 dup (0FFFFh)
		db	0FFh, 24h
abc_1:
                mov     si,offset abcd_3
abc_2:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
                je      abc_3                   ; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
                mov     bl,abcd_1
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
                jmp     short abc_2
abc_3:
		mov	ah,9
                mov     dx,offset abcd_2        ; ('')
		int	21h			; DOS Services  ah=function 09h
Ret
Image:

code ends
end start
