
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; ICE, the INTEL complex emulator 0.3.4
   ;
   ; tasm /m9 ice.asm
   ; tlink /3 ice
   ;
   ;
   ; Based on IUP by Frank Zago, whole code rewritten, improved and made
   ; as strong as it is nowadays by Jauming Tseng till version 0.3.1.
   ;
   ; 0.3.2 : Christoph Gabler, HS 1.19 COM files entry point searcher improved
   ; 0.3.3 : Christoph Gabler, Mess 1.31 EXE/COM files BT/BTR trick bypassed
   ;                           and crash prevention if IP doesn't change
   ; 0.3.4 : JauMing Tseng, initialize registers as DOS before emulating
   ;
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; MACRO's, used for internal/external stack switching
   ;

   ideal ;>
   locals ;>
   p386
   macro ice_switch_to_internal_stack
           mov [cs:ice_reg._ss], ss
           mov [cs:ice_reg._esp], esp  ; save external stack address
           mov [cs:ice_internal_stack.switch], cs
           mov ss, [cs:ice_internal_stack.switch]
           mov esp, [cs:ice_internal_stack.internal_esp]
                   ; set stack to internal stack address
           endm
   macro ice_switch_to_external_stack
           mov [cs:ice_internal_stack.internal_esp], esp
                                       ; save internal stack offset
           mov ss, [cs:ice_reg._ss]
           mov esp, [cs:ice_reg._esp]  ; set stack to external stack address
           endm
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; STACK
   segment stackers para stack 'stack'
           dw 050h dup('$$') ;>
   ends stackers
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; Segment definition... where all our code/data is stored
   ;
   segment ice para public 'code' use16;>>jmt16
           assume cs:ice, ds:ice, es:nothing, ss:stackers ;>
;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; MACRO's, used for iceunp/iup
   ;
  ;>
;==Macro Clean_Process=======================================================
macro clean_process     endloc
        ;
        ;       define  ;;[_end_main:] as end of program
        ;               ;;[done:]      as end of tsr
        ;
        ;       input   loc: endloc
        ;               ah=4ch ,ds=psp
        ;               al=error level
        ;              (dx=para for ah=31h)
        ;
 ;>
                mov     cx,(offset endloc);p(-100h)
           ;p   mov     di,100h
                xor     di,di ;>es:di<-cs:0,cs!=psp:p
 ;>
                shr     cx,1
                dec cx;!(inc cx) ;> avoid overflow:p
                ;p      cx,7f80h        ;(32640=(65536(64k)-256(0100h))/2)

                mov     bl,0b4h        ;mov ah,?
                mov     bh,ah
                mov     bp,bx
                mov     bl,al           ;bl=al=error level
                cli
                mov si,ds ;>
                mov ss,si
                mov     sp,0100h-10     ;8+2=10
                sti
                xor     si,si           ;di=0
                push    si
                mov     ax,21cdh        ;int 21h
                mov     [ds:si],ax
                or      si,0100h        ;si=(0|100h)=100h  ;PSP;
                sub     si,8            ;2+2+2+2=8
                push ds    ;>cs
                push    si ;>ip
                mov     ax,0abf3h       ;rep stosw ;use cx
                mov     [ds:si],ax
                mov     [ds:si+2],bp
                mov     ax,0d888h       ;mov al,bl
                mov     [ds:si+4],ax
                mov     ax,0c390h       ;nop ;ret
                mov     [ds:si+6],ax
                push    cs;
                pop     es;es=cs
                xor     ax,ax
                cld
                retf ;>
                endm    ;clean_process for .com 4ch, 31h end

   ;>
; Terminate with a return code
macro EXIT ReturnCode
      mov ds,[cs:ice_psp] ;>
      mov ax,[cs:oldpid] ;
      mov [ds:16h],ax    ; restore old parent id ;>
      mov AX, 4Ch*256+ReturnCode
   ;p int 21h ->(21.4c)->[clean_p]
   ;p int 3 ;>debuggy ;p ok ;>
      clean_process TSREnd ;> ;>
      endm
;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; MACRO's, used for int_21h
macro int_21h
        call call_21h ;>
endm int_21h
;>
; Write a string on stdout with int 21h
; Warning: - DS must be correct ;>
;          - AX and DX may change
macro PRINT String ;>
      push ax dx
      mov ax, 0900h
      lea dx, [String]
      int_21h;>
      pop dx ax
      endm

; Write a character on stdout with int 21h
; Warning: - AX and DX may change
macro PRINTCAR Character
      mov ax, 0200h
      mov dl, Character
      int 21h
      endm

; Save the traced program's context ;>
macro ContextSave ;>
      mov [cs:SaveSS], ss
      mov [cs:SaveSP], sp
      mov [cs:SaveBP], bp

      mov [cs:SaveDS], ds
      mov [cs:SaveAX], ax
      mov ax, cs
      mov ds, ax               ; DS = CS

      mov bp, sp
;      mov ax, ss:[bp+4]      ; flags (they are already on stack)
;      mov cs:SaveFG, ax
      mov ax, [ss:bp+2]       ; CS
      mov [SaveCS], ax
      mov ax, [ss:bp]         ; IP
      mov [SaveIP], ax

    ; mov ax, cs
    ; mov ss, ax
    ; lea sp, [TSREnd] ;>

      mov [SaveBX], bx
      mov [SaveCX], cx
      mov [SaveDX], dx
      mov [SaveES], es
      mov [SaveDI], di
      mov [SaveSI], si

      endm

; Restore traced program's context
macro ContextLoad
      mov ax, [cs:SaveAX]
      mov bx, [cs:SaveBX]
      mov cx, [cs:SaveCX]
      mov dx, [cs:SaveDX]
      mov es, [cs:SaveES]
      mov di, [cs:SaveDI]
      mov si, [cs:SaveSI]

      mov ss, [cs:SaveSS]
      mov sp, [cs:SaveSP]
      mov bp, [cs:SaveBP]

      mov ds, [cs:SaveDS]
      endm

; Print an error text and exit
macro ERROR Chaine, ErrorCode ;>
      PRINT TxtError
      PRINT Chaine
      EXIT ErrorCode
      endm

TxtError db 0dh, 0ah, "iCEuNP: $" ;>
;>macro.inc
;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; INCLUDE's, used for files.inc
   ;
; File management

; Read an executable (COM or EXE) file without execute it
; File name is in ProgName
; Give also the parameters
proc ReadExeFile ;> [ds],[es] -> data segment!
      mov ax, 4B01h            ; load without execute
      lea dx, [ProgName]       ; file name
      lea bx, [param_block]    ; parameters block ptr
      mov [word es:bx], 0      ; segment's son environment
      mov [word es:bx+2], offset OptionLine        ; adr ofs paramtres
      mov cx,[ice_psp] ;>
      mov [es:bx+4], cx ;!ds                       ; adr seg paramtres
      mov [word es:bx+6], offset ChaineVide        ; adr ofs FCB1
      mov [es:bx+8], cx ;!ds                       ; adr seg FCB1
      mov [word es:bx+0ah], offset ChaineVide      ; adr ofs FCB2
      mov [es:bx+0ch], cx ;!ds                     ; adr seg FCB2
      int 21h
      jnc ReadOk
      ERROR TxtLoadError, 0
ReadOk:
      ret
endp ReadExeFile

; Change termination address
proc ChangeTermination
      mov ax, 6200h ;>
      int 21h                  ; get son's PSP -> BX
      mov [ParPSP], bx ;>      ; save it for later
      mov es, bx
      push cs
      pop ax                   ; current segment
      mov [es:0ch], ax         ; PSP int 22h seg.
      lea ax, [ReturnProg] ;>
      mov [es:0ah], ax         ; PSP int 22h ofs.
      ret
endp ChangeTermination

; Free unused memory
proc FreeMem
      mov ax, 04A00h
    ; mov bx, offset TSREnd ;> ; compute the number of paragraphs
    ; shr bx, 4                ; IUP really needs
    ; inc bx ;> com method:p
      ;>
      mov bx, offset TSREnd ;> ; compute the number of paragraphs
      shr bx, 4                ; IUP really needs
      inc bx ;> com method:p
      mov cx,cs
      sub cx,[ice_psp] ;> exe method
      add bx,cx
      ;>
      push es ;>
      mov es,[ice_psp] ;> [es] -> [psp]
      int 21h
      pop es ;>
      ret
endp FreeMem

; Free unused memory
proc FreeMem2
      mov ax, 04A00h
    ; mov bx, offset TSREnd ;> ; compute the number of paragraphs
    ; shr bx, 4                ; IUP really needs
    ; inc bx ;> com method:p
      ;>
      mov bx, offset TSREnd ;> ; compute the number of paragraphs
      shr bx, 4                ; IUP really needs
      inc bx ;> com method:p
      mov cx,cs
      sub cx,[ice_psp] ;> exe method
      add bx,cx
      add bx,3 ;> 3 para more for pass2 ;> 1 para is ok
      ;>
      push es ;>
      mov es,[ice_psp] ;> [es] -> [psp]
      int 21h
      pop es ;>
      ret
endp FreeMem2
;>
; Write the body code
proc WriteBody ;>
      mov bx, [NumHandle] ;>
      ;>
    ; push cx
    ; mov dx, offset makeexe_cs ;>
    ; mov cx, 28 ;>
    ; mov ax, 4000h            ; write in file
    ; int 21h
    ; pop cx
      ;>
    ; movzx edx, [ParCode]
    ; mov ecx, [AdrSup] ;>
    ; shl edx, 4               ; transforms paragraph in bytes
    ; sub ecx, edx             ; PSP adress
    ; inc ecx
;>
      mov ecx,[dword ptr ds:dumpSizeLo$667c]
;>
      mov [TailleCodeEcrit], ecx ;>
;>
      push ds ;>

      mov dx, [ParCode] ;>
      mov ds, dx               ; DS:DX is the begining of the
      xor dx, dx               ; program in memory

      ; write 64KB blocs
@@1:
      cmp ecx, 0fff0h
      jbe short @@10           ; if less than 64KB to write
      sub ecx, 0fff0h          ; paragraphs to write
      push ecx
      mov cx, 0fff0h
      mov ax, 4000h            ; write in file
      int_21h
      mov dx, ds               ; inc DS by the
      add dx, 0fffh            ; number of paragraphs
      mov ds, dx               ; written
      xor dx, dx
      pop ecx

      jmp @@1

      ; write the residue
@@10:
      mov ax, 4000h
      int_21h

      pop ds

      ret
endp WriteBody

proc WriteHeader
      ; seek at the begining of the file
      mov ax, 4200h
      mov bx, [NumHandle]
      xor cx, cx
      xor dx, dx
      int 21h

      ; write the header
      mov ax, 04000h
      mov bx, [NumHandle]
      mov cx, 32
      lea dx, [EntNouvFichier]
      int 21h
      ret
endp WriteHeader

; Copy the overlay table
; We use the 512 bytes jump table as buffer. It avoids to allocate some
; buffers elsewhere.
proc WriteOverlay
      ; go to the end of the new file
      mov ax, 4202h
      mov bx, [NumHandle]      ; BX = new file handle
      xor cx, cx
      xor dx, dx
      int 21h

      ; open the old file
      mov ax, 3d00h
      lea dx, [ProgName]
      int 21h                  ; should be correct
      mov [OldHandle], ax

      ; go to the begining of the overlay in the old file
      mov eax, [HeaderSize]
      add eax, [CodeSize]

      mov dx, ax
      shr eax, 16
      mov cx, ax
      mov ax, 4200h
      mov bx, [OldHandle]
      int 21h

      lea dx, [JtOpcode] ;>
@@1:
      mov ax, 3f00h
      mov bx, [OldHandle] ;>
      mov cx, 512              ;  our buffer size ;>
      int 21h

      cmp ax, 0
      je @@2

      mov cx, ax               ; copy only the size read
      mov ax, 4000h
      mov bx, [NumHandle]
      int 21h

      jmp @@1

@@2:
      ; close old file
      mov ax, 3e00h
      mov bx, [OldHandle]
      int 21h

      ret
endp WriteOverlay

proc CloseFile ;>
      mov ax, 3E00h
      mov bx, [NumHandle]
      int_21h

      not [FichierCree] ;>     ; new value should be 0ffffh

      ret
endp CloseFile

proc CreateTempFile ;> 070598
      mov ah,19h ; get (current;default)work drive
      int 21h
      add al,'a'
      mov [BYTE PTR tEmpfile], al ; set work drive '?:\', 0
      mov [BYTE PTR tEmpfile+3], 0; init tEmpfile path for sure!!
      xor cx, cx ;>file attribute
      mov dx, OFFSET tEmpfile
      mov ah, 5ah ;> 070598       ; create temp file, name @ds:dx ;
      int 21h                     ; cx=file attribute bits        ;
      jnc CreateOK ;>
      ERROR TxtCantCreate, 1
CreateOK: ;>
      mov [NumHandle], ax ;>
      ret ;>
endp CreateTempFile

proc CreateTempFile2 ;> 070598
      mov ah,19h ; get (current;default)work drive
      int 21h
      add al,'a'
      mov [BYTE PTR tEmpfile2], al ; set work drive '?:\', 0
      mov [BYTE PTR tEmpfile2+3], 0; init tEmpfile path for sure!!
      xor cx, cx ;>file attribute
      mov dx, OFFSET tEmpfile2
      mov ah, 5ah ;> 070598       ; create temp file, name @ds:dx ;
      int 21h                     ; cx=file attribute bits        ;
      jnc CreateOK2 ;>
      ERROR TxtCantCreate, 1
CreateOK2: ;>
      mov [NumHandle], ax ;>
      ret ;>
endp CreateTempFile2

;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; MACRO's, used for int_29h
macro int_29h
        call call_29h ;>
endm int_29h
   ;
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; INCLUDE's, used for numbers.inc
   ;
; Write numbers to stdout

; WriteHexa4   : Write a 4 bits hexadecimal number (in AL)
; WriteHexa8   : Write a 8 bits hexadecimal number (in AL)
; WriteHexa16  : Write a 16 bits hexadecimal number (in AX)
; WriteDecimal : Write a 32 bits decimal number (in EAX)

proc WriteHexa4
      push ax
      push dx

      mov ah, 02h              ; write a character
      xchg al, dl
      cmp dl, 10               ; number or letter ?
      jae @@1
      add dl, '0'
      jmp @@2
@@1:  add dl, 'A'-10
@@2:
  ;>  int 21h ;> method1 ;>
      mov al,dl ;} method2 ;> avoid dos-re-entry
      int_29h   ;}

      pop dx
      pop ax
      ret
endp WriteHexa4

proc WriteHexa8
      push ax

      push ax
      shr al, 4                ; 4 higher bits
      call WriteHexa4
      pop ax
      and al, 00fh             ; 4 lower bits
      call WriteHexa4

      pop ax
      ret
endp WriteHexa8


proc WriteHexa16
      push ax

      push ax                  ; get a copy of ax
      xchg al, ah              ; higher byte
      call WriteHexa8
      pop ax
      call WriteHexa8          ; lower byte

      pop ax
      ret
endp WriteHexa16

proc WriteDecimal
      push eax
      push ebx
      push ecx
      push edx

      test eax, 10000000000000000000000000000000b   ; negative
      je @@3
      neg eax          ; reverse the number
      push eax
      mov ah, 02h
      mov dl, '-'      ; print a '-'
      int 21h
      pop eax

@@3:
      mov ebx, 10
      xor cx, cx

@@1:  xor edx, edx
      div ebx        ; (exd:eax) / 10
      push dx        ; the lowest decimal number
      inc cx
      or eax, eax    ; eax=0 ?
      jne @@1

      mov ah, 02h
@@2:  pop dx         ; number in dans dl
      add dl, '0'
      int 21h
      dec cx
      or cx, cx
      jne @@2

      pop edx
      pop ecx
      pop ebx
      pop eax

      ret
endp WriteDecimal
;>numbers.inc
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; INCLUDE's, used for fileanal.inc
   ;
; File analysis
; *********
; Analysis of the entry file
; Return=0 on error (an error message is printed)
;        1 if a COM file ;>
;        2 if an EXE file ;>
; *********

proc AnalyseFichier ;>
      ; open the file
      mov ax, 3d00h            ; open in read only
      lea dx, [ProgName]       ; parameters offset adress
      int 21h
      jnc @@2

      ERROR TxtLoadError, 1    ; can't load file

@@2:  mov bx, ax               ; handle

      ; get file's size
      mov ax, 4202h
      xor cx, cx
      xor dx, dx
      int 21h
      jnc @@3

      ERROR TxtInternalError, 1

@@3:  xchg eax, edx
      shl eax, 16
      xchg ax, dx
      mov [FileSize], eax

      ; read the first 28 bytes of the file
      ; (the header if an exe file)
      mov ax, 4200h
      xor cx, cx
      xor dx, dx
      int 21h                  ; position 0

      mov ax, 3f00h
      mov cx, 28
      lea dx, [EntAncFichier.Identificateur]
      int 21h

      ; close the file
      mov cx, ax               ; store the number of bytes read
      mov ax, 3e00h
      int 21h

      PRINT FileSizeTxt
      mov eax, [FileSize]
      call WriteDecimal
      PRINT CarReturn

      PRINT TxtOldFileStruct   ; "Structure : "

      ; search for an exe identificator
      mov ax, [EntAncFichier.Identificateur]
      cmp ax, 'ZM'       ; MZ
      je short AncEXE
      cmp ax, 'MZ'       ; ZM
      je short AncEXE

      ; it's not an exe, so we check for file size
      mov eax, [FileSize]
      cmp eax, 0ff00h
      ja short AncDonnees      ; file is over ff00h bytes

      PRINT TxtCOMFileStruct
      mov ax, 1 ;>             ; COM file
      ret

AncDonnees:
      ; so it is some datas
      PRINT StructureDonneesTxt
      xor ax, ax               ; not an executable
      ret

AncEXE:
      ; so it is an exe file
      PRINT TxtEXEFileStruct

      mov eax, [FileSize]
      cmp eax, 28              ; header size
      jae short @@1

      ; size is not good, so it's a data file with an exe file signature
      PRINT CarReturn
      PRINT TxtInvalidFormat
      xor ax, ax
      ret

@@1:  ; write infos on standard output

      PRINTCAR '('
      PRINT TailleHeaderTxt
      movzx eax, [EntAncFichier.TailleHeader]
      shl eax, 4               ; eax=eax*16
      mov ebx, eax
      mov [HeaderSize], eax ;>
      call WriteDecimal

      PRINT TailleCodeTxt
      movzx eax, [EntAncFichier.LongFicDiv]
      shl eax, 9               ; EAX=EAX*512
      movzx ecx, [EntAncFichier.LongFicMod]
      cmp ecx, 0
      je @@4
      add eax, ecx
      sub eax, 512
@@4:
      mov ecx, eax             ; store HeaderSize+CodeSize ;>
      sub eax, ebx

      mov [CodeSize], eax ;>
      call WriteDecimal

      PRINT TailleOverlayTxt
      mov eax, [FileSize]
      sub eax, ecx
      mov [OverlaySize], eax ;>
      call WriteDecimal

      PRINTCAR ')'
      PRINT CarReturn

      mov ax, 2 ;>             ; EXE file

      ret

endp AnalyseFichier ;>
;>fileanal.inc
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; INCLUDE's, used for options.inc
   ;
;*******
; array of options on command line
;*******
struc OptEntry
  OptLen dw 0                  ; length of option
  OptName db 5 dup (0)         ; name of option (length can be increased)
  OptHandler dw 0              ; handler to call
ends OptEntry

;OptArray OptEntry <5, "mish1", install_mish1> ;>
;         OptEntry <5, "mish2", install_mish2> ;>
OptArray OptEntry <5, "blind", blind_csip> ;>
         OptEntry <0, 0, 0>             ; no more options

proc blind_csip
        mov [cs:blind],1 ;> enable
        ret
blind db 0 ;> init0
endp blind_csip

; *******
; Analysis of command line parameters
; Program name is in NomProg
; and its parameters are in ParamsProg
; *******
proc ParseOptions ;> parseOptions:
      push bx
      push si
      push di

      cld

      mov si, 81h              ; ds:si points to the commmand line ;>

      ; search for options
@@1:
      push ds ;>
      mov ds,[ice_psp] ;>
      lodsb
      pop ds ;>
      cmp al, ' '
      je @@1
      cmp al, 09h
      je @@1
      cmp al, '-'
      jne @@4
      call AnOption
      jmp @@1
@@4:  cmp al, '/'
      jne @@5
      call AnOption
      jmp @@1
@@5:  cmp al, 0dh
      je EndOptions

      ; get the file name
      lea di, [ProgName] ;> [es] -> data segment!
@@2:  stosb ;>                 ; store
      push ds ;>
      mov ds,[ice_psp] ;>
      lodsb
      pop ds ;>
      cmp al, 0dh
      je EndOptions
      cmp al, ' '
      je @@3
      cmp al, 09h
      jne @@2

      ; get options for program to load
      lea di, [OptionLine]
@@3:  stosb
      push ds ;>
      mov ds,[ice_psp] ;>
      lodsb
      pop ds ;>
      cmp al, 0dh
      jne @@3

EndOptions:
      pop di
      pop si
      pop bx
      ret

endp ParseOptions

; search for the option and call the handler
proc AnOption
      lea bx, [OptArray]
      push ds;
      pop es ;es=ds=data segment!
      cld

@@1:  mov cx, [(OptEntry bx).OptLen]
      or cx, cx
      je UnknowOpt

      push si
      lea di, [(OptEntry bx).OptName]
      push ds ;>
      mov ds,[ice_psp] ;> [ds] -> [psp]
      repe cmpsb
      pop ds ;>
      je FoundOPt

      pop si
      add bx, size OptEntry
      jmp @@1

FoundOpt:
      pop ax                   ; restore stack (si was pushed)
      mov di, [(OptEntry bx).OptHandler]
      call di
      ret

UnknowOpt:
      ERROR TxtInvalidOption, 1          ; no option yet
endp AnOption

TxtInvalidOption db "Invalid option$"
;>options.inc
;> --
;)
;-------------------------------------
;        : $$prinT: input ds:dx,4/4
;-------------------------------------
$$prinT_cx dw ? ;>
$$prinT_color db 3eh ;>default ;> ; yellow on green:3eh,1Bh;white on blue
PROC $$print near ;ideal
        push    ax bx cx si
        ;
        mov     bh, 0
        mov     si, dx
        ;
        mov     ax,[ds:si-2] ;ideal
        mov     [cs:$$prinT_cx],ax ;>
        ;
        mov     cx, 1 ;>for i10.ah9
@@print_loop:
        mov     bl, [cs:$$prinT_color];3eh ;>; yellow on green
;)
        mov     ah, 9
        ;
        mov     al, [si] ;> lodsw
        inc     si       ;>
;)
        push    cx
        mov     cl,[byte ptr cs:$$prinT_cx] ;>>
        rol     al,cl ;) sclar type:p
        pop     cx
        xor     al,[byte ptr cs:$$prinT_cx] ;>
        sub     al,[byte ptr cs:$$prinT_cx] ;>
        dec     [cs:$$prinT_cx] ;>
;)
        cmp     al, '$' ;> chk after decode:p
        je      SHORT @@end_print
;)
        cmp     al, ' ' ;> chk after decode:p
        jb      SHORT @@print_tty
;)
        int     10h
        inc     dl
        mov     ah, 2
        int     10h
;)
        jmp     SHORT @@print_loop
@@print_tty:
        mov     ah, 0eh
        int     10h
;)
        cmp     al, 10
        jne     @@print_loop
        ;
        mov     al, ' '
        int     10h
        ;
        push    cx
        mov     ah, 3
        int     10h
        pop     cx
        ;
        jmp     SHORT @@print_loop
@@end_print:
        pop     si cx bx ax
        retn
ENDP $$print

setup_registers:
        xor ax, ax
        xor dx, dx
        ;>
        mov cx,[word ptr ds:FileSize]
        mov bx,[word ptr ds:FileSize+2]
        cmp [filetype],1;1=com,2=exe
        je bxcxok
        mov cx,[word ptr ds:CodeSize]
        mov bx,[word ptr ds:CodeSize+2]
bxcxok:
        mov di,[ds:real_sp]
        mov si,[ds:ice_reg._ip]
        ;>
        mov [ds:ice_reg._si],si
        mov [ds:ice_reg._di],di
        mov [ds:ice_reg._bx],bx
        mov [ds:ice_reg._cx],cx
        ;>
        PRINT entry_si
        mov ax,[ds:ice_reg._si]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        PRINT entry_di
        mov ax,[ds:ice_reg._di]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        PRINT entry_bxcx
        mov ax,[ds:ice_reg._bx]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,':'
        mov ah,2
        int 21h
        mov ax,[ds:ice_reg._cx]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,13
        mov ah,2
        int 21h
        mov dl,10
        int 21h
        ;>
        ret
;> --
   proc ice_setup near ;> iceunp: ice_setup:
;>
        push cs;
        pop ds ;ds=cs
        mov [ice_psp],es ;> save [psp], [ds] -> data segment!
        mov ax,[es:16h] ;071198
        mov [oldpid],ax ;
        mov [es:16h],es ;> fake parent id ;> for trap&fse
        push cs;
        pop es ;es=cs , after (save psp) ;>
 ;>
; *********
; Initialization of IUP
; *********
 ;>
      call init_21h ;> a must b4 (print)
 ;p   PRINT DebutProgTxt ;> logo, [ds] -> data segment!
      lea dx,[DebutProgTxt] ;ideal;> logo, [ds] -> data segment!
      call $$print

      ; read parameters ;> input [ds] = [psp]
      push ds ;>
      mov ds,[ice_psp] ;> [ds] -> [psp]!
      mov cl, [ds:80h] ;>      ; parameters on command line's length $$$
      pop ds ;>
      xor ch, ch
      test cx, cx              ; empty command line ?
      jz NoOptions ;>
      ; ([ds] -> [psp]!) [es]-> data segment!
      call ParseOptions        ; parameters analysis

      cmp [ProgName], 0
      jz NoOptions
;>
      ; analyse the entry file
      PRINT Stage1Txt
      call AnalyseFichier

      or ax, ax ;> 0=error,1=com,2=exe
      jne @@1

      ERROR TxtCantProceed, 1
@@1:
      mov [fileType],al
      mov [oldFileType],al
      ;>
      mov eax,cr0
      test eax,1
      jz real_mode
      ERROR TxtCantPmode, 1
real_mode: ;>
      ;>
      call CreateTempFile ;> 070598
;>
      ; free unused memory to be able to load another program
      ; some variables and procedures are no longer available
      call FreeMem
;>
      call ice$SignMem$1b6d ;>
;>
      call ReadExeFile
      call ChangeTermination

      ; compute the starting code paragraph
      mov ax, [ParPSP] ;>      ; PSP
      add ax, 10h              ; start of the code
      mov [ParCode], ax ;>

      PRINT Stage2Txt ;>
;>
      ; initialize some datas
      movzx eax, [ParCode]
      shl eax, 4
      add eax, [CodeSize]
      mov [AdrSup], eax

      ; get son's segment
      push cs;
      pop es ;es=cs=data segment!
      lea bx, [param_block]    ; ptr on parameter block

      ; set the registers for the program
        xor ecx,ecx ;>
        mov cx, [word es:bx+0Eh]           ; SP
        mov ax, [word es:bx+10h]           ; SS
        ;>
        cmp [fileType],2;1=com,2=exe
        je cxok
        mov cx,0fffeh
cxok:
        ;>
        mov [ds:ice_reg._ss], ax ;>
        mov [ds:ice_reg._esp], ecx ;>
        ;>
        push es bx
        mov es,ax
        mov bx,cx
        mov [word ptr es:bx],0 ;> push com:0 ;>
        pop bx es
        mov [ds:real_ss],ax
        mov [ds:real_sp],cx
        ;>
;>
      movzx ecx, [word es:bx+12h]    ; IP in cx!
      movzx eax, [word es:bx+14h]    ; CS in ax!
         mov [ds:ice_reg._cs], ax ;>
         mov [ds:ice_reg._ip], cx ;>
         mov [ds:check_cs], ax ;>
      shl eax, 4
      add eax, ecx
      mov [RoutBegin], eax

      ; to run the program, some registers must have some specifc values.
      ; note that this particularity is used in IUP to know when the
      ; decompression code ends.
      mov ax, [ParPSP]
        mov [ds:ice_reg._ds], ax ;> a must
        mov [ds:ice_reg._es], ax ;> a must
        mov [ds:check_psp],ax
        ;>
        mov [ds:check_psp0],ax ;> pass1's psp
        ;>
        call init_29h ;> a must b4 1st (call writeHexaXX)
        ;>
 ;p     call setOwnInt_611 ;> tmpoff:p
        ;>
        mov [byte ptr ds:real_stack+1],13
        PRINT real_stack
        mov [byte ptr ds:real_stack+1],10 ;>
        mov ax,[ds:real_ss]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,':'
        mov ah,2
        int 21h
        mov ax,[ds:real_sp]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,10
        mov ah,2
        int 21h
        ;>
        PRINT info_psp ;>
        mov ax,[ds:check_psp]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,13
        mov ah,2
        int 21h
        ;>
        call    setup_registers
        ;>
        ; launch the son program
        ;>
        in al,21h
        mov [port21],al
        in al,0a1h
        mov [porta1],al
        mov al,0ffh
    ;p  out 21h,al  ;tmp
    ;p  out 0a1h,al ;   off
 ;>
;> ice.setup: ;>
           push cs;
           pop ss ;ss=cs
           mov esp, (offset ice_internal_stack.top)
    
           cli ;>
           pushfd
           pop [dword ds:ice_reg._eflags]
           and [byte high word ds:ice_reg._flags], 11111100b
    
           jmp ice_dispatch
;> ;>
NoOptions: ;>
      PRINT UsageTxt
      EXIT 1 ;>
;>
ReturnProg: ;> ice_return:

      ; When the program terminates, it returns here.
      mov ax, cs;
      mov ds, ax;ds=cs
;>
        mov al,[port21]
        out 21h,al
        mov al,[porta1]
        out 0a1h,al
        ;> restore int's
        lidt [fword ptr cs:intDesTab_edc] ; Load int des(description)
;>
        PRINT real_entry ;>
        mov ax,[ds:real_cs]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,':'
        mov ah,2
        int_21h
        mov ax,[ds:real_ip]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        PRINT real_stack ;>
        mov ax,[ds:real_ss]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,':'
        mov ah,2
        int_21h
        mov ax,[ds:real_sp]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
;>
        call ice$dumps$17ea ;> [get image length]!
        PRINT real_size ;>
        mov ax,[dumpSizeLo$667c]
        mov dx,[dumpSizeHi$667e]
        mov bh,0
        call outdec32 ;>
        mov dl,13
        mov ah,2
        int_21h
        mov dl,10
        int_21h
        ;>
        call writeBody ;>!
        call closeFile ;>!
        PRINT writeBody$;>
;>
     ;cmp [FichierCree], 0
     ;jne @@19 ;>              ; no decompression code was found
      cmp [ds:real_found],1
      je @@19 ;>
      ;; no decompression code was found
      ; delete temporary file
      mov ax, 4100h
      lea dx, [TempFile] ;> pass1 ;>070598
      int 21h
;>
      ERROR TxtErrorInProg, 1

@@19:
      ; restore environment
      mov ax, cs;
      mov ds, ax;ds=cs
      mov es, ax;es=cs=ds
;>
ice_setup2: ;>
        ;>
        cmp [fileType],1 ;>1=com,2=exe
        je updateCom ;>
        ;>
        cmp [byte ptr ds:TempCount],'2'
        je ice_setup3 ;>
        ;>
        mov [FichierCree], 0  ;> re-init flag's ;>
        mov [ds:real_found], 0 ;> re-init flag's ;> ;>
        ;))
        inc [byte ptr ds:TempCount] ;> pass2 ;> 070598
        ;
    ;p  push es         ;071198tmp off
    ;p  mov es,[ice_psp];
    ;p  mov [es:16h],es ;> fake parent id ;> for trap
    ;p  pop es          ;
        ;>
        mov al,[oldFileType];
        mov [fileType],al   ;re-init flag's if exe2com ;>
        ;>
        mov [entry_flag],-1 ;> re-init flag's if exe2com
      ;>
      call CreateTempFile2 ;> pass2 ;> 070598
        ;>
      ; free unused memory to be able to load another program
      ; some variables and procedures are no longer available
      call FreeMem2 ;>
        ;>
      call ice$SignMem$1b6d ;>
        ;>
      call ReadExeFile
      call ChangeTermination

      ; compute the starting code paragraph
      mov ax, [ParPSP] ;>      ; PSP
      add ax, 10h              ; start of the code
      mov [ParCode], ax ;>

      PRINT Stage3Txt ;>
        ;>
      ; initialize some datas
      movzx eax, [ParCode]
      shl eax, 4
      add eax, [CodeSize]
      mov [AdrSup], eax

      ; get son's segment
      push cs;
      pop es ;es=cs=data segment!
      lea bx, [param_block]    ; ptr on parameter block

      ; set the registers for the program
      xor ecx,ecx ;>
      mov cx, [word es:bx+0Eh]           ; SP
      mov ax, [word es:bx+10h]           ; SS
         mov [ds:ice_reg._ss], ax ;>
         mov [ds:ice_reg._esp], ecx ;>
        ;>
      movzx ecx, [word es:bx+12h]    ; IP in cx!
      movzx eax, [word es:bx+14h]    ; CS in ax!
         mov [ds:ice_reg._cs], ax ;>
         mov [ds:ice_reg._ip], cx ;>
         mov [ds:check_cs], ax ;>
      shl eax, 4
      add eax, ecx
      mov [RoutBegin], eax

      ; to run the program, some registers must have some specifc values.
      ; note that this particularity is used in IceUnP to know when the
      ; decompression code ends.
      mov ax, [ParPSP]
        mov [ds:ice_reg._ds], ax ;> a must
        mov [ds:ice_reg._es], ax ;> a must
        mov [ds:check_psp],ax
;>
        PRINT info_psp ;>
        mov ax,[ds:check_psp]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov dl,13
        mov ah,2
        int 21h
        ;>
        call    setup_registers
        ;>
        ; launch the son program
        ;>
        in al,21h
        mov [port21],al
        in al,0a1h
        mov [porta1],al
        mov al,0ffh
    ;p  out 21h,al  ; tmp
    ;p  out 0a1h,al ;    off
 ;>
;> ice.setup:
           push cs;
           pop ss ;ss=cs
           mov esp, (offset ice_internal_stack.top)
    
           cli ;>
           pushfd
           pop [dword ds:ice_reg._eflags]
           and [byte high word ds:ice_reg._flags], 11111100b
    
           jmp ice_dispatch
ice_setup3: ;>
        call _updateDump ;>
        jmp renameOk ;>
updateCom:
        ;>
        PRINT write_com
        ;>
      ; erase old file
      mov ax, 4100h
      lea dx, [unpacked$com];![ProgName]
      int 21h
      jnc DeleteOK
   ;> ERROR TxtCantDelete, 1

DeleteOK:
      mov ax, ds;
      mov es, ax;es=ds
      mov ax, 5600h
      lea dx, [TempFile] ;> pass1 ;>070598
      lea di, [unpacked$com];![ProgName]
      int 21h
      jnc RenameOK1
      ERROR TxtCantRename, 1
renameOk1:
    ;p  PRINT finished$
      lea dx,[finished$]
      call $$print
RenameOK: ;>

      EXIT 00
;>
   endp ice_setup
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; ICE Dispatcher
   ;
   proc ice_tf_handler near ;>
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           mov ah, 1 ;>
           call ice_int_x ;> int1
           jmp ice_tf_handled
   endp ice_tf_handler
    
   ice_address_removal_process:
           mov [ds:ice_address_override], al
           jmp ice_removal_jump
    
   ice_operand_removal_process:
           mov [ds:ice_operand_override], al
           jmp ice_removal_jump        ; repeat override removal process
    
   ice_repeat_removal_process:
           mov [ds:ice_repeat_override], bl
           jmp ice_removal_jump        ; repeat override removal process
    
   ice_segment_removal_process:
           mov [ds:ice_segment_override], bl
    
   ice_removal_jump:
           inc [ds:ice_reg._ip]        ; increment IP
           jmp ice_segment_removal     ; repeat override removal process
    
   proc ice_dispatch near ;> ......... ; .................................
   ;>
           push ax ;>
           mov ax,[ds:ice_reg._ip]
           cmp ax,offset ReturnProg ;>
           pop ax ;>
           jne ice_check ;>
           ;>
           push ax ;>
           mov ax,cs
           cmp ax,[ds:ice_reg._cs]
           pop ax ;>
           jne ice_check ;>
           ;>
           jmp ReturnProg ;>
   ice_check: ;> ;>
           cmp [ds:real_found],1 ;>
           jne ice_check5
           ;>
       ;p  mov ds,[cs:ice_psp];>
       ;p  mov ax,[cs:oldpid] ;
       ;p  mov [ds:16h],ax    ; restore old parent id ;>
           ;tmp off
           mov ax,4c00h;} -> int22
           int_21h ;>  ;}
ice_check5: ;>
;>
        cmp [cs:blind],1
        je bypass_csip$
;
        push ax
        mov ax,[ds:ice_reg._cs]
        cmp ax,0a000h ;>
        pop ax
        jae bypass_csip$ ;> tmp on :q
        ;>
;
        push ax dx
        mov ax,[ds:ice_reg._cs]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov al,':'
        int_29h   ; ;> avoid dos-re-entry
        mov ax,[ds:ice_reg._ip]
        call WriteHexa16  ; Write a 16 bits hexadecimal number (in AX)
        mov al,13
        int_29h   ; ;> avoid dos-re-entry
        pop dx ax
bypass_csip$:
        ;>
        ;>
        cmp [fileType],2
        je analyse_exe
;> com check start
analyse_com: ;> ................................
        cmp [ds:ice_reg._ip],100h
        jne ice_continue2 ;>

; HS 1.19 .COM files improval (lame but in order to keep it working with
; other .com encryptors changed since 0.3.3 done via passive bypassing.
push es
mov es, [ds:ice_reg._cs]
cmp [byte ptr es:100h], 0CFh
je ice_cont2
cmp [byte ptr es:100h], 0F9h
je ice_cont2
cmp [byte ptr es:101h], 0CFh
je ice_cont2
cmp [byte ptr es:102h], 0CFh
je ice_cont2
cmp [byte ptr es:103h], 0CFh
je ice_cont2
cmp [byte ptr es:104h], 0CFh
je ice_cont2
jmp nothscom
ice_cont2:
pop es
jmp ice_continue2
nothscom:
pop es

        ;> [ice:ip]==100h
        push ax
        mov ax, [ds:ice_reg._cs]
        cmp ax, [ds:check_psp]
        pop ax
        jne ice_continue2 ;>
        ;> [ice:cs]==psp
        inc [entry_flag]
        cmp [entry_flag],0
        je ice_continue2 ;> bypass 1st time match
        ;>
        ;>more check for rcmild ;> (fake jmp to psp:100h)
        ;>9x;c3
        push bx
        mov bx,100h
        ;>
rcmild10xh:
        push es ;>
        mov es,[ds:ice_reg._cs]
        cmp [byte ptr es:bx],0c3h
        pop es
        je chk_rcmild9x
        inc bx;101
        cmp bx,106h
        je rcmild106h
        jmp short rcmild10xh
rcmild106h:
        jmp no_rcmild9xc3
chk_rcmild9x:
        push cx
        mov cx,bx
        sub cx,100h
        or cx,cx
        jz is_rcmild9xc3
scan_rcmild9x:
        dec bx
        push es ax;>
        mov es,[ds:ice_reg._cs]
        mov al,[byte ptr es:bx]
        and al,0f0h
        cmp al,90h
        pop ax es
        jne no_rcmild9x
        loop scan_rcmild9x
is_rcmild9xc3:
        pop cx
        pop bx
        jmp ice_continue2 ;>
no_rcmild9x:
        pop cx
no_rcmild9xc3: ;>
        pop bx
        ;>
           ;>more check for mess108a ;> (fake jmp to psp:100h)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [word ptr es:100h],0e3ffh ;> (jmp bx) ;>mess108a ;>
           pop es
           jne no_mess108a2
           jmp ice_continue2 ;>
no_mess108a2: ;>
        ;>
           ;>more check for jmt-cp5 ;> (fake jmp to psp:100h)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:100h],0c3h ;> (ret) ;>jmt-cp5 ;>
           pop es
           jne no_jmt_cp5
           jmp ice_continue2 ;>
no_jmt_cp5: ;>
        ;>
           ;>more check for com-prot ;> (fake jmp to psp:100h)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:100h],0cbh ;> (retf) ;>com-prot ;>
           pop es
           jne no_com_prot
           jmp ice_continue2 ;>
no_com_prot: ;>
        ;>
           ;>more check for xcomor099f ;> (fake jmp to psp:100h)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [word ptr es:100h],019ebh ;> (jmps) ;>xcomor099f ;>
           pop es
           jne no_xcomor_099f
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:11bh],0e8h ;> (call) ;>xcomor099f ;>
           pop es
           jne no_xcomor_099f
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:11eh],024h ;> ('$') ;>xcomor099f ;>
           pop es
           jne no_xcomor_099f
           jmp ice_continue2 ;>
no_xcomor_099f: ;>
        ;>
           ;>more check for uscc13 ;> (fake jmp to psp:100h,layer2)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:100h],0e9h ;> (jmps) ;>uscc13 ;>
           pop es
           jne no_uscc13
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,103h
           add bx,[word ptr es:101h]
           cmp [word ptr es:bx+3],1c30h ;> (xor [si],bl) ;>uscc13 ;>
           pop bx es
           jne no_uscc13
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,103h
           add bx,[word ptr es:101h]
           cmp [word ptr es:bx+6],0fbe2h ;> (loop) ;>uscc13 ;>
           pop bx es
           jne no_uscc13
           jmp ice_continue2 ;>
no_uscc13: ;>
        ;>
        push ax
        mov ax,[ds:ice_reg._cs]
        mov [ds:real_cs],ax
        mov ax,[ds:ice_reg._ip]
        mov [ds:real_ip],ax
        mov ax,[ds:ice_reg._ss]
        mov [ds:real_ss],ax
        mov ax,[ds:ice_reg._sp]
        mov [ds:real_sp],ax
        pop ax
        mov [ds:real_found],1 ;>
ice_continue2: ;> ............................

           ;>more check for SPaCeMAKER ;> (exe2com+compression)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0afh],0cbh ;> (retf) ;>SPaCeMAKER ;>
           pop es
           jne no_spcmaker
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0aeh],051h ;> (push cx:ip) ;>SPaCeMAKER ;>
           pop es
           jne no_spcmaker
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0adh],016h ;> (push ss:cs) ;>SPaCeMAKER ;>
           pop es
           jne no_spcmaker
           mov [fileType],2 ;> 1=com,2=exe ;>
           jmp ice_continue0 ;> update check_cs
no_spcmaker: ;>

           ;>more check for mess108a ;> (int1 trix with push ss/pop ss/loop)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx],0ff80h ;> (cmp bh,) ;>mess108a ;>
           pop bx es
           jne no_mess108a
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx+2],008h ;> (8) ;>mess108a ;>
           pop bx es
           jne no_mess108a
           push es bx ;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx+3],0850fh ;> (jnz near) ;>mess108a ;>
           pop bx es
           jne no_mess108a
           add [ds:ice_reg._ip],(366h-35fh)
no_mess108a: ;>

           ;>more check for xcomor099f ;> (pre-fetch trix)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx],50h ;> (push ax) ;>xcomor099f ;>
           pop bx es
           jne no_xcomor099f
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx+1],009b4h ;> (mov ah,9) ;>xcomor099f ;>
           pop bx es
           jne no_xcomor099f
           push es bx ;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx+3],021cdh ;> (int 21h) ;>xcomor099f ;>
           pop bx es
           jne no_xcomor099f
           push es bx ;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx+5],0e587h ;> (xchg bp,sp) ;>xcomor099f ;>
           pop bx es
           jne no_xcomor099f
           inc [ds:ice_reg._ip] ;> bypass pre-fetch trix ;>
no_xcomor099f: ;>

           ;>more check for jmt-cp5 ;> (64<-ad)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx],064e6h ;> (out 64,al) ;>jmt-cp5 ;>
           pop bx es
           jne l1233
           add [ds:ice_reg._ip],2
l1233: ;> ;>

           ;>more check for fds-cp4a ;> (out dx,ax)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx],0efh ;> (out dx,ax) ;>fds-cp4a ;>
           pop bx es
           jne l1266
           inc [ds:ice_reg._ip] ;>
l1266: ;> ;>

           ;>more check for fds-cp4a ;> (outsb)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx],06eh ;> (outsb) ;>fds-cp4a ;>
           pop bx es
           jne l1276
           inc [ds:ice_reg._ip] ;>
l1276: ;> ;>

;icebuggy(ecx,cx0,ecx!0,jcxz)!:p
           ;>more check for com-prot ;> (outsb)
           push es bx;>
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx],0e367h ;> (67h:jcxz) ;>com-prot ;>
           pop bx es
           jne l1545
           push eax
           mov eax,[ds:ice_reg._ecx]
           or eax,eax
           pop eax
           jz l1545
           add [ds:ice_reg._ip],3 ;> 67 e3 08; 67h:jcxz @+08
l1545: ;> ;>

        ;>
        cmp [ds:ice_reg._ip],32bh ;> weird:p
        jb l1234 ;>
        ;> [ice:ip]==100h
        push ax
        mov ax, [ds:ice_reg._cs]
        cmp ax, [ds:check_psp]
        pop ax
        jne l1234 ;>
        push ax
        mov ah,0
     ;p int 16h
        pop ax
l1234:
        ;>
        jmp ice_continue1
;> exe check start

ice_check1 db 0,0
icecount db 0,0
analyse_exe: ;> ...........................

; Below follow all Mess 1.31 fixes done by Christoph

push bx es
mov es,[ds:ice_reg._cs]
mov bx,[ds:ice_reg._ip]
cmp [dword ptr es:bx], 0F0BA0F66h     ; BTR trick
pop es bx
jne bypass_1
add [ds:ice_reg._ip], 12h             ; bypass
jmp ice_continue0

bypass_1:
push bx es
mov es,[ds:ice_reg._cs]
mov bx,[ds:ice_reg._ip]
cmp [dword ptr es:bx], 0B8661075h     ; flag trick, stability bypass
pop es bx
jne bypass_2
add [ds:ice_reg._ip], 12h             ; bypass
jmp ice_continue0

bypass_2:
push bx es
mov es,[ds:ice_reg._cs]
mov bx,[ds:ice_reg._ip]
cmp [dword ptr es:bx],0FE55840Fh      ;>not needed, stability bypass, direct
je bypass_trick1
cmp [dword ptr es:bx],0FE0E840Fh      ;
je bypass_trick1
cmp [dword ptr es:bx],0FDC2820Fh      ;
je bypass_trick1
pop es bx
jmp bypass_3

bypass_trick1:
pop es bx
Add [ds:ice_reg._ip], 4               ; bypass
jmp ice_continue0


bypass_3:

;>Mess 1.31 entrypoint fake bypass
push bx es
mov es,[ds:ice_reg._cs]
mov bx,[ds:ice_reg._ip]
cmp [dword ptr es:bx], 1872403Ch
pop es bx
jne fakenotreached
add [ds:ice_reg._ip], 10h      ; entrypoint fake seeker fix
fakenotreached:

           push ax ;>
           mov ax,[ds:ice_reg._cs]
           cmp ax,[ds:check_cs]
           pop ax
           je ice_continue1 ;>
           ; [ice:cs] changed!
           push ax
           mov ax,[ds:ice_reg._ds]
           cmp ax,[ds:ice_reg._es]
           pop ax
           jne ice_continue0 ;> ;>
           ; [ice:ds]==[ice:es]
           ;>
         ; push ax ;> {method1}
         ; mov ax,[ds:ice_reg._ds]
         ; cmp ax,[ds:check_psp]
         ; pop ax
         ; jne ice_continue0;!1 ;>
           ;>
           push es ;> {method2}
           mov es,[ds:ice_reg._ds]
           cmp [word ptr es:0],20cdh
           pop es
           jne ice_continue0;!1 ;>
           ;> [ice:ds]==[psp]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; xpack section, improve ;;;;;;;;;;;;;;;;;;;;;
           ;>more check for xpack:p, also general improve
           push ax
           mov ax,[ds:ice_reg._cs]
           cmp ax,[ds:check_psp]
           pop ax
           jb ice_continue0;!1 ;> (cs<psp)maybe in i21(low) :p

           ;>more check for xpack:p
           push ax
           mov ax,[ds:ice_reg._cs]
           cmp ax,0a000h ;>
           pop ax
           jae ice_continue0;!1 ;> (cs>=a000)maybe in i21(high) :p
           ;>
;;;;;;;;;;;;;;;;;;;;;;;;;; hackstop section, improve ;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;>more check for hackstop:p, also general improve
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx-2],0cdh ;> (int xx) ;>
           pop es bx
           je ice_continue0 ;> must update [check_cs] for (int xx)
           ;>
;)
;;;;;;;;;;;;;;;;;;;;;;;;;; fse section ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;>more check for fse55s:p
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [byte ptr es:bx],0cbh ;> (retf) ;> fake entry..
           pop es bx
           je ice_continue0 ;>
           ;>
           ;>more check for fse55s,layer#2,ip=1016h
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],01000686h;86060001;xchg [100],al
           pop es bx
           jne no_fse55s
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx+3],0e8fb5801h;*58fbe8*;popax;sti;callnear
           pop es bx
           jne no_fse55s
           jmp ice_continue0 ;>
no_fse55s: ;>
;)
;;;;;;;;;;;;;;;;;;;;;;;;;; hackstop section ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;>more check for hackstop1.11a
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:019h],0cbh ;> (retf) ;>hackstop1.11a
           pop es
           jne no_hackstop111a
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:00eh],053h ;> (push bx:ip) ;>hackstop1.11a
           pop es
           jne no_hackstop111a
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:006h],050h ;> (push ax:cs) ;>hackstop1.11a
           pop es
           jne no_hackstop111a
           jmp ice_continue0 ;>
no_hackstop111a: ;>

           ;>more check for hackstop1.11a2
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:01fh],0cbh ;> (retf) ;>hackstop1.11a2
           pop es
           jne no_hackstop111a2
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:014h],053h ;> (push bx:ip) ;>hackstop1.11a2
           pop es
           jne no_hackstop111a2
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:00ch],050h ;> (push ax:cs) ;>hackstop1.11a2
           pop es
           jne no_hackstop111a2
           jmp ice_continue0 ;>
no_hackstop111a2: ;>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; wwpack section ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           ;>more check for wwpack305p/pu-us
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:54h],0cbh ;> (retf) ;>wwp305b5-p/pu-us
           pop es
           jne no_wwpack305us
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:51h],050h ;> (push ax:ip) ;>wwp305b5-p/pu-us
           pop es
           jne no_wwpack305us
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:4dh],055h ;> (push bp:cs) ;>wwp305b5-p/pu-us
           pop es
           jne no_wwpack305us
           jmp ice_continue0 ;>
no_wwpack305us: ;>

           ;>more check for wwpack305pu-uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0bdh],0cbh ;> (retf) ;>wwp305b5-pu-uh
           pop es
           jne no_wwpack305uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0bah],050h ;> (push ax:ip) ;>wwp305b5-pu-uh
           pop es
           jne no_wwpack305uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0b6h],055h ;> (push bp:cs) ;>wwp305b5-pu-uh
           pop es
           jne no_wwpack305uh
           jmp ice_continue0 ;>
no_wwpack305uh: ;>

           ;>more check for wwpack304a.pu-uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0c5h],0cbh ;> (retf) ;>wwp304a-pu-uh
           pop es
           jne no_wwpack304uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0c2h],050h ;> (push ax:ip) ;>wwp304a-pu-uh
           pop es
           jne no_wwpack304uh
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0beh],055h ;> (push bp:cs) ;>wwp304a-pu-uh
           pop es
           jne no_wwpack304uh
           jmp ice_continue0 ;>
no_wwpack304uh: ;>
;)
           ;>more check for wwpack304a.pu-uh0:(surface)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:047h],0cbh ;> (retf) ;>wwp304a-pu-uh0:(surface)
           pop es
           jne no_wwpack304uh0
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:020h],051h ;> (push cx:ip) ;>wwp304a-pu-uh0
           pop es
           jne no_wwpack304uh0
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:01dh],053h ;> (push bx:cs) ;>wwp304a-pu-uh0
           pop es
           jne no_wwpack304uh0
           jmp ice_continue0 ;>
no_wwpack304uh0: ;>

           ;>more check for wwpack305b5.pu-uh0:(surface)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:04ch],0cbh ;> (retf) ;>wwp305b5-pu-uh0:(surface)
           pop es
           jne no_wwpack305b5uh0
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:023h],051h ;> (push cx:ip) ;>wwp305b5-pu-uh0
           pop es
           jne no_wwpack305b5uh0
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:020h],053h ;> (push bx:cs) ;>wwp305b5-pu-uh0
           pop es
           jne no_wwpack305b5uh0
           jmp ice_continue0 ;>
no_wwpack305b5uh0: ;>

           ;>more check for wwpack304a.pu-uh1:(wwpack.exe)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0b5h],0cbh ;> (retf) ;>wwp304a-pu-uh1:(wwpack.exe)
           pop es
           jne no_wwpack304uh1
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0b2h],050h ;> (push ax:ip) ;>wwp304a-pu-uh1
           pop es
           jne no_wwpack304uh1
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0aeh],055h ;> (push bp:cs) ;>wwp304a-pu-uh1
           pop es
           jne no_wwpack304uh1
           jmp ice_continue0 ;>
no_wwpack304uh1: ;>

           ;>more check for wwpack305b5.pu-uh1:(wwpack.exe)
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0bfh],0cbh ;> (retf) ;>wwp305b5-pu-uh1:(wwpack.exe)
           pop es
           jne no_wwpack305b5uh1
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0bch],050h ;> (push ax:ip) ;>wwp305b5-pu-uh1
           pop es
           jne no_wwpack305b5uh1
           push es ;>
           mov es,[ds:ice_reg._cs]
           cmp [byte ptr es:0b8h],055h ;> (push bp:cs) ;>wwp305b5-pu-uh1
           pop es
           jne no_wwpack305b5uh1
           jmp ice_continue0 ;>
no_wwpack305b5uh1: ;>


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
force_dump:
           push ax
           mov ax,[ds:ice_reg._cs]
           mov [ds:real_cs],ax
           mov ax,[ds:ice_reg._ip]
           mov [ds:real_ip],ax
           mov ax,[ds:ice_reg._ss]
           mov [ds:real_ss],ax
           mov ax,[ds:ice_reg._sp]
           mov [ds:real_sp],ax
           pop ax
           mov [ds:real_found],1
           ;> more check for com2exe
           cmp [ds:real_ip],100h
           jne not_com1242
           push ax
           mov ax,[ds:real_cs]
           cmp ax,[check_psp]
           pop ax
           jne not_com1242
           push ax
           mov ax,[ds:real_ss]
           cmp ax,[check_psp]
           pop ax
           jne not_com1242
           mov [fileType],1 ;>1=com,2=exe
           jmp ice_continue1
not_com1242:
           ;>
           push ax
           mov al,13
           int_29h
           mov al,10
           int_29h
           mov al,'d'
           int_29h
           mov al,'u'
           int_29h
           mov al,'m'
           int_29h
           mov al,'p'
           int_29h
           mov al,[ds:TempCount] ;> 070598
           int_29h
           mov al,13
           int_29h
           pop ax
;
           cmp [cs:force_dump$],1
           je ice_check
;
           jmp short ice_continue1
   ice_continue0: ;> update [check_cs]!
           push ax
           mov ax,[ds:ice_reg._cs]
           mov [ds:check_cs],ax
           pop ax
   ice_continue1: ;>>

; Crash prevention if IP keeps the same. Nice for "cli, jmp $" and similar.
Push Ax
Mov Ax, [ds:ice_reg._ip]
Cmp [word ptr ds:ice_check1], Ax
Je Again1
Mov [word ptr ds:ice_check1], Ax
Pop Ax
Jmp overagain1
Again1:
Pop Ax
Inc [word ptr ds:icecount]
Cmp [word ptr ds:icecount], 0FFFFh
Jne overagain1
PushAD
Call here111
db 0Dh,0Ah,0Dh,0Ah, ' Fault, CPU locked up - aborted',0Dh,0Ah,0Dh,0Ah,'$'
here111: pop Dx
Mov Ah, 9
Int 21h
PopAD

push bx es
mov es,[ds:ice_reg._cs]
mov bx,[ds:ice_reg._ip]
mov [dword ptr es:bx], 21CD4CB4h         ; B44CCD21
pop es bx
overagain1:

           ;>more check for fse55s,fake psp:[c] to [ax]
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],000ca164h;64a10c00;mov ax,fs:[c]
           pop es bx
           jne no_fse55s1625
           add [ds:ice_reg._ip],4
           push ax
           mov ax,[cs:oldpid]
           mov [ds:ice_reg._ax],ax ;fake psp:[c] to [ax]
         ; mov al,10 ;prompt off
         ; int_29h
           pop ax
no_fse55s1625: ;>
           ;>more check for fse55s,fake psp:[16h] to [ax]
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],0016a164h;64a11600;mov ax,fs:[16h]
           pop es bx
           jne no_fse55s1644
           add [ds:ice_reg._ip],4
           push ax
           mov ax,[cs:oldpid]
           mov [ds:ice_reg._ax],ax ;fake psp:[c] to [ax]
         ; mov al,10 ;prompt off
         ; int_29h
           pop ax
no_fse55s1644: ;>
;)
           ;>more check for fse55s,layer#3,bypass cr0 trix0
           ;0f20c0 mov eax,cr0
           ;668bd8 mov ebx,eax
           ;80cb01 or bl,1
           ;0f22c3 mov cr0,ebx -> bypass
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],66c0200fh
           pop es bx
           jne no_fse55s1626
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx+4],0cb80d88bh
           pop es bx
           jne no_fse55s1626
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx+8],0c3220f01h
           pop es bx
           jne no_fse55s1626
           add [ds:ice_reg._ip],12
no_fse55s1626: ;>
;)
           ;>more check for fse55s,layer#3,bypass cr0 trix1
           ;b9ffff mov cx,ffff
           ;0f20c0 mov eax,cr0
           ;3401   xor al,1
           ;fa     cli -> ?
           ;0f22c0 mov cr0,eax -> by pass
           ;0f00c9 str cx -> bypass
           ;3401   xor al,1
           ;0f22c0 mov cr0,eax
           ;41     inc cx
           ;7502   jnz -> ok
           ;ffe1   jmp cx ->(cx=0)
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],0ebc0220fh;0f22c0eb;mov cr0,eax;jmp short
           pop es bx
           jne no_fse55s1913
           add [ds:ice_reg._ip],3
no_fse55s1913: ;>
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],34c9000fh;0f00c934;str cx;xor al,?
           pop es bx
           jne no_fse55s1909
           add [ds:ice_reg._ip],3
           inc [ds:ice_reg._cx]
         ; push ax
         ; mov al,10 ;prompt off
         ; int_29h   ; ;> avoid dos-re-entry
         ; pop ax
no_fse55s1909: ;>
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],0e1ff0275h;7502ffe1;jnz(ok);jmp cx
           pop es bx
           jne no_fse55s1947
           add [ds:ice_reg._ip],4
         ; push ax
         ; mov al,10 ;prompt off
         ; int_29h   ; ;> avoid dos-re-entry
         ; pop ax
no_fse55s1947: ;>
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx],0e3ff0275h;7502ffe3;jne(chk2);jmp bx
           pop es bx
           jne no_fse55s1958
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [dword ptr es:bx-4],0fad163bh;3b16ad0f;cmp dx,[?0fadh] ;?
           pop es bx
           jne no_fse55s1958
           add [ds:ice_reg._ip],2
        ;; push ax
        ;; mov al,10 ;prompt off
        ;; int_29h   ; ;> avoid dos-re-entry
        ;; pop ax ;q
no_fse55s1958: ;>
           push bx es
           mov es,[ds:ice_reg._cs]
           mov bx,[ds:ice_reg._ip]
           cmp [word ptr es:bx],64e6h;e664;out 64h,al
           pop es bx
           jne no_fse55s1971
           add [ds:ice_reg._ip],2
           push ax
           mov al,10 ;prompt off
           int_29h   ; ;> avoid dos-re-entry
           pop ax
           jmp short no_fse55s1971
           ;q
         ; mov [cs:force_dump$],1
         ; jmp force_dump ;q
force_dump$ db 0
no_fse55s1971: ;>
;)
         ; can prompt cs:ip here but maybe must use direct-i/o
   ;>
           test [byte high word ds:ice_reg._flags], 1
           jnz ice_tf_handler          ; check for TF in emulated flags
    
   ice_tf_handled:
           mov ax, [ds:ice_reg._ip]
           mov [ds:ice_original_ip], ax; save address of _IP before prefix removal
                                       ; begins
           xor eax, eax
           mov [ds:ice_overrides], eax ; clear prefix variables
                                       ; (they are 4 one byters, stored in a row,
                                       ; so we use one doubleword move to clear)
   ice_segment_removal:
           les di, [ds:ice_reg._csip]  ; ES:DI=instruction to emulate
    
   ice_breakpoint:
           mov ax, [es:di]             ; get opcode
           mov bx, ax
;>
        mov [ds:check_opcode],al ;>
;>
           and al, 011100111b
           cmp al, 000100110b
           mov al, bl
           je ice_segment_removal_process
    
           and al, 0feh
           cmp al, 064h
           je ice_segment_removal_process
           cmp al, 0f2h
           je ice_repeat_removal_process
    
           mov al, bl
           cmp al, 66h
           je ice_operand_removal_process
           cmp al, 67h
           je ice_address_removal_process
    
           cmp al, 0f0h
           je ice_removal_jump
    
   ice_decode_begin:
           cld
           push bx             ; save original opcode
           mov [ds:ice_current_opcode], ax
    
           call ice_decoder    ; scan opcode through COS decoder
    
           push cx             ; save length to copy
           lds si, [ds:ice_reg._csip]
           push cs
           pop es
           mov di, (offset ice_override_buffer)
           mov cx, 5
           mov eax, 90909090h
           rep stosd           ; clear execution buffer with NOP instructions
           pop cx              ; restore length of instruction to copy
           mov di, (offset ice_opcode_buffer)
           rep movsb           ; copy instruction to be emulated into execution
                               ; buffer
    
   ice_copy_complete:
           push cs
           pop ds
           pop ax                          ; original opcode, saved earlier
           les di, [ds:ice_reg._csip]
           mov dl, [ds:ice_operand_override]
           mov [ds:ice_communication], 0   ; clear communication area
    
           ; On entry to opcode handlers
           ;   AX    = opcode of instruction
           ;   ES:DI = instruction address
           call [ds:ice_handler]           ; call opcode handler
           cli ;>
    
           mov ax, [ds:ice_opcode_length]
           add [ds:ice_reg._ip], ax        ; increment IP by instruction length
    
           cmp [ds:ice_communication], 1
           jb ice_dispatch ;>      ; default restart condition, clear old prefixes
                                   ; and do TF check
           jmp ice_tf_handled ;>   ; special POPF/IRET condition, skip checking
    
   endp ice_dispatch
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; ICE COS decoder
   ;
   ice_decoder_extended:
           inc cx          ; increment instruction length
           inc di          ; increment pointer to point to rest of instruction
           mov al, ah
           mov bx, (offset ice_extended_layout)
           mov si, (offset ice_tables._extended)
           jmp ice_decoder_normal_middle
    
   proc ice_decoder near
           xor cx, cx                      ; clear instruction length
           cmp al, 0fh
           je ice_decoder_extended
    
   ice_decoder_normal: ;>
           mov bx, (offset ice_normal_layout)
           mov si, (offset ice_tables._normal)
    
   ice_decoder_normal_middle:
           and ax, 11110000b
           mov dx, ax
           shr al, 4
           add ax, bx
    
           xchg ax, si
           xor bx, bx
           mov bl, [ds:si]
           add ax, bx
           xchg ax, si
    
   ice_decoder_setup:
           mov ax, [es:di] ; load opcode to compare with table numbers
           mov ah, 0       ; clear top half as it's junk
    
   ice_decoder_loop:
           mov bl, [ds:si]
           and bl, 11100000b
           cmp bl, 01100000b               ; is repeat flag set?
           jne ice_decoder_single          ; no, handle it as a single entry
    
   ice_decoder_repeat:
           mov bl, [ds:si]
           and bl, 11111b                  ; get repeat length
           inc bx                          ; make real repeat length
                           ; get number of opcodes covered by this repeat entry
           add dx, bx      ; table entry = table entry + repeat entries
           inc si          ; point to 'real' opcode entry
           cmp ax, dx      ; is our opcode covered by repeater?
           jb ice_decoder_match    ; yes, decode entry
           jmp ice_decoder_nomatch
    
   ice_decoder_single:
           cmp ax, dx      ; does opcode = table entry?
           je ice_decoder_match    ; yes, decode entry
           inc dx          ; increment table entry number
    
   ice_decoder_nomatch:
           test [byte ds:si], 1000b    ; is procedure entry set?
           jz ice_decoder_skip_entry_easy
           push ax
           mov al, [ds:si]
           and al, 11000000b
           cmp al, 10000000b
           pop ax
           je ice_decoder_skip_entry_easy  ; invalid if group flag set
           inc si
           inc si          ; fixup pointer to skip procedure address
    
   ice_decoder_skip_entry_easy:
           inc si          ; point to next table entry
                           ; move pointer to next entry
           jmp ice_decoder_loop            ; test next entry against opcode
   endp ice_decoder
    
   proc ice_decoder_groups near
           call ice_decoder_immediates     ; calculate immediates
           mov al, [ds:si]
           and ax, 111000b         ; get group access number
           shr al, 3               ; right-align it
           add ax, (offset ice_groups_layout)
           xchg ax, si
           mov ax, (offset ice_tables._groups)
           xor bx, bx
           mov bl, [byte ds:si]
           add ax, bx
           xchg ax, si             ; get group table address
    
           mov al, [es:di+1]
           and ax, 111000b
           shr al, 3               ; index into group entry
           xor dx, dx              ; clear table entry number
           jmp ice_decoder_loop    ; decode !
   endp ice_decoder_groups
    
   proc ice_decoder_invalid near
           xor cx, cx                      ; length of 0
           mov [ds:ice_handler], offset ice_invalid_opcode
                                           ; use invalid opcode handler
           ret
   endp ice_decoder_invalid
    
   proc ice_decoder_fixup_test near
           and ah, 111000b
           jnz ice_decoder_fixup_over
    
           cmp al, 0f6h
           je ice_decoder_fixup_byte
           cmp [ds:ice_operand_override], 0
           je ice_decoder_fixup_word
           inc cx  ; DWORD fixup
           inc cx
   ice_decoder_fixup_word:
           inc cx  ; WORD fixup
   ice_decoder_fixup_byte:
           inc cx  ; BYTE fixup
           jmp ice_decoder_fixup_over
   endp ice_decoder_fixup_test
    
   proc ice_decoder_match near
           mov bl, [ds:si]         ; get table entry
           and bl, 11000000b
           cmp bl, 10000000b       ; mask for group entry flag
           je ice_decoder_groups   ; convert decoding for group tables
           mov bl, [ds:si]
           and bl, 11100000b
           cmp bl, 01000000b
           je ice_decoder_invalid  ; invalid opcode
    
           mov bp, (offset ice_generic)    ; use generic opcode handler by default
           test [byte ds:si], 1000b
           jz ice_decoder_match_no_handler
           mov bp, [ds:si+1]       ; use special opcode handler
    
   ice_decoder_match_no_handler:
           mov ax, [es:di]
           cmp al, 0f6h
           je ice_decoder_fixup_test
           cmp al, 0f7h
           je ice_decoder_fixup_test
           cmp al, 0c8h
           je ice_decoder_fixup_byte   ; note that the extended C8h instruction
                                       ; (0FC8) is invalid and won't come by here
                                       ; so this won't stuff it up
   ice_decoder_fixup_over:
           mov bl, [ds:si]         ; get table entry again
           and bl, 11110000b       ; get header bits of table entry
           jz ice_decoder_plain            ; just a plain old opcode
           cmp bl, 00010000b
           je ice_decoder_special_address  ; special address opcode
   endp ice_decoder_match
    
   proc ice_decoder_modrm near
           inc cx
           mov bl, [es:di+1]
           mov al, bl
           cmp [ds:ice_address_override], 0
           jne ice_decoder_modrm_32        ; use 32-bit MODR/M calculations
    
           and al, 11000111b
           cmp al, 110b
           je ice_decoder_modrm_big        ; address   = two addition
           and al, 11000000b
           jz ice_decoder_plain            ; register = no addition
           cmp al, 01000000b
           je ice_decoder_modrm_small      ; small     = one addition
           cmp al, 10000000b
           jne ice_decoder_plain           ; register = no addition
                                           ; big       = two addition
   ice_decoder_modrm_big:
           inc cx
   ice_decoder_modrm_small:
           inc cx
           jmp ice_decoder_plain
   endp ice_decoder_modrm
    
   proc ice_decoder_modrm_32 near
           and al, 11000000b
           cmp al, 11000000b
           je ice_decoder_plain            ; register = no addition
           mov al, bl
           and al, 111b
           cmp al, 100b
           jne ice_decoder_modrm_sib
           inc cx          ; account for Scale/Index/Base byte
    
           mov al, bl
           and al, 11000000b
           jnz ice_decoder_modrm_sib
           mov al, [es:di+2]
           and al, 111b
           cmp al, 101b
           je ice_decoder_modrm_four_32
    
   ice_decoder_modrm_sib:
           mov al, bl
           and al, 11000111b
           cmp al, 101b
           je ice_decoder_modrm_four_32    ; 32-bit displacement = four addition
           and al, 11000000b
           jz ice_decoder_plain            ; no addition
           cmp al, 10000000b
           jb ice_decoder_modrm_one_32     ; small displacement = one addition
    
   ice_decoder_modrm_four_32:              ; 32-bit displacements
           add cx, 3
    
   ice_decoder_modrm_one_32:               ; 8-bit displacements
           inc cx
           jmp ice_decoder_plain           ; go to immediate data length decoder
   endp ice_decoder_modrm_32
    
   proc ice_decoder_special_address near
           inc cx
           inc cx                          ; word memory address
           cmp [byte ds:ice_address_override], 0
           je ice_decoder_plain
           inc cx
           inc cx                  ; doubleword memory address
   endp ice_decoder_special_address
    
   proc ice_decoder_plain near
           call ice_decoder_immediates     ; calculate immediates
           inc cx                          ; instruction size + 1
           mov [ds:ice_opcode_length], cx  ; save opcode length
           mov [ds:ice_handler], bp        ; save opcode handler address
           ret
   endp ice_decoder_plain
    
   proc ice_decoder_immediates near
           mov al, [ds:si]
           and ax, 111b
           shl al, 1
           add ax, (offset ice_immediates_table)
           cmp [ds:ice_operand_override], 0
           je ice_decoder_immediates_conversion
           inc ax
    
   ice_decoder_immediates_conversion:
           xchg ax, si
           add cl, [ds:si]
           xchg ax, si
           ret
   endp ice_decoder_immediates
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_mov_segreg_source near
           and ah, 111000b
           cmp ah, 1000b
           je ice_mov_regmem_cs        ; MOV ?, CS
   endp ice_mov_segreg_source
    
   proc ice_mov_segreg_destination near
           and ah, 111000b
           cmp ah, 1000b
           je ice_invalid_opcode       ; MOV CS, ?
           cmp ah, 11000b
           je ice_generic_process_es   ; MOV DS instructions
           cmp ax, 1000010001110b
           jne ice_mov_segreg_exit
           inc [ds:ice_communication]  ; MOV SS, ?
   ice_mov_segreg_exit:
           jmp ice_generic             ; handle the rest generically
   endp ice_mov_segreg_destination
    
   proc ice_mov_regmem_cs near
           cmp [byte high word ds:ice_current_opcode], 11001000b
           je ice_mov_ax_cs
           mov [byte ds:ice_opcode_buffer], 89h
           and [byte ds:ice_opcode_buffer+1], 11000111b
           push [ds:ice_reg._eax]      ; save _EAX
           xor eax, eax
           mov ax, [ds:ice_reg._cs]
           mov [ds:ice_reg._eax], eax  ; _EAX = _CS
           call ice_generic            ; emulate it
           pop [ds:ice_reg._eax]       ; restore _EAX
           ret                         ; exit
   endp ice_mov_regmem_cs
    
   proc ice_mov_ax_cs near
           xor eax, eax
           mov ax, [ds:ice_reg._cs]
           cmp [ds:ice_operand_override], 0
           jne ice_mov_ax_cs_32
           mov [ds:ice_reg._ax], ax    ; _AX = _CS
           ret
   endp ice_mov_ax_cs
    
   proc ice_mov_ax_cs_32 near
           mov [ds:ice_reg._eax], eax  ; _EAX = 0000 shl 16 + _CS
           ret
   endp ice_mov_ax_cs_32
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_fault_execute near ;>
           xchg bl, ah
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           mov ax, [ds:ice_original_ip]
           mov [ds:ice_reg._ip], ax
           xchg ah, bl
           jmp ice_int_x ;>
   endp ice_fault_execute
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_protection_fault near
           mov ah, 13              ; yes, 13, not 13h ;> int0dh
           jmp ice_fault_execute
   endp ice_protection_fault
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_invalid_opcode near
           mov ah, 6 ;>int6 ;>
           jmp ice_fault_execute
   endp ice_invalid_opcode
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_indirect near ;>
           mov al, 10001011b
           and ah, 11000111b
           mov [word ds:ice_opcode_buffer], ax
           push [ds:ice_reg._eax]
           call ice_generic ;>
           mov eax, [ds:ice_reg._eax]
           mov [ds:ice_indirect_saved], eax
           pop [ds:ice_reg._eax]
           mov ax, [ds:ice_current_opcode]
           cmp al, 62h
           je ice_indirect_second
           and ah, 111000b
           cmp ah, 110000b
           je ice_div
           cmp ah, 111000b
           je ice_div
    
           mov bl, [ds:ice_operand_override]
           cmp ah, 100000b
           je ice_indirect_jmp_near
           cmp ah, 010000b
           jne ice_indirect_second
    
   ice_indirect_call_near:
           or bl, bl
           jnz ice_indirect_call_near_32
           mov ax, [ds:ice_reg._ip]
           add ax, [ds:ice_opcode_length]
           call ice_external_push_16
    
   ice_indirect_jmp_near:
           or bl, bl
           jnz ice_indirect_jmp_near_32
           mov ax, [word low dword ds:ice_indirect_saved]
           mov [ds:ice_reg._ip], ax
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           ret
    
   ice_indirect_call_near_32:
           cmp [word high dword ds:ice_indirect_saved], 0
           jne ice_protection_fault
           xor eax, eax
           mov ax, [ds:ice_reg._ip]
           add ax, [ds:ice_opcode_length]
           call ice_external_push_32
    
   ice_indirect_jmp_near_32:
           mov eax, [ds:ice_indirect_saved]
           cmp eax, 10000h
           jnb ice_protection_fault
           mov [ds:ice_reg._ip], ax
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           ret
    
   ice_indirect_second:
           push [ds:ice_reg._eax]
           mov [byte ds:ice_opcode_buffer], 8dh
           call ice_generic
           mov eax, [ds:ice_reg._eax]
           pop [ds:ice_reg._eax]
           cmp [ds:ice_address_override], 0
           jnz ice_indirect_second_32
    
           xchg ax, di
           mov al, [ds:ice_segment_override]
           mov bx, [word low dword ds:ice_indirect_saved]
           cmp al, 26h
           je ice_indirect_es
           cmp al, 2eh
           je ice_indirect_cs
           cmp al, 36h
           je ice_indirect_ss
           cmp al, 64h
           je ice_indirect_fs
           cmp al, 65h
           je ice_indirect_gs
    
   ice_indirect_ds:
           mov es, [ds:ice_reg._ds]
           cmp bx, [es:di]
           je ice_indirect_third
    
   ice_indirect_ss:
           mov es, [ds:ice_reg._ss]
           cmp bx, [es:di]
           je ice_indirect_third
    
   ice_indirect_cs:
           mov es, [ds:ice_reg._cs]
           cmp bx, [es:di]
           je ice_indirect_third
    
   ice_indirect_es:
           mov es, [ds:ice_reg._es]
           cmp bx, [es:di]
           je ice_indirect_third
    
   ice_indirect_fs:
           push fs
           pop es
           cmp bx, [es:di]
           je ice_indirect_third
    
   ice_indirect_gs:
           push gs
           pop es
           cmp bx, [es:di]
           jne ice_protection_fault
    
   ice_indirect_third:
           mov cx, [es:di+2]
    
           mov ax, [ds:ice_current_opcode]
           cmp al, 62h
           je ice_bound
           and ah, 111000b
           cmp ah, 101000b
           je ice_indirect_jmp_far
    
   ice_indirect_call_far:
           mov ax, [ds:ice_reg._cs]
           call ice_external_push_16
           mov ax, [ds:ice_reg._ip]
           add ax, [ds:ice_opcode_length]
           call ice_external_push_16
    
   ice_indirect_jmp_far:
           mov [ds:ice_reg._cs], cx
           mov ax, [word low dword ds:ice_indirect_saved]
           mov [ds:ice_reg._ip], ax
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           ret
    
   ice_indirect_second_32:
           cmp eax, 10000h
           jnb ice_protection_fault
           xchg eax, edi
           mov al, [ds:ice_segment_override]
           mov ebx, [ds:ice_indirect_saved]
    
           cmp al, 26h
           je ice_indirect_es_32
           cmp al, 2eh
           je ice_indirect_cs_32
           cmp al, 36h
           je ice_indirect_ss_32
           cmp al, 64h
           je ice_indirect_fs_32
           cmp al, 65h
           je ice_indirect_gs_32
    
   ice_indirect_ds_32:
           mov es, [ds:ice_reg._ds]
           cmp ebx, [es:edi]
           je ice_indirect_third_32
    
   ice_indirect_ss_32:
           mov es, [ds:ice_reg._ss]
           cmp ebx, [es:edi]
           je ice_indirect_third_32
    
   ice_indirect_cs_32:
           mov es, [ds:ice_reg._cs]
           cmp ebx, [es:edi]
           je ice_indirect_third_32
    
   ice_indirect_es_32:
           mov es, [ds:ice_reg._es]
           cmp ebx, [es:edi]
           je ice_indirect_third_32
    
   ice_indirect_fs_32:
           push fs
           pop es
           cmp ebx, [es:edi]
           je ice_indirect_third_32
    
   ice_indirect_gs_32:
           push gs
           pop es
           cmp ebx, [es:edi]
           jne ice_protection_fault
    
   ice_indirect_third_32:
           mov ecx, [es:di+4]
    
           mov ax, [ds:ice_current_opcode]
           cmp al, 62h
           je ice_bound_32
           and ah, 111000b
           cmp ah, 101000b
           je ice_indirect_jmp_far_32
    
   ice_indirect_call_far_32:
           db 66
           push cs
           pop eax
           mov ax, [ds:ice_reg._cs]
           call ice_external_push_32
           xor eax, eax
           mov ax, [ds:ice_reg._ip]
           add ax, [ds:ice_opcode_length]
           call ice_external_push_32
    
   ice_indirect_jmp_far_32:
           mov [ds:ice_reg._cs], cx
           mov ax, [word low dword ds:ice_indirect]
           mov [ds:ice_reg._ip], ax
           xor ax, ax
           mov [ds:ice_opcode_length], ax
           ret
   endp ice_indirect
    
   proc ice_div near ;>
           mov ebx, [ds:ice_indirect_saved]
           cmp al, 0f6h ;>
           jne ice_div_word
    
   ice_div_byte: ;> (f6 f4) -> (div ah:secure024)
           or bl, bl ;>
           jz ice_div_exception ;>
    
   ice_div_okay:
           mov ax, [ds:ice_current_opcode]
           mov [word ds:ice_opcode_buffer], ax
           ;>
           ;>
           jmp ice_generic
    
   ice_div_word: ;> (f7 f3) -> (div bx:jmt-cp5)
           cmp [ds:ice_operand_override], 0
           jnz ice_div_dword
           or bx, bx
           jnz ice_div_okay
    
   ice_div_exception: ;>
           xor ax, ax ;> ax=0, int0
           jmp ice_fault_execute ;>
    
   ice_div_dword:
           or ebx, ebx
           jz ice_div_exception
           jmp ice_div_okay
   endp ice_div
    
   proc ice_bound near
           push [ds:ice_reg._ax]
           push cx
           mov al, 89h
           and ah, 111000b
           or ah, 11000000b
           mov [word ds:ice_opcode_buffer], ax
           mov [word ds:ice_opcode_buffer+2], 9090h
           call ice_generic
           mov ax, [ds:ice_reg._ax]
           mov bx, [word low dword ds:ice_indirect_saved]
           pop cx
           pop [ds:ice_reg._ax]
           cmp ax, bx
           jb ice_bound_triggered
           cmp ax, cx
           ja ice_bound_triggered
           ret
    
   ice_bound_triggered:
           mov ah, 5 ;> int5
           jmp ice_fault_execute
   endp ice_bound
    
   proc ice_bound_32 near
           push [ds:ice_reg._eax]
           push ecx
           mov al, 89h
           and ah, 111000b
           or ah, 11000000b
           mov [word ds:ice_opcode_buffer], ax
           mov [dword ds:ice_opcode_buffer+2], 90909090h
           call ice_generic
           mov eax, [ds:ice_reg._eax]
           mov ebx, [ds:ice_indirect_saved]
           pop ecx
           pop [ds:ice_reg._eax]
           cmp eax, ebx
           jb ice_bound_triggered
           cmp eax, ecx
           ja ice_bound_triggered
           ret
   endp ice_bound_32
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_direct_call_far near
           or dl, dl
           jnz ice_direct_call_far_32
           mov ax, [ds:ice_reg._cs]
           call ice_external_push_16
           mov ax, [ds:ice_reg._ip]
           add ax, 5
           call ice_external_push_16
    
   proc ice_direct_jmp_far near
           or dl, dl
           jnz ice_direct_jmp_far_32
           mov ax, [word es:di+1]
           mov [ds:ice_reg._ip], ax
           mov ax, [word es:di+3]
           mov [ds:ice_reg._cs], ax
           dec [ds:ice_opcode_length]
           ret
   endp ice_direct_jmp_far
   endp ice_direct_call_far
    
   proc ice_direct_call_far_32 near
           cmp [word high dword es:di+1], 0
           jnz ice_protection_fault
           db 66h
           push cs
           pop eax
           mov ax, [ds:ice_reg._cs]
           call ice_external_push_32
           xor eax, eax
           mov ax, [ds:ice_reg._ip]
           add ax, 7
           call ice_external_push_32
    
   proc ice_direct_jmp_far_32 near
           mov eax, [es:di+1]
           cmp eax, 10000h
           jnb ice_protection_fault
           mov [ds:ice_reg._ip], ax
           mov ax, [word es:di+5]
           mov [ds:ice_reg._cs], ax
           dec [ds:ice_opcode_length]
           ret
   endp ice_direct_jmp_far_32
   endp ice_direct_call_far_32
    
   proc ice_direct_call_near near
           or dl, dl
           jnz ice_direct_call_near_32
           mov ax, [ds:ice_reg._ip]
           add ax, 3
           call ice_external_push_16
    
   proc ice_direct_jmp_near near ;>
           or dl, dl
           jnz ice_direct_jmp_near_32
           mov ax, [es:di+1]
           add [ds:ice_reg._ip], ax ;>
           ret
   endp ice_direct_jmp_near ;>
   endp ice_direct_call_near
    
   proc ice_direct_call_near_32 near
           xor eax, eax
           mov ax, [ds:ice_reg._ip]
           add ax, 5
           push eax
           add eax, [es:di+1]
           cmp eax, 10000h
           pop eax
           jnb ice_protection_fault
           call ice_external_push_32
    
   proc ice_direct_jmp_near_32 near
           xor eax, eax
           mov ax, [ds:ice_reg._ip]
           add eax, [es:di+1]
           add eax, 5
           cmp eax, 10000h
           jnb ice_protection_fault
           mov [ds:ice_reg._ip], ax
           dec [ds:ice_opcode_length]
           ret
   endp ice_direct_jmp_near_32
   endp ice_direct_call_near_32
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_into near
           mov ah, 4 ;> int4
           test [byte high word ds:ice_reg._flags], 1000b
           jnz ice_int_x       ; emulate interrupt if emulated overflow flag set
           ret                 ; else just skip the interrupt
   endp ice_into
    
   proc ice_int_3 near ;>int3
           mov ah, 3           ; emulate INT 3 instruction (length of 1 already in
                               ; the ice_opcode_length variable
   proc ice_int_x near ;>
           xchg ax, bx         ; BX holds interrupt to emulate ;>
           mov ax, [ds:ice_reg._flags]
           call ice_external_push_16   ; save emulated flags on external stack
           mov ax, [ds:ice_reg._cs]
           call ice_external_push_16   ; save emulated CS on external stack
           mov ax, [ds:ice_reg._ip]
           add ax, [ds:ice_opcode_length]
           call ice_external_push_16   ; save emulated return IP on external stack
           and [byte high word ds:ice_reg._flags], 11111100b
                                       ; clear emulated IF and TF
           xor ax, ax
           mov di, ax              ; DI = 0
           mov al, bh              ; AL = INT to emulate
           shl ax, 2               ; AX = INT * 4
           xchg ax, di ;> di=ax
           mov es, ax              ; ES = 0, DI = INT * 4
           ;>
           mov ax, [word es:di]    ; get offset of interrupt code
           mov [ds:ice_reg._ip], ax; update emulated IP
           mov ax, [word es:di+2]  ; get segment of interrupt code
           mov [ds:ice_reg._cs], ax; update emulated CS
           ;>
           xor ax, ax
           mov [ds:ice_opcode_length], ax  ; clear opcode length as IP is already
                                           ; set properly
           ret
   endp ice_int_x ;>
   endp ice_int_3
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_ret_near_value
           mov bx, [es:di+1]
           jmp ice_ret_near_skip   ; get value to add to eSP
   endp ice_ret_near_value
    
   proc ice_ret_near
           xor bx, bx              ; value to add to eSP is 0
   ice_ret_near_skip:
           or dl, dl
           jnz ice_ret_near_32     ; 32-bit RET NEAR
           call ice_external_pop_16; get new IP
           mov [ds:ice_reg._ip], ax; set new IP
           jmp ice_ret_exit
    
   ice_ret_near_32:
           call ice_external_pop_32    ; get new IP
           cmp eax, 10000h
           jnb ice_ret_exception       ; emulate exception if invalid return IP
           mov [ds:ice_reg._ip], ax    ; set new IP
   endp ice_ret_near
    
   proc ice_ret_exit near
           dec [ds:ice_opcode_length]  ; instruction length = 0, for dispatcher
           or dl, dl
           jnz ice_ret_exit
           add [ds:ice_reg._sp], bx    ; update SP
           ret
    
   ice_retn_exit_32:
           xor eax, eax
           mov ax, bx
           add [ds:ice_reg._esp], eax  ; update ESP
           ret
   endp ice_ret_exit
    
   proc ice_ret_exception near
           call ice_external_push_32   ; for protection fault in RETs... we must
                                       ; have a valid return address... and since
                                       ; what we have here is an invalid one....
                                       ; set the stack back to normal first
           jmp ice_protection_fault
   endp ice_ret_exception
    
   proc ice_ret_far_value near
           mov bx, [es:di+1]       ; get value to add to eSP
           jmp ice_ret_far_skip
   endp ice_ret_far_value
    
   proc ice_ret_far near
           xor bx, bx              ; value to add to eSP is 0
   ice_ret_far_skip:
           or dl, dl
           jnz ice_ret_far_32      ; 32-bit RET FAR
           call ice_external_pop_16
           mov [ds:ice_reg._ip], ax; save new IP
           call ice_external_pop_16
           mov [ds:ice_reg._cs], ax; save new CS
           jmp ice_ret_exit
   endp ice_ret_far
    
   proc ice_ret_far_32 near
           call ice_external_pop_32; get new IP
           cmp eax, 10000h
           jnb ice_ret_exception   ; emulate exception if it's invalid
           mov [ds:ice_reg._ip], ax; save new IP
           call ice_external_pop_32
           mov [ds:ice_reg._cs], ax; save new CS
           jmp ice_ret_exit
   endp ice_ret_far_32
    
   proc ice_iret
           dec [ds:ice_opcode_length]  ; set opcode length to 0
           or dl, dl
           jnz ice_iret_32             ; use 32-bit IRET
           call ice_external_pop_16
           mov [ds:ice_reg._ip], ax    ; save new IP
           call ice_external_pop_16
           mov [ds:ice_reg._cs], ax    ; save new CS
           jmp ice_popf                ; emulate POPF
    
   ice_iret_32:
           call ice_external_pop_32    ; get new IP
           cmp eax, 10000h
           jnb ice_ret_exception       ; emulate exception if it's invalid
           mov [ds:ice_reg._ip], ax    ; set new IP
           call ice_external_pop_32
           mov [ds:ice_reg._cs], ax    ; set new CS
           jmp ice_popf                ; emulate POPF[D]
   endp ice_iret
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_pushf near
           mov eax, [ds:ice_reg._eflags]   ; get the flags
           or dl, dl
           jnz ice_pushfd
           call ice_external_push_16   ; push them onto external stack (word)
           ret
    
   proc ice_pushfd near
           call ice_external_push_32   ; push them onto external stack (double)
           ret
   endp ice_pushfd
   endp ice_pushf
    
   proc ice_popf near
           mov bx, [ds:ice_reg._flags] ; get a copy of the flags
           or dl, dl
           jnz ice_popfd
           call ice_external_pop_16    ; get the new copy of the flags
           mov [ds:ice_reg._flags], ax ; save them into the real flags
           jmp ice_popf_single_step
    
   proc ice_popfd near
           call ice_external_pop_32        ; get the new copy of the flags
           mov [ds:ice_reg._eflags], eax   ; save them into the real flags
    
   ice_popf_single_step:
           and bh, 1
           jnz ice_popf_exit           ; exit if TF was originally SET
           and ah, 1
           jz ice_popf_exit            ; exit if TF is still SET
           inc [ds:ice_communication]  ; TF transition from OFF-ON, skip TF check
                                       ; for one instruction pass
   ice_popf_exit:
           ret                         ; POPF emulation finished
   endp ice_popfd
   endp ice_popf
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_loop near      ; DEC CX, JNZ X
           or dl, dl
           jnz ice_loop_ecx
           dec [ds:ice_reg._cx]
           jnz ice_jmp_conditional_short_follow ;>
           ret
   ice_loop_ecx:           ; DEC ECX, JNZ X
           dec [ds:ice_reg._ecx]
           jnz ice_jmp_conditional_short_follow ;>
           ret
   endp ice_loop
    
   proc ice_loope near
           test [byte low word ds:ice_reg._flags], 1000000b
           jnz ice_loop    ; use normal LOOP procedure if ZF set
           jmp ice_loop_dec    ; decrement eCX anyway
   endp ice_loope
    
   proc ice_loopne near
           test [byte low word ds:ice_reg._flags], 1000000b
           jz ice_loop     ; use normal LOOP procedure if ZF clear
           jmp ice_loop_dec    ; decrement eCX anyway
   endp ice_loopne
    
    
   proc ice_loop_dec near
           or dl, dl
           jnz ice_loope_ecx
           dec [ds:ice_reg._cx]    ; decrement CX
           ret
    
   ice_loope_ecx:
           dec [ds:ice_reg._ecx]   ; decrement ECX
           ret
   endp ice_loop_dec
    
   proc ice_jcxz near
           mov eax, [ds:ice_reg._ecx]
           or dl, dl
           jnz ice_jcxz_ecx
           or ax, ax       ; follow short jump if CX was 0
           jz ice_jmp_conditional_short_follow
           ret
   ice_jcxz_ecx:
           or ecx, ecx     ; follow short jump if ECX was 0
           jz ice_jmp_conditional_short_follow
           ret
   endp ice_jcxz
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_aam near
           or ah, ah
           jz ice_div_exception        ; emulate a DIV exception
           jmp ice_generic             ; emulate AAM generically
   endp ice_aam
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_pop_segreg near
           cmp al, 17h
           jne ice_pop_segreg_exit     ; is it POP SS? ;> weird
           inc [ds:ice_communication]  ; if so, skip single step handler on return
   ice_pop_segreg_exit:
           jmp ice_generic             ; use generic handler for opcode anyway
   endp ice_pop_segreg
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_jmp_conditional_short near ;>
           mov [byte ds:ice_jmp_conditional_short_modify], al ;>
           db 0ebh, 00 ;>
           mov ebx, [ds:ice_reg._eflags]
           and bh, 11111110b
           push ebx
           popfd
    
           db 0ebh, 00 ;> clear pre-fetch by jmt ;>
   ice_jmp_conditional_short_modify: ;>
           jc ice_jmp_conditional_short_follow
           ret
    
   ice_jmp_conditional_short_follow: ;>
           mov al, [es:di+1]
           cbw
           add [ds:ice_reg._ip], ax
           ret
   endp ice_jmp_conditional_short
    
   proc ice_jmp_conditional_long near ;>
           mov [byte high word ds:ice_jmp_conditional_long_modify], ah ;>
           db 0ebh, 00 ;>
           mov ebx, [ds:ice_reg._eflags]
           and bh, 11111110b
           push ebx
           popfd
    
           db 0ebh, 00 ;> clear pre-fetch by jmt ;>
   ice_jmp_conditional_long_modify: ;>
           dw 0fh
           dw 1
           ret
    
   ice_jmp_conditional_long_follow: ;>
           or dl, dl
           jnz ice_jmp_conditional_long_32
           mov ax, [es:di+2]
           add [ds:ice_reg._ip], ax
           ret
   endp ice_jmp_conditional_long
    
   proc ice_jmp_conditional_long_32 near
           xor eax, eax
           mov ax, [ds:ice_opcode_length]
           add ax, [ds:ice_reg._ip]
           add eax, [es:di+2]
           cmp eax, 10000h
           jnb ice_protection_fault
           mov [ds:ice_reg._ip], ax
           ret
   endp ice_jmp_conditional_long_32
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_push_segreg near
           cmp al, 0eh
           jne ice_generic             ; not PUSH CS?  exit!
           db 66h
           push cs
           pop eax
           mov ax, [ds:ice_reg._cs]    ; determine the complete emulated CS
           or dl, dl
           jnz ice_push_segreg_32      ; go to 32-bit version if operand size
                                       ; prefix is present
           call ice_external_push_16   ; push 16-bit emulated CS
           ret
   ice_push_segreg_32:
           call ice_external_push_32   ; push 32-bit emulated CS
           ret
   endp ice_push_segreg
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; 16-bit external stack push from AX
   ;
   proc ice_external_push_16 near
           push es
           push edi
           les edi, [ds:ice_reg._ssesp]
           dec di
           dec di
           mov [es:di], ax
           mov [ds:ice_reg._sp], di
           pop edi
           pop es
           ret
   endp ice_external_push_16
   ; 16-bit external stack pop into AX
   ;
   proc ice_external_pop_16 near
           cld
           push ds
           push esi
           lds esi, [ds:ice_reg._ssesp]
           lodsw
           mov [cs:ice_reg._sp], si
           pop esi
           pop ds
           ret
   endp ice_external_pop_16
   ; 32-bit external stack push from EAX
   ;
   proc ice_external_push_32 near
           push es
           push edi
           les edi, [ds:ice_reg._ssesp]
           sub edi, 4
           mov [es:edi], eax
           mov [ds:ice_reg._esp], edi
           pop edi
           pop es
           ret
   endp ice_external_push_32
   ; 32-bit external stack pop into EAX
   ;
   proc ice_external_pop_32 near
           cld
           push ds
           push esi
           lds esi, [ds:ice_reg._ssesp]
           lodsd
           mov [cs:ice_reg._esp], esi
           pop esi
           pop ds
           ret
   endp ice_external_pop_32
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   proc ice_generic_process_es near
           cmp [ds:ice_segment_override], 2eh
           jne ice_generic_main
           mov [ds:ice_cs_swapped], 2
           mov [ds:ice_segment_override], 26h
    
   proc ice_generic near
           cmp [ds:ice_segment_override], 2eh
           jne ice_generic_main
           mov [ds:ice_cs_swapped], 1
           mov [ds:ice_segment_override], 3eh
    
   ice_generic_main:
           push [ds:ice_reg._flags]
           and [byte high word ds:ice_reg._flags], 11111110b
    
           push ds
           pop es
           std
           mov si, (offset ice_overrides+3)
           mov di, (offset ice_override_buffer+3)
    
           lodsb
           or al, al
           jz ice_generic_no_segment
           stosb
    
   ice_generic_no_segment:
           lodsb
           or al, al
           jz ice_generic_no_repeat
           stosb
    
   ice_generic_no_repeat:
           lodsb
           or al, al
           jz ice_generic_no_operand
           stosb
    
   ice_generic_no_operand:
           lodsb
           or al, al
           jz ice_generic_no_address
           stosb
    
   ice_generic_no_address:
           mov eax, [ds:ice_reg._eax]
           mov ebx, [ds:ice_reg._ebx]
           mov ecx, [ds:ice_reg._ecx]
           mov edx, [ds:ice_reg._edx]
           mov edi, [ds:ice_reg._edi]
           mov esi, [ds:ice_reg._esi]
           mov ebp, [ds:ice_reg._ebp]
           mov es, [ds:ice_reg._es]
           mov ds, [ds:ice_reg._ds]
           cmp [cs:ice_cs_swapped], 0
           je ice_generic_swapped
    
           cmp [cs:ice_cs_swapped], 2
           je ice_generic_swap_es
    
   ice_generic_swap_ds:
           mov ds, [cs:ice_reg._cs]
           jmp ice_generic_swapped
   ice_generic_swap_es:
           mov es, [cs:ice_reg._cs]
    
   ice_generic_swapped:
           push [cs:ice_reg._eflags]
           popfd
           ice_switch_to_external_stack
    
   align 4
   ice_override_buffer db 4 dup (90h)
   ice_opcode_buffer db 10h dup (90h)
    
           ice_switch_to_internal_stack
    
           pushfd
           pop [cs:ice_reg._eflags]
           cmp [cs:ice_cs_swapped], 0
           je ice_generic_save_both
           cmp [cs:ice_cs_swapped], 1
           je ice_generic_restore_ds
           mov es, [cs:ice_reg._es]
           jmp ice_generic_save_both
   ice_generic_restore_ds:
           mov ds, [cs:ice_reg._ds]
   ice_generic_save_both:
           mov [cs:ice_reg._ds], ds
           push cs
           pop ds
           mov [ds:ice_reg._es], es
    
           mov [ds:ice_reg._eax], eax
           mov [ds:ice_reg._ebx], ebx
           mov [ds:ice_reg._ecx], ecx
           mov [ds:ice_reg._edx], edx
           mov [ds:ice_reg._edi], edi
           mov [ds:ice_reg._esi], esi
           mov [ds:ice_reg._ebp], ebp
           cmp [ds:ice_cs_swapped], 0
           je ice_generic_exit
           mov [ds:ice_segment_override], 2eh
    
   ice_generic_exit:
           pop ax
           and ah, 1
           or [byte high word ds:ice_reg._flags], ah
           mov [ds:ice_cs_swapped], 0
   proc ice_skip near
           ret
   endp ice_skip
   endp ice_generic
   endp ice_generic_process_es
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   ; STRUC definitions
   ;
   ; STRUC for our internal 32-bit stacks
   ;
   struc ice_stack_struc
         internal_esp   dd 0
         switch dw 0
             label bottom
         dw 50h dup(0) ;>
             label top ;>
   ends ice_stack_struc
   ; STRUC for immediate tables
   ;
   struc ice_immediates_table_struc
       db 0, 0
       db 1, 1
       db 2, 2
       db 4, 4
       db 6, 6
       db 1, 2
       db 2, 4
       db 4, 6
   ends ice_immediates_table_struc
   ; STRUC for group layouts
   ;
   struc ice_groups_layout_struc
           db (offset ice_tables._group_0 - offset ice_tables._groups)
           db (offset ice_tables._group_1 - offset ice_tables._groups)
           db (offset ice_tables._group_2 - offset ice_tables._groups)
           db (offset ice_tables._group_3 - offset ice_tables._groups)
           db (offset ice_tables._group_4 - offset ice_tables._groups)
           db (offset ice_tables._group_5 - offset ice_tables._groups)
           db (offset ice_tables._group_6 - offset ice_tables._groups)
           db (offset ice_tables._group_7 - offset ice_tables._groups)
   ends ice_groups_layout_struc
   ; STRUC for extended layouts
   ;
   struc ice_extended_layout_struc
           db (offset ice_tables._extended_0 - offset ice_tables._extended)
           db (offset ice_tables._extended_1 - offset ice_tables._extended)
           db (offset ice_tables._extended_2 - offset ice_tables._extended)
           db (offset ice_tables._extended_3 - offset ice_tables._extended)
           db (offset ice_tables._extended_4 - offset ice_tables._extended)
           db (offset ice_tables._extended_5 - offset ice_tables._extended)
           db (offset ice_tables._extended_6 - offset ice_tables._extended)
           db (offset ice_tables._extended_7 - offset ice_tables._extended)
           db (offset ice_tables._extended_8 - offset ice_tables._extended)
           db (offset ice_tables._extended_9 - offset ice_tables._extended)
           db (offset ice_tables._extended_a - offset ice_tables._extended)
           db (offset ice_tables._extended_b - offset ice_tables._extended)
           db (offset ice_tables._extended_c - offset ice_tables._extended)
           db (offset ice_tables._extended_d - offset ice_tables._extended)
           db (offset ice_tables._extended_e - offset ice_tables._extended)
           db (offset ice_tables._extended_f - offset ice_tables._extended)
   ends ice_extended_layout_struc
   ; STRUC for normal layouts
   ;
   struc ice_normal_layout_struc
           db (offset ice_tables._normal_0 - offset ice_tables._normal)
           db (offset ice_tables._normal_1 - offset ice_tables._normal)
           db (offset ice_tables._normal_2 - offset ice_tables._normal)
           db (offset ice_tables._normal_3 - offset ice_tables._normal)
           db (offset ice_tables._normal_4 - offset ice_tables._normal)
           db (offset ice_tables._normal_5 - offset ice_tables._normal)
           db (offset ice_tables._normal_6 - offset ice_tables._normal)
           db (offset ice_tables._normal_7 - offset ice_tables._normal)
           db (offset ice_tables._normal_8 - offset ice_tables._normal)
           db (offset ice_tables._normal_9 - offset ice_tables._normal)
           db (offset ice_tables._normal_a - offset ice_tables._normal)
           db (offset ice_tables._normal_b - offset ice_tables._normal)
           db (offset ice_tables._normal_c - offset ice_tables._normal)
           db (offset ice_tables._normal_d - offset ice_tables._normal)
           db (offset ice_tables._normal_e - offset ice_tables._normal)
           db (offset ice_tables._normal_f - offset ice_tables._normal)
   ends ice_normal_layout_struc
   ; STRUC for our simulated CPU registers
   ;
   struc ice_register_struc
         label _eax dword
         label _ax word
         label _al byte
               db 0
         label _ah byte
               db 0
               dw 0
    
         label _ebx dword
         label _bx word
         label _bl byte
               db 0
         label _bh byte
               db 0
               dw 0
    
         label _ecx dword
         label _cx word
         label _cl byte
               db 0
         label _ch byte
               db 0
               dw 0
    
         label _edx dword
         label _dx word
         label _dl byte
               db 0
         label _dh byte
               db 0
               dw 0
    
         label _edi dword
         label _di word
               dw 0
               dw 0
    
         label _esi dword
         label _si word
               dw 0
               dw 0
    
         label _ebp dword
         label _bp word
               dw 0
               dw 0
    
         label _csip dword
         label _ip word
               dw 0
         _cs   dw 0
    
         label _ssesp fword
         label _esp dword
         label _sp word
               dd 0
         _ss   dw 0
    
         _es   dw 0
         _ds   dw 0
    
         label _eflags dword
         label _flags word
               dd 0
    
   ends ice_register_struc
   ; STRUC for COS database tables
   ;
   struc ice_tables_struc ;>
       label _normal unknown
           label _normal_0 unknown
           label _normal_1 unknown
           label _normal_2 unknown
           label _normal_3 unknown
               db 063h, 0c0h, 001h, 006h, 000h, 008h
               dw offset ice_pop_segreg
               db 063h, 0c0h, 001h, 006h, 008h
               dw offset ice_push_segreg
               db 000h
           label _normal_4 unknown
           label _normal_5 unknown
               db 06fh, 000h
           label _normal_6 unknown
               db 000h, 000h, 0e8h
               dw offset ice_indirect
               db 0f0h, 063h, 000h, 006h, 0c6h, 001h, 0c1h, 063h, 000h
           label _normal_7 unknown
               db 06fh, 009h
               dw offset ice_jmp_conditional_short
           label _normal_8 unknown
               db 081h, 086h, 040h, 081h, 067h, 0c0h, 0c8h
               dw offset ice_mov_segreg_source
               db 0e0h, 0c8h
               dw offset ice_mov_segreg_destination
               db 0c0h
           label _normal_9 unknown
               db 069h, 000h, 08h
               dw offset ice_direct_call_far
               db 000h, 008h
               dw offset ice_pushf
               db 008h
               dw offset ice_popf
               db 000h, 000h
           label _normal_a unknown
               db 063h, 010h, 063h, 000h, 001h, 006h, 065h, 000h
           label _normal_b unknown
               db 067h, 001h, 067h, 006h
           label _normal_c unknown
               db 089h, 089h, 008h
               dw offset ice_ret_near_value
               db 008h
               dw offset ice_ret_near
               db 0e0h, 0e8h
               dw offset ice_generic_process_es
               db 0c1h, 0c6h, 002h, 000h, 008h
               dw offset ice_ret_far_value
               db 008h
               dw offset ice_ret_far
               db 008h
               dw offset ice_int_3
               db 009h
               dw offset ice_int_x
               db 008h
               dw offset ice_into
               db 008h
               dw offset ice_iret
           label _normal_d unknown
               db 063h, 088h, 009h
               dw offset ice_aam
               db 001h, 040h, 000h, 067h, 0c0h
           label _normal_e unknown
               db 009h
               dw offset ice_loopne
               db 009h
               dw offset ice_loope
               db 009h
               dw offset ice_loop
               db 009h
               dw offset ice_jcxz
               db 063h, 001h, 00eh
               dw offset ice_direct_call_near
               db 00eh
               dw offset ice_direct_jmp_near ;>
               db 008h
               dw offset ice_direct_jmp_far
               db 009h
               dw offset ice_jmp_conditional_short_follow
               db 063h, 000h
           label _normal_f unknown
               db 000h, 040h, 000h, 000h, 008h
               dw offset ice_skip
               db 000h, 090h, 090h, 065h, 000h, 098h, 0a0h
    
       label _extended unknown
           label _extended_0 unknown
               db 0a8h, 0b0h, 0c0h, 0c0h, 040h, 040h, 000, 68h, 40h
           label _extended_1 unknown
               db 06fh, 040h
           label _extended_2 unknown
               db 064h, 0f0h, 040h, 0f0h, 68h, 40h
           label _extended_3 unknown
           label _extended_4 unknown
           label _extended_5 unknown
           label _extended_6 unknown
           label _extended_7 unknown
               db 06fh, 040h
           label _extended_8 unknown
               db 06fh, 00eh
               dw offset ice_jmp_conditional_long
           label _extended_9 unknown
               db 06fh, 0c0h
           label _extended_a unknown
               db 000h,000h,040h,0c0h,0c1h,0c0h,040h,040h,000h,000h,040h,0c0h,0c1h,0c0h,040h,0c0h
           label _extended_b unknown
               db 040h,040h,0e0h,0c0h,0e0h,0e0h,0c0h,0c0h,040h,040h,0b9h,064h,0c0h
           label _extended_c unknown
           label _extended_d unknown
           label _extended_e unknown
           label _extended_f unknown
               db 06fh, 040h
    
       label _groups unknown
           label _group_0 unknown
               db 067h, 0c0h
           label _group_1 unknown
               db 065h, 0c0h, 040h, 0c0h
           label _group_2 unknown
               db 0c0h, 040h, 063h, 0c0h, 061h, 0c8h
               dw offset ice_indirect
           label _group_3 unknown
               db 0c0h, 0c0h, 065h, 040h
           label _group_4 unknown
               db 0c0h, 0c0h, 063h, 0c8h
               dw offset ice_indirect
               db 0c0h, 040h
           label _group_5 unknown
               db 065h, 0c0h, 040h, 040h
           label _group_6 unknown
               db 064h, 0c0h, 040h, 0c0h, 040h
           label _group_7 unknown
               db 063h, 040h, 063h, 0c0h
   ends ice_tables_struc
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   align 4
   ice_tables ice_tables_struc <>
   align 4
   ice_normal_layout ice_normal_layout_struc <>
   align 4
   ice_extended_layout ice_extended_layout_struc <>
   align 4
   ice_groups_layout ice_groups_layout_struc <>
   align 4
   ice_immediates_table ice_immediates_table_struc <>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   align 4
   ice_reg ice_register_struc <>
   align 4
   ice_internal_stack ice_stack_struc <> ;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
   align 4
    
   ice_indirect_saved dd 0
   label ice_overrides dword
       ice_repeat_override  db 0
       ice_segment_override db 0
       ice_address_override db 0
       ice_operand_override db 0
    
   ice_current_opcode dw 0
   ice_opcode_length dw 0
   ice_original_ip dw 0
   ice_handler dw 0
   ice_cs_swapped db 0
   ice_communication db 0
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
; datas used to load the program in memory
param_block dw 24h dup(0)      ; block parameters to read the source file
ProgName db 256 dup (0)        ; program source name

; options line for program to load
OptionLine db 100 dup(0dh)    ; only line return

; miscs messages
;)
masm ;))
even ;)
dw 'jm'
dw 0babeh ;)
dw $DebutProgTxt ;)
DebutProgTxt equ $ ;))
db 13,10 ;> 10 is a must?!:p
db '/------------------------------------------------------------------\',13,10
db "| iCEuNP v0.3.4 Intel Complex Emulator exe/com UNPacker (free use) |",13,10
db "| open source 1999 ~ 2000, Coders: JauMing Tseng, Christoph Gabler |",13,10
db "|   email contact: <jauming@yahoo.com> <ChristophG1@Hotmail.Com>   |",13,10
db '\------------------------------------------------------------------/',13,10
db 0dh, 0ah, "$"
$DebutProgTxt equ ($-DebutProgTxt)
ideal
;))

UsageTxt db  "usage: iCEuNP [options] <source file name>",0dh, 0ah
         db " 0.2.8: added option /blind = no cs:ip prompt while tracing",13,10
         db " 0.2.9: added stuff for fse55s, not finished,though:q",13,10
         db " 0.3.0: workAround#2iceBug: added stuff for comprot:q",13,10
         db " 0.3.1: added stuff for rcc286v1.12mild, rc386v0.51:q",13,10
         db " 0.3.2: improved entrypoint searcher (unpacks hs119 exe&com)",13,10
         db " 0.3.3: bt/btr tricks bypassed (unpacks mess 1.31 exe&com)",13,10
         db " 0.3.4: jmt: initialize registers as DOS before emulating",13,10

         db "$"

Stage1Txt db "Stage 0 : source file analysis",0dh, 0ah ;>
	  db "-  - --===============-- -  -",0dh, 0ah, "$"
TxtOldFileStruct db "  Structure : $" ;>
FileSizeTxt      db "  Size      : $"
TxtCOMFileStruct db "COM",0dh, 0ah, "$" ;>
TxtEXEFileStruct db "EXE ", "$" ;>
StructureDonneesTxt db "Datas",0dh, 0ah, 0dh, 0ah, "$"
TailleHeaderTxt db  "Header = $"
TailleCodeTxt db    " , Code = $"
TailleOverlayTxt db " , Overlay = $" ;>

Stage2Txt db 0dh, 0ah, "Stage 1 : Unpacking/Searching for entry point..."
          db 0dh, 0ah, "-  - --========-- -  -",0dh, 0ah, "$"

Stage3Txt db 0dh, 0ah, "Stage 2 : Unpacking/Analyzing the method of packing..."
          db 0dh, 0ah, "-  - --========-- -  -",0dh, 0ah, "$"
; miscs
ChaineVide db 16 dup(0) ;>     ; empty string
InstCount dw 0                 ; instructions numbers since the last
                               ; time the light state changed

; error messages
TxtErrorInProg db "Couldn't find decompression code",0dh, 0ah, "$"
;>TxtInt00Error db "An int 00h occured, program halted",0dh, 0ah, "$"
TxtCantRename db "Can not rename temporary file", 0dh, 0ah, "$"
TxtCantDelete db "Can not delete old file", 0dh, 0ah, "$"
;>TxtTrapInt db "IUP: Attempt to trap int $"
CarReturn db 0dh, 0ah, "$" ;>
;>TxtCallInt db "Call of int $"
; error messages
ErrorPasParamTxt   db "no parameters",0dh, 0ah, "$"
TxtInternalError   db "internal error",0dh, 0ah, "$"
TxtInvalidFormat   db "invalid exe/com format",0dh, 0ah, "$"
TxtCantProceed     db "can't unpack",0dh, 0ah, "$"
TxtLoadError       db "can't load file",0dh, 0ah, "$"
TxtCantCreate      db "can't create temporary file", 0dh, 0ah, "$"
TxtCantPmode       db "can't unpack file under protected mode!", 0dh, 0ah
                   db 'Please remove all memory manager! (emm386/qemm386..)'
                   db 13,10,"$"

; Infos on original file
FileSize dd 0                  ; total size
HeaderSize dd 0                ; size of the header
CodeSize dd 0                  ; size of the code
OverlaySize dd 0               ; size of the overlay

; EXE header
struc StructEnteteFichier
  Identificateur dw "ZM"
  LongFicMod dw 0         ; file length MOD 512
  LongFicDiv dw 0         ; file length DIV 512
  NbReloc dw 0            ; relocations numbers
  TailleHeader dw 0       ; hedear size in paragraphs
  ParMin dw 0             ; paragraphs minimal number
  ParMax dw 0ffffh        ; paragraph maximal number
  RegSS dw 0              ; initial SS
  RegSP dw 0              ; initial SP
  Checksum dw 0           ; EXE header checksum
  RegIP dw 0              ; initial IP
  RegCS dw 0              ; initial CS
  AdrRelocEXE dw 0
  NumOvl dw 0
  Sig db "iCE!"           ; a signature (might be another, just to align)
ends StructEnteteFichier

EntNouvFichier StructEnteteFichier <>     ; header copy of the original file
EntAncFichier StructEnteteFichier <>      ; header of the target file

; datas used to know size of program in memory
ParPSP dw 0  ;>                ; PSP paragraph of son
ParCode dw 0 ;>                ; paragraph where the code starts
;>070598
TempFile  db '?:\', 13 DUP (0) ;'1iceunp',0;>100 dup (0) ;> ; new filename ;>
TempFile2 db '?:\', 13 DUP (0)
tempCount db '1' ;>
;tmpfile  DB '?:\', 13 DUP (0) ;>070598
;>071198
oldpid dw ? ;>
;>071198
      ALIGN 2
RelocOfs dw 0               ; DO NOT split ....
RelocSeg dw 0               ; ... them
NumHandle dw 0              ; file handle
OldHAndle dw 0              ; handle of old file
NbreParEcrits dw 0          ; number of paragraph in code
FichierCree dw 0            ; 1 if destination file is already created

NbPrefix dw 0               ; number of prefixes found
Prefix dw 0                 ; code of the last prefix
SizeModRM dw 0              ; number of bytes used by the modR/M
TailleInstruction dw 0      ; numbers of bytes used by current instruction

; infos on new file ;>
AdrSup dd 0                    ; superior adress used
TailleCodeEcrit dd 0 ;>        ; sizeof the written code

; datas used for jumps
IsJump dw 0
AddrStartJmp dd 0              ; jump begin adress
RoutBegin dd 0                 ; adress in bytes where the routine starts

   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
ice_psp dw ? ;>
JtOpcode db 512 dup(1) ;> buffers for overlay copy ;>
real_cs dw ? ;>
real_ip dw ? ;>
real_ss dw ? ;>
real_sp dw ? ;>
check_cs dw ? ;>
check_psp dw ? ;>
check_psp0 dw ? ;>
real_found db 0 ;>
info_psp   db 13,   'Entry PSP = $' ;>
real_entry db 13,10,'Entry Point = $'
real_stack db 13,10,'Entry Stack = $'
entry_si   db 13,10,'Entry SI = $'
entry_di   db 13,10,'Entry DI = $'
entry_bxcx db 13,10,'Entry BX:CX = $'
old10 dd ? ;>
code10 dw ? ;> for trap ;>
old21 dd ? ;>>
check_opcode db ? ;>
real_size db 13,10,'Image Length : $'
writebody$ db '[iCEuNP.wRiTEbODY.oK]',13,10,'$'
;>
;makeexe_cs dw ? ;>           ;#28 block
;makeexe_ip dw ? ;>           ;
;makeexe_ss dw ? ;>           ;
;makeexe_sp dw ? ;>           ;
;makeexe_psp dw ? ;>          ;
;makeexe_size dd ? ;>         ;
;makeexe_dummy db 14 dup(1) ;>;
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
init_29h:
        push es
        mov ax,3510h
        int 21h
        mov [word ptr ds:old10],bx
        mov [word ptr ds:old10+2],es
        mov ax,[es:bx]              ;
        mov [word ptr ds:code10],ax ;save entry code for trap;>
        pop es
        ret
call_29h:
        push es bx ax     ;
        les bx,[cs:old10] ;
        mov ax,[cs:code10];
        mov [es:bx],ax    ;restore entry code for trap ;>
        pop ax bx es      ;
        ;
        push ax si di bp bx
        mov ah,0eh
        mov bx,7
      ; int 10h ;> hackstop will destroy int10h vector table
        pushf
        call [cs:old10]
        pop bx bp di si ax
        ret
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
init_21h:
        push es
        mov ax,3521h
        int 21h
        mov [word ptr ds:old21],bx
        mov [word ptr ds:old21+2],es
        pop es
        ret
call_21h:
        pushf
        call [cs:old21] ;> upstop will destroy int21h vector table?
        ret
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
; ............. SUBROUTINE: ice$SignMem$1b6d

proc ice$SignMem$1b6d   near ;>
                push es ;>
                ;>
                xor     [word ptr cs:_7F9h],1234h ;>
                mov     bx,0FFFFh;
                mov     ah,48h   ;
                int     21h      ;
                mov     ah,48h   ;get all mem
                int     21h      ;
                jc      short ice$1bbd
                push    ax
                xchg    dx,ax
                mov     ax,4711h ;> signature to know file size ;>
                cld
ice$1b9d:
                xor     di,di
                mov     es,dx; !!!es changed!!!
                inc     dx
                mov     cx,8 ;word unit,1 para
                rep     stosw;
                dec     bx
                jnz     ice$1b9d
                pop     es; !!!es changed!!!
                mov     ah,49h
                int     21h
ice$1bbd:
                xor     [word ptr cs:_7F9h],1234h ;>
                ;>
                pop es ;>
                retn
endp ice$SignMem$1b6d   ;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

; ............  SUBROUTINE: calcDumpSize$72b

proc calcDumpSize$72b           near ;>
                xor     bx,bx
 ; External Entry into Subroutine:
calcDumpSize$72d:
                mov     al,0BFh ;>>
                mov     cx,200h
loc_073C:
                repne   scasb
                jcxz    short loc_0784
                cmp     [byte ptr es:bx+di+2],0B9h ;>>
                jne     loc_073C
                mov     bx,[es:di]
 ; External Entry into Subroutine:
calcDumpSize$758: ;>
                xchg    dx,ax
                sub     ax,[word ptr ds:check_psp]; pass?'s psp ;>
                mov     cx,10h ;16,1 para
                mul     cx     ; dx:ax = reg * ax
                add     ax,bx
                adc     dx,0
                sub     ax,100h ;size of psp
                sbb     dx,0
                mov     [dumpSizeLo$667c],ax
                mov     [dumpSizeHi$667e],dx
                retn
loc_0784:
                mov     es,dx
                jmp     loc$dumps$17ea
endp calcDumpSize$72b       ;>

; ............. SUBROUTINE: scanSizeMark$78d

proc scanSizeMark$78d            near ;>
                lodsw
                dec     cx
                dec     cx
loc_0790:
                scasw
                jnz     short loc_079D
                push    di
                push    si
                push    cx
                repe    cmpsb ;> ds:si,cx,es:di,cld?
                pop     cx
                pop     si
                pop     di
                jz      short loc_07D5
loc_079D:
                dec     di ;>
                sti ;>
                cmp     di,0FFF0h
                jb      loc_0790
                mov     bx,es
                cmp     bx,9000h ;>seg
                ja      short loc_ret_07F6
                add     bx,0FFFh ;> add seg
                mov     es,bx; es changed!
                sub     di,0FFF0h ;> sub ofs
                jmp     short loc_0790
loc_07D5:
                add     di,cx
                mov     bx,di
                mov     dx,es
                call    calcDumpSize$758
                stc ;>
loc_ret_07F6:
                retn
endp scanSizeMark$78d        ;>
        ;>
_7f7h           dw      4711h ;#6 words
_7f9h           dw     (4711h xor 1234h);(5525h) ;>(5525h xor 1234h=4711h)
                dw      4711h
;> ...

; ............  SUBROUTINE: ice$dumps$17ea
proc ice$dumps$17ea    near ;>
loc$dumps$17ea: ;>>
                ;>
                push es ;>
                ;>
                push    cs;
                pop     ds;ds=cs
                ;>
                mov es,[ds:check_psp] ;> init for (scanSizeMark$78d)
                ;>
                xor     [word ptr ds:_7F9h],1234h
                xor     di,di
                mov     si,offset _7F7h ;> #6 magic bytes,#3 words
                mov     cx,6 ;??
                call    scanSizeMark$78d
                sub     [dumpSizeLo$667c],6
                sbb     [dumpSizeHi$667e],0
                xor     [word ptr ds:_7F9h],1234h ;>
                stc
                pop es ;>
                retn
endp ice$dumps$17ea  ;>
;
dumpSizeLo$667c dw      0 ;} double word
dumpSizeHi$667e dw      0 ;}
 ;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
;- outdec32 ------------------------------------------------------------------;
;****************************************************************             ;
;*procedure:                                                    *             ;
;*      OUTDEC32                                                *             ;
;*function:                                                     *             ;
;*      this procedure will put DX:AX'32 bit unsigned value     *             ;
;*             to screen                                        *             ;
;*usage:                                                        *             ;
;*      input  :DX:AX = value to put                            *             ;
;*              BH < 0 width |BH| left start                    *             ;
;*              BH = 0 don't put space char                     *             ;
;*              BH > 0 width |BH| right start                   *             ;
;*      call   :call outdec32                                   *             ;
;*      return :no,no register destroyed.                       *             ;
;*      note   :if number'width > |bh| then result=(input BH=0) *             ;
;****************************************************************             ;
                                                                              ;
proc outdec32       NEAR  ;>                                                  ;
            push    bp                                                        ;
            push    dx                                                        ;
            push    cx                                                        ;
            push    bx                                                        ;
            push    ax                                                        ;
            mov     bp,sp                    ;set bp for auto variable        ;
            sub     sp,10                    ;make auto variable in stack     ;
            push    bx                                                        ;
            mov     cx,0                     ; cx = char count                ;
top:                                                                          ;
            call    div10                    ;exec div10,till quotient=0      ;
            dec     bp                       ;bp point to next auto variable  ;
            mov     [bp],bl                  ;remainder in [bp]               ;
            inc     cx                       ; cx (char count)+1              ;
            cmp     dx,0                     ;                                ;
            jne     top                      ;test dx:ax quotient if 0        ;
            cmp     ax,0                     ;yes then leave,else continue    ;
            jne     top                                                       ;
                                                                              ;
            pop     bx                                                        ;
            cmp     bh,0                     ;test bh value                   ;
            jle     display$                 ; <= 0, left start,put number 1st;
            call    putspace                 ;otherwise put space first       ;
            mov     bh,0                                                      ;
display$:                                                                     ;
            push    cx                       ;keep char count in stack        ;
top2:                                        ;this part output digit          ;
            mov     dl,[bp]                                                   ;
            add     dl,'0'                                                    ;
            mov     ah,2                                                      ;
            int_21h
            inc     bp                                                        ;
            loop    top2                                                      ;
                                                                              ;
            pop     cx                       ;restore char count              ;
            cmp     bh,0                     ;test bh with 0                  ;
            jnl     exit_outdec32            ;>=0 mean no right space out     ;
            neg     bh                       ;                                ;
            call    putspace                 ;put space char                  ;
exit_outdec32:                                                                ;
            add     sp,10                    ;restore sp                      ;
            pop     ax                                                        ;
            pop     bx                                                        ;
            pop     cx                                                        ;
            pop     dx                                                        ;
            pop     bp                                                        ;
            ret                                                               ;
endp outdec32    ;>                                                           ;
;************************************************************                 ;
;*function:                                                 *                 ;
;*      this procedure exec 32 bit unsigned value div by 10 *                 ;
;*      and return quotient and remainder                   *                 ;
;*usage:                                                    *                 ;
;*      input  :DX:AX = value to div by 10                  *                 ;
;*      call   :call div10                                  *                 ;
;*      return :quotient in DX:AX ,remainder in BX          *                 ;
;************************************************************                 ;
proc div10          NEAR  ;>                                                  ;
            push    cx                    ;BX = dividen as unsigned expand &  ;
            mov     bx,0                  ;test value'high part,also remainder;
            mov     cx,32                 ;loop exec = bits of dividen        ;
            sub     bx,10                 ;try sub once                       ;
looptop_div10:                                                                ;
            test    bx,8000h              ;check test value' sign (+, -)      ;
            jz      positive                                                  ;
            shl     ax,1                  ;-:  (1) quotient'LSB = 0           ;
            rcl     dx,1                  ;    (2) dividend * 2               ;
            rcl     bx,1                  ;                                   ;
            add     bx,10                 ;    (3) + divisor = next test value;
            jmp     @@_div10_a ;; @f                                          ;
positive:                                                                     ;
            add     ax,1                  ;+:  (1) quotient'LSB = 1           ;
            shl     ax,1                  ;    (2) dividend * 2               ;
            rcl     dx,1                  ;                                   ;
            rcl     bx,1                  ;                                   ;
            sub     bx,10                 ;    (3) - divisor = next test value;
@@_div10_a:                                                                   ;
            loop    looptop_div10                                             ;
                                                                              ;
            test    bx,8000h              ;check last test value'sign (+,-)   ;
            jnz     negative                                                  ;
            add     ax,1                  ;+:quotient+1,remainder= test value ;
            jmp     @@_div10_b ;; @f                                          ;
negative:                                                                     ;
            add     bx,10                 ;-:let test value + divisor         ;
@@_div10_b:                               ;   to recover remainder            ;
            pop     cx                                                        ;
            ret                                                               ;
endp div10       ;>                                                           ;
                                                                              ;
;*********************************************                                ;
;*this procedure put space char              *                                ;
;*********************************************                                ;
proc putspace       NEAR ;>                                                   ;
            push    ax                                                        ;
            push    bx                                                        ;
            push    cx                                                        ;
            push    dx                                                        ;
            xchg    bh,bl                                                     ;
            xor     bh,bh                                                     ;
            sub     cx,bx                                                     ;
            jnl     exit1                                                     ;
            neg     cx                                                        ;
            jcxz    exit1                                                     ;
            mov     ah,2                                                      ;
            mov     dl,' '                                                    ;
@@_putspace:                                                                  ;
            int_21h
            loop    @@_putspace ;; @b                                         ;
exit1:                                                                        ;
            pop     dx                                                        ;
            pop     cx                                                        ;
            pop     bx                                                        ;
            pop     ax                                                        ;
            ret                                                               ;
endp putspace ;> ;;-----------------------------------------------------------;
;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
; ............. SUBROUTINE: _updateDump
proc _updateDump proc    ;>
                push    cs;
                pop     ds;ds=cs
                ;>
                mov     bx,[word ptr ds:check_psp]; (here)'s pass(2)'s (psp)
                mov     ax,[ds:real_ss]; ;>
                sub     ax,bx  ;ax-bx=(ss-psp)
                sub     ax,10h ;subtract size of psp
                mov     [head$ss$6798],ax
                mov     ax,[ds:real_sp] ;>
                mov     [head$sp$679a],ax
                mov     ax,[ds:real_cs] ;>
                sub     ax,bx
                sub     ax,10h
                mov     [head$cs$67a0],ax
                mov     ax,[ds:real_ip] ;>
                mov     [head$ip$679e],ax
                ;>
                mov     bx,[ds:check_psp0] ;> pass(1)'s (psp) for (reloDelta)
                mov     [word ptr ds:reloDelta$2400],bx
                add     [word ptr ds:reloDelta$2400],10h ;>
                ;
                mov     ah,9
                mov     dx,offset write$relo$ ;>  'Writing RelocationTable ... $'
                int     21h
                ;
                mov     ax,3C00h ;>
                xor     cx,cx
                mov     dx,offset cracked$exe;> ; (='unpackED.EXE'),69d8
                int     21h
                mov     [fhandle2$2412],ax
                xchg    bx,ax
                mov     ah,40h ;>
                mov     dx,offset exe$header$678a ;>header
                mov     cx,20h ;> #32
                int     21h

                mov     ax,3D02h
                xor     cx,cx
                mov     dx,offset Tempfile2 ;>dump2: '2iceunp' ;> 070598
                int     21h
                mov     [fhandle1$2410],ax
               ;x
 ;p OFF NOW :>  dec     [ds:TempFile] ; '2'-> (='1') ;> 070598
               ;x
                mov     ax,3D02h
                xor     cx,cx
                mov     dx,offset TempFile ;>dump1: '1iceunp' ;> 070598
                int     21h
                mov     [fhandle0$240e],ax

                push    cs;
                pop     es;es=cs=ds

                mov     [reloCmpPos$2404],0
loc_1E63:
                mov     bx,[fhandle0$240e]
                mov     cx,2000h ;> internal buffer ;< :p
                mov     dx,offset ice$buff1$241e
                mov     ah,3Fh
                int     21h
                mov     [reloBuffer$2402],ax
                mov     bx,[fhandle1$2410]
                xchg    cx,ax
                mov     dx,offset ice$buff2$442e
                mov     ah,3Fh
                int     21h
                xchg    cx,ax
                mov     si,offset ice$buff1$241e
                mov     di,offset ice$buff2$442e
                add     si,[reloCmpPos$2404]
                add     di,[reloCmpPos$2404]
                sub     cx,[reloCmpPos$2404]
                cld
loc_1ED0:
                repe    cmpsb ;es=ds=cs
                jz      short no$Relo$1f47
                ;
                mov     ax,si
                dec     ax
                sub     ax,offset ice$buff1$241e;!(241Eh) ;>
                mov     dx,[reloPos$hi$2408]
                add     ax,[reloPos$lo$2406]
                adc     dx,0
                shl     dx,0Ch
                mov     [relo$lo$240a],ax
                mov     [relo$hi$240c],dx
                push    cx
                mov     bx,[fhandle2$2412]
                mov     cx,4 ;> relocations
                mov     dx,offset relo$lo$240a
                mov     ah,40h
                int     21h
                inc     [relo$count$6790]
                pop     cx
                inc     si
                inc     di
                dec     cx
                jz      short no$Relo$1f47
                jns     loc_1ED0
                mov     [reloCmpPos$2404],1
                jmp     short loc_1F51
no$Relo$1f47:
                mov     [reloCmpPos$2404],0
loc_1F51:
                mov     ax,[reloBuffer$2402]
                add     [reloPos$lo$2406],ax
                adc     [reloPos$hi$2408],0
                cmp     ax,2000h ;> buffer size :p
                je      loc_1E63

                mov     ah,3Eh
                mov     bx,[fhandle1$2410]
                int     21h

                xor     dx,dx ;> prepare dx:ax
                mov     ax,[relo$count$6790] ;> relocation count
                mov     cx,4 ;> calc relocation size
                mul     cx ; dx:ax = reg * ax
                add     ax,20h ;> header size
                push    ax
                add     ax,0Fh
                adc     dx,0
                mov     cx,10h
                div     cx ; ax,dx rem=dx:ax/reg
                mov     [head$para$6792],ax
                pop     ax
                and     ax,0Fh
                jz      short header$ok$1fe4 ;> para unit ok
                ;
                mov     cx,10h ; para unit stuff..
                sub     cx,ax  ;
                mov     bx,[fhandle2$2412]
                mov     ah,40h ;>
                mov     dx,offset data_67CA ; (=' iCE iCE iCE')
                int     21h
header$ok$1fe4:
                mov     bx,[fhandle0$240e]
                call    ice$fseekBof$23ef
                ;
                mov     dx,offset write_exe ; (='Writing unpackED.EXE...')
                mov     ah,9
                int     21h
                ;
                mov     bx,[fhandle2$2412]
                xor     cx,cx
                mov     dx,20h
                call    ice$fseek$23f3
                mov     cx,[relo$count$6790]
                jcxz    short loc_203D
                jmp     short loc_2040
loc_203D:
                jmp     loc_2102
loc_2040:
                push    cx
                mov     ah,3Fh
                mov     bx,[fhandle2$2412]
                mov     cx,4 ;> relocations?
                mov     dx,offset relo$lo$240a
                int     21h

                mov     bx,[fhandle0$240e]
                mov     dx,[relo$lo$240a]
                mov     cx,[relo$hi$240c]
                shr     cx,0Ch
                call    ice$fseek$23f3
                mov     ah,3Fh
                mov     cx,2 ;>word unit
                mov     dx,offset reloBuffer$2402
                int     21h

                mov     ax,4201h ;> fseek (current-2)
                mov     cx,0FFFFh ;(-)
                mov     dx,0FFFEh ;(-2) ;>
                int     21h

                mov     ax,[word ptr ds:reloDelta$2400] ;>
                sub     [reloBuffer$2402],ax ;>
                mov     ah,40h
                mov     cx,2
                mov     dx,offset reloBuffer$2402
                int     21h
                pop     cx
                loop    short locloop_20FF

                jmp     short loc_2102
locloop_20FF:
                jmp     loc_2040
loc_2102:
                mov     bx,[fhandle2$2412]
                call    ice$fseekEof$23df
                mov     bx,[fhandle0$240e]
                call    ice$fseekBof$23ef
loc_212C:
                mov     ah,3Fh
                mov     bx,[fhandle0$240e]
                mov     cx,2000h
                mov     dx,offset ice$buff1$241e
                int     21h
                push    ax
                xchg    cx,ax
                mov     ah,40h
                mov     bx,[fhandle2$2412]
                mov     dx,offset ice$buff1$241e
                int     21h
                pop     ax
                cmp     ax,2000h
                je      loc_212C

                mov     ah,3Eh
                mov     bx,[fhandle0$240e]
                int     21h

                mov     bx,[fhandle2$2412]
                call    ice$fseekEof$23df
                push    dx
                push    ax
                mov     cx,200h
                div     cx ; ax,dx rem=dx:ax/reg
                or      dx,dx
                jz      short loc_21B8
                inc     ax
loc_21B8:
                mov     [size$page$678e],ax
                mov     [size$rem$678c],dx
                mov     ax,[min$para$6794]
                mov     cx,10h
                mul     cx ; dx:ax = reg * ax
                add     ax,[ovl$pos$lo2418]
                adc     dx,[ovl$pos$hi241a]
                pop     cx
                sub     ax,cx
                pop     cx
                sbb     dx,cx
                jnc     short loc_21F0
                xor     ax,ax
                cwd
                jmp     short loc_21FB
loc_21F0:
                mov     cx,10h
                div     cx ; ax,dx rem=dx:ax/reg
loc_21FB:
                mov     [min$para$6794],ax
                ;
                call    ice$fseekBof$23ef
                ;
                mov     ah,40h
                mov     cx,20h ;#32
                mov     dx,offset exe$header$678a ;>
                int     21h
                ;
                cmp     [byte ptr copy$ovl$241c],0 ;>
                je      loc_22FD
                ;
                mov     dx,offset data_69E9 ; (='writing overlay...')
                mov     ah,9
                int     21h
                ;
                call    ice$fseekEof$23df
                ;
                mov     ax,3D00h
                xor     cx,cx
                mov     dx,offset ProgName;!str$66ab ;!(data_66A2+9) ;>
                int     21h
                mov     [fhandle0$240e],ax
                xchg    bx,ax
                mov     dx,[ovl$pos$lo2418]
                mov     cx,[ovl$pos$hi241a]
                call    ice$fseek$23f3 ;> in [cx:dx]
copy$ovl$loop$2298:
                mov     ah,3Fh
                mov     bx,[fhandle0$240e]
                mov     cx,2000h ;> buffer size
                mov     dx,offset ice$buff1$241e
                int     21h

                push    ax
                xchg    cx,ax
                mov     ah,40h
                mov     bx,[fhandle2$2412]
                mov     dx,offset ice$buff1$241e
                int     21h
                pop     ax
                cmp     ax,2000h ;> buffer size
                je      copy$ovl$loop$2298

                mov     ah,3Eh
                mov     bx,[fhandle0$240e]
                int     21h
loc_22FD:
                mov     ah,3Eh
                mov     bx,[fhandle2$2412]
                int     21h
;>del #2 dump files 070598
                mov     dx,offset TempFile  ;> del dump1
                call    ice$delFile$23d4
                mov     dx,offset TempFile2 ;> del dump2
                call    ice$delFile$23d4

                mov     dx,offset finished$ ;>Finished.
loc_23CB:
             ;p mov     ah,9
             ;p int     21h
                call    $$print ;))

                retn
endp _updateDump       ;>

; ............  SUBROUTINE: ice$delFile$23d4
proc ice$delFile$23d4   proc   ;>
                mov     ah,41h ;>delfile
                xor     cx,cx
                int     21h
                retn
endp ice$delFile$23d4      ;>

; ............  SUBROUTINE: ice$fseekEof$23df
proc ice$fseekEof$23df  proc   ;>
                mov     ax,4202h ;> fseek to eof
                cwd ;> zero dx
                xor     cx,cx
                int     21h
                retn
endp ice$fseekEof$23df       ;>

; ............. SUBROUTINE: ice$fseekBof$23ef
proc ice$fseekBof$23ef  proc   ;>
                xor     cx,cx
                xor     dx,dx
; (External Entry into Subroutine)
ice$fseek$23f3:
                mov     ax,4200h
                int     21h
                retn
endp ice$fseekBof$23ef      ;>
 ;>
reloDelta$2400  dw      0 ;>
reloBuffer$2402 dw      0 ;>
 ;>
reloCmpPos$2404 dw      0 ;>
 ;>
reloPos$lo$2406 dw      0 ;
reloPos$hi$2408 dw      0 ;
 ;>
relo$lo$240a    dw      0 ; relocation item unit, double word.
relo$hi$240c    dw      0 ;
 ;>
fhandle0$240e   dw      0 ;>
fhandle1$2410   dw      0 ;>
fhandle2$2412   dw      0 ;>
 ;>
fEof$lo$2414    dw      0
fEof$hi$2416    dw      0
 ;>
ovl$pos$lo2418  dw      0
ovl$pos$hi241a  dw      0
 ;>
copy$ovl$241c   db      0 ;> flag, init0 ;>> ;>
 ;>
ice$buff1$241e  db      'Error: ',7;('Fehler:',7) ;> [#8!] string ;#8208
ice$buf1a$2426  db      0Dh, 0Ah, 0Ah, 0Ah                        ;#2010h
                db      'this space intentionally left blank ...' ;
                db      0Dh, 0Ah, 0Ah, 0Ah                        ;
 _2455_         db      8153 dup (0) ;> 2455-37=241e, #8208,#2010h;
 ;>
ice$buff2$442e  db      8208 dup(0) ;> 2010h
 ;>
;)
masm ;))
even ;)
dw 'jm'
dw 0babeh ;)
dw $finished$ ;)
finished$ equ $ ;))
db      13,10 ;>
db      'Finished(Fertig).'
db      8 dup(32)
db      '"Trust me, You can make it!!!"$' ;> better: "Remember: iCEuNP rULES!"
$finished$ equ ($-finished$)
ideal
;))
 ;> ...
exe$header$678a db      'MZ' ;> #20h block
size$rem$678c   dw      0
size$page$678e  dw      0
relo$count$6790 dw      0 ;>
head$para$6792  dw      0
min$para$6794   dw      0
max$para$6796   dw      0FFFFh
head$ss$6798    dw      0
head$sp$679a    dw      0
chksum$679c     dw      0 ;>>
head$ip$679e    dw      0
head$cs$67a0    dw      0
relo$ofs$67a2   dw      20h ;>>
ovl$num$67a4    dw      166h ;> ice v166d
stuff$67a6      db      ' iCE' ;>>
 ;> ...
data_67CA       db      ' iCE iCE iCE';#12 ;> para unit stuff...
 ;> ...
;write$relo$    db      0Dh, 0Ah, 'Schreibe Relokationstabelle ... $'
write$relo$     db      0Dh, 0Ah, 'Writing RelocationTable ... $'

write_exe       db      0Dh, 0Ah, 'Writing(Schreibe) ' ;> block
cracked$exe     db      'unpackED.EXE', 0, '... $' ;> block
 ;>
write_com       db      0Dh, 0Ah, 'Writing(Schreibe) ' ;> block
unpacked$com    db      'Unpacked.COM',0 ,'... $' ;> block
 ;>
data_69E9       db      13,10,'Writing(Schreibe) Overlay ... $'
 ;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
;
; SUBROUTINE: setOwnInt_611
;
proc setOwnInt_611   proc    ;>
                pusha ;> .286
                push    ds
                push    es

                push    0
                pop     ds ;ds=0

                push    cs
                pop     es ;es=cs

                xor     si,si ;init faked int vector table
                mov     di,offset own_inttab_ee4 ;>
                mov     cx,100h ;>]
                cld ;>
                rep     movsd ;>

                xor eax,eax ;>prepare (eax) ;>
                mov     ax,cs
                shl     eax,4   ; 66| C1 E0 04
                ;>
                xor     edx,edx ; 66| 33 D2

                mov     dx,offset own_inttab_ee4;!0EE4h ;ofs??ya!
                add     eax,edx ;> 66| 03 C2
                mov     [dword ptr cs:intDesTab_edc+2],eax ;> 66| 2E: A3 0EDE
                lidt    [fword ptr cs:intDesTab_edc]  ; Load int des(description) table
                ;> later 2nd lidt will restore 0:0's
                mov     [dword ptr cs:intDesTab_edc+2],0 ;> 66| 2E: C7 06 0EDE + 00000000
                ;> later 2nd lidt will restore 0:0's
                pop     es
                pop     ds
                popa ;> .286
                retn
endp setOwnInt_611   ;>

own_inttab_ee4  dd      (100h) dup ('1234') ;> faked inttab ;512#w

intDesTab_edc   dw      3FFh, 0 ;0-3ff=#400h;
                dd      ?                   ;
port21 db ? ;>
porta1 db ? ;>
fileType db ? ;>1=com,2=exe ;>
oldfiletype db ? ;>1=com,2=exe ;>switch ;>
entry_flag db -1 ;>
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
TSREnd db 0                    ; end of memory occupied by the TSR
   ; =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

   ends ice
       end ice_setup

