#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include "pftw.h"

#define VER_1		1
#define VER_2		2
#define VER_2_3		3
#define VER_2_10	4

void CleanExit(int code);
void InitPackage(char* filename);
void ExtractPassword();
void DecryptInstData(LPBYTE pInstData, DWORD cbInstData);
void DecryptInstData2(LPBYTE pInstData, DWORD cbInstData);
void FindPassword2(char* buf);
int FindPassword2_3(char* buf);

// Utils
void Usage();
HANDLE OpenForRead(LPSTR filename);
void ReadFrom(HANDLE hFile, LPVOID pBuf, DWORD cbRead);

// Errors
void CantReadFile(int code);
void CantOpenFile(LPSTR filename);
void NotPFTW();
void InvalidPackage();
void NoMemory();
void FileNotWindows();
void BrokenPackage();
void WrongVersion();
void WindowsError();
void ImpossibleToFind();
void VersionProblem();

// Some useful globals
HANDLE hPackage = NULL;
LONG ofsCabData = 0;
LONG FileLen = 0;
LONG PackLen = 0;
LPSTR exename = NULL;
LPBYTE pInstData = NULL;
DWORD Version = 0;
LPVOID pVerBuf = NULL;

#define PWD_HASH_MASK	0xf801e01f
int MaxSearchLevel = 0;
char PwdBuf[200];
unsigned char InterBuf[4];
DWORD* pCryptTable = NULL;
MSCABHEADER CabHdr;
BOOL bIsRealPwd = FALSE;
char buf[65536];

void main(int argc, char* argv[])
{
	fprintf(stderr, "PackageForTheWeb Password Xtractor\nVersion 3.0 -] fOSSiL - 2000 [-\n(for versions from 1.0 upto and including 3.0)\n\n");
	exename = argv[0];

	if (argc != 2)
		Usage();
	
	InitPackage(argv[1]);
	ExtractPassword();

	CleanExit(0);
}

void PrintQuotedPassword(char* pwdstr)
{
	fprintf(stderr, "\nFound suitable password : \"");
	fprintf(stdout, "%s", pwdstr);
	fprintf(stderr, "\" (with no outer quotes)\n");
}

void ExtractPassword()
{
	PFTWDATAHEADER DataHdr;
	LPPFTWINSTDATA pDataHdr;
	DWORD i, InstDataSize;
	BYTE Id = 0xff;
	BOOL bPwdFound;

	SetFilePointer(hPackage, ofsCabData, NULL, FILE_BEGIN);
	switch (Version) {
		case VER_1:
			ReadFrom(hPackage, &DataHdr, sizeof(DataHdr));
			InstDataSize = DataHdr.cbInstData;
			// file pointer is positioned over InstData
			break;
		case VER_2:
		case VER_2_3:
		case VER_2_10:
			ReadFrom(hPackage, &InstDataSize, sizeof(InstDataSize));
			// file pointer is positioned over InstData
			break;
		default:
			InvalidPackage();
	}

	if ( !(pInstData = LocalAlloc(LMEM_FIXED, InstDataSize)) )
		NoMemory();
	ReadFrom(hPackage, pInstData, InstDataSize);

	switch (Version) {
		case VER_2_10:
		case VER_2_3:
			// file ptr is rite over the begining of package
			ReadFrom(hPackage, &CabHdr, sizeof(CabHdr));
			// and apply both descramblers
			DecryptInstData2(pInstData, InstDataSize);
		case VER_1:
		case VER_2:
			DecryptInstData(pInstData, InstDataSize);
	}
	
	pDataHdr = (LPPFTWINSTDATA)pInstData;
	if (strncmp(pDataHdr->Tag, PFTW_INSTTAG, lstrlen(PFTW_INSTTAG)) != 0)
		WrongVersion();
	// may change later on
	PackLen = ((DWORD*)pInstData)[1];
	i = sizeof(PFTWINSTDATA) + pDataHdr->cDWORDS * sizeof(DWORD);

	while (i < InstDataSize && Id != PFTW_ID_PASSWORD) {
		Id = pInstData[i];
		i += sizeof(Id);
		
		if (Id == 0x12)
			i += sizeof(DWORD);
		else if (Id & 0x80) {
			Id &= 0x7f;
			i += sizeof(BYTE);
		} else {
			WORD Len;

			Len = *(WORD*)(pInstData + i);
			i += sizeof(WORD);
			strncpy(buf, pInstData + i, Len);
			buf[Len] = '\0';
			i += Len;
		}
	}
	if (Id != PFTW_ID_PASSWORD) {
		fprintf(stderr, "\nPlaying games with me, huh ? No password found\n");
		return;
	}
	
	// default
	bPwdFound = TRUE;

	switch (Version) {
		case VER_1:
			bIsRealPwd = TRUE;
			break;
		case VER_2:
			FindPassword2(buf);
			break;
		case VER_2_3:
		case VER_2_10:
			bPwdFound = FindPassword2_3(buf);
	}
	if (bPwdFound) {
		if (bIsRealPwd) {
			fprintf(stderr, "\nInstallation password : ");
			fprintf(stdout, "%s\n", buf);
		} else {
			PrintQuotedPassword(buf);
		}
	} else {
		fprintf(stderr, "No definite password found.\n");
	}
}

void FindPassword2(char* buf)
{
	DWORD pwd;
	int i, cnt, mod;

	// undo all stupid steps
	sscanf(buf, "%x", &pwd);
	pwd = ((pwd ^ 0x51993) - 0xf143ac) / 2;

	if (pwd < 32)
		ImpossibleToFind();

	cnt = pwd / 65;
	mod = pwd % 65;
	if (mod < 48) {
		cnt--;
		mod += 65;
	}
	for (i = 0; i < cnt; i++)
		buf[i] = 'A';
	buf[i++] = mod;
	buf[i] = 0;
}

int VerifyKey2_3(int lvl, DWORD Hash)
{
	int i;
	BYTE xc;

	Hash = (Hash >> 8) ^ pCryptTable[InterBuf[3]];
	
	for (i = 2; i >= 0; i--, lvl++) {
		xc = (BYTE)Hash ^ InterBuf[i];
		if (xc < 32 || xc > 127)
			return FALSE;
		Hash = (Hash >> 8) ^ pCryptTable[InterBuf[i]];
		PwdBuf[lvl] = xc;
	}
	return TRUE;
}

int SearchKey2_3(int lvl, DWORD Hash)
{
	int i;
	//BYTE xc;

	for (i = 33; i < 127; i++) {
		if (((BYTE)Hash ^ i) == InterBuf[3] && VerifyKey2_3(lvl + 1, Hash)) {
			PwdBuf[lvl] = i;
			return TRUE;
		}
	}
	
	if (lvl > MaxSearchLevel)
		return FALSE;

	for (i = 33; i < 127; i++) {
		if (SearchKey2_3(lvl + 1, (Hash >> 8) ^ pCryptTable[(BYTE)Hash ^ i])) {
			PwdBuf[lvl] = i;
			return TRUE;
		}
	}
	
	if (_kbhit()) {
		fprintf(stderr, "\nAbort signaled... Pulling a scalpel out... Abortion successful =)\n");
		CleanExit(20);
	}

	return FALSE;
}

int GuessPassword2_3(int lvl, DWORD Hash, DWORD HashMask)
{
	int i;
	DWORD mHash = Hash & 0xff000000;
	DWORD CryptVal;
	DWORD NewHash;

	if (lvl > 3)
		return SearchKey2_3(0, 0xffffffff);

	for (i = 0; i < 0x100; i++) {
		// adjust CryptVal for data-loss at the final stage
		CryptVal = pCryptTable[i] & HashMask;
		if (mHash == (CryptVal & 0xff000000)) {
			// possible char found
			InterBuf[lvl] = i;
			NewHash = (Hash ^ CryptVal) << 8;
			if (GuessPassword2_3(lvl + 1, NewHash, (HashMask << 8) | 0xff))
				return TRUE;
		}
	}
	return FALSE;
}

int DecryptPassword2_3(char* buf, int declen)
{
	MSCABHEADER DecCabHdr = {PFTW_CABTAG, 0, PackLen, 0, 0x2c, 0, 0x00010103, 9};
	unsigned char* pDec = (char*)&DecCabHdr;
	unsigned char pEnc[sizeof(CabHdr)];
	unsigned char CryptStr[4] = {0x13, 0x35, 0x86, 0x07}; //0x07863513
	int i, plen;
	unsigned char xc;

	memcpy(pEnc, &CabHdr, sizeof(CabHdr));

	for (i = 0; i < declen; i++) {
		xc = (pEnc[i] >> 4) | (pEnc[i] << 4);
		pDec[i] = ~pDec[i] ^ xc;
	}

	for (plen = 1; plen <= declen; plen++) {
		for (i = 0; i < declen; i++)
			pEnc[i] = pDec[i] ^ CryptStr[(i % plen) % 4];
		if (strncmp(pEnc, pEnc + plen, declen - plen) == 0) {
			if (plen == declen) {
				// cannot verify it's the password
				pEnc[declen] = 0;
				fprintf(stderr, "Possible password (unverified): %s\n", pEnc);
				return FALSE;
			}
			// yay! password found!
			lstrcpyn(buf, pEnc, plen + 1);
			buf[plen] = 0;
			return TRUE;
		}
	}
	return FALSE;
}

int FindPassword2_3(char* buf)
{
	DWORD i, i2, hash, midhash;
	unsigned char pwd[4];
	// probability of good header decreases with every new field used
	// but 16 bytes have 100% probability
	// we'll try longer buffers first though
	int PwdBufLens[] = {28, 24, 16, 0}; // 0-term for safety
	int* pBufLen;

	// reverse the last hashing stage
	sscanf(buf, "%x", pwd);
	_swab(pwd, pwd, sizeof(pwd));
	*(DWORD*)pwd ^= 0x74747474;
	pwd[0] >>= 3;
	pwd[1] <<= 5;
	pwd[2] >>= 7;
	pwd[3] <<= 3;
	midhash = *(DWORD*)pwd;
	midhash = ~midhash & PWD_HASH_MASK;

	// build crypt table
	if ( !(pCryptTable = LocalAlloc(LMEM_FIXED, 0x100 * sizeof(DWORD))) )
		NoMemory();
	for (i = 0; i < 0x100; i++)	{
		hash = i;
		for (i2 = 0; i2 < 8; i2++)
			hash = hash & 1 ? (hash >> 1) ^ 0xedb88320 : hash >> 1;
		pCryptTable[i] = hash;
	}
	
	// attemp simple pwd decryption
	for (pBufLen = PwdBufLens; *pBufLen != 0 && !DecryptPassword2_3(buf, *pBufLen); pBufLen++)
		;
	if (*pBufLen != 0) {
		bIsRealPwd = TRUE;
		return TRUE;
	}

	// if all else fails - try guessing
	//fprintf(stderr, "Searching for a suitable password ... (Hit your 'puter to abort)");
	//for (i = 0; i < 100; i++) {
	//	fprintf(stderr, "\ngoing to depth %d ...", i + 5);
	//	MaxSearchLevel = i;
	//	if (GuessPassword2_3(0, midhash, PWD_HASH_MASK)) {
	//		fprintf(stderr, "\n");
	//		lstrcpy(buf, PwdBuf);
	//		return TRUE;
	//	}
	//}
	//fprintf(stderr, "\n");

	return FALSE;
}

void DecryptInstData(LPBYTE pInstData, DWORD cbInstData)
{
	DWORD i;
	BYTE al = 0x61;

	for (i=0; i < cbInstData; i++) {
		pInstData[i] ^= al;
		al++;
		if (al > 0x7a)
			al = 0x61;
	}
}

void DecryptInstData2(LPBYTE pInstData, DWORD cbInstData)
{
	DWORD i;
	BYTE al = 0x61;

	for (i=0; i < cbInstData; i++)
		pInstData[i] = ~((pInstData[i] >> 4) | (pInstData[i] << 4));
}

void Usage()
{
	LPSTR pName;
	pName = strrchr(exename, '\\');
	pName = pName ? pName + 1 : exename;
	fprintf(stderr, "Usage: %s <PFTWexefile>\n", pName);
	fprintf(stderr, "\n");
	CleanExit(100);
}

void CleanExit(int code)
{
	if (hPackage)
		CloseHandle(hPackage);
	if (pInstData)
		LocalFree(pInstData);
	if (pCryptTable)
		LocalFree(pCryptTable);
	if (pVerBuf)
		LocalFree(pVerBuf);
	exit(code);
}

BOOL TryGetVersion(LPSTR StrVerKey, LPSTR ScanForm, int* pv1, int* pv2)
{
	DWORD VerSize;
	DWORD *pLangs;
	LPSTR pStrVer;
	char buf[128];

	if (!VerQueryValue(pVerBuf, "\\VarFileInfo\\Translation", &pLangs, &VerSize))
		return FALSE;
	sprintf(buf, "\\StringFileInfo\\%04x%04x\\%s", LOWORD(*pLangs), HIWORD(*pLangs), StrVerKey);
	if (!VerQueryValue(pVerBuf, buf, &pStrVer, &VerSize))
		return FALSE;

	if (2 != sscanf(pStrVer, ScanForm, pv1, buf))
		return FALSE;
	if (strlen(buf) < 2)
		strcat(buf, "0");
	if (1 != sscanf(buf, "%d", pv2))
		return FALSE;

	return TRUE;
}

void InitPackage(char* filename)
{
	BYTE buf[0x200];
	PIMAGE_DOS_HEADER pMZ = (PIMAGE_DOS_HEADER)buf;
	PIMAGE_NT_HEADERS pPE = (PIMAGE_NT_HEADERS)buf;
	LPPFTWDATAHEADER pPDH = (LPPFTWDATAHEADER)buf;
	DWORD VerSize;
	DWORD whOfs;
	VS_FIXEDFILEINFO* pInfo;
	int v1, v2;

	hPackage = OpenForRead(filename);

	// attemp version detection based on VS_VERSION_INFO resource
	VerSize = GetFileVersionInfoSize(filename, &VerSize);
	if (VerSize == 0)
		NotPFTW();

	if ( !(pVerBuf = LocalAlloc(LMEM_FIXED, VerSize)) )
		NoMemory();
	if (!GetFileVersionInfo(filename, 0, VerSize, pVerBuf))
		VersionProblem();
	
	// had to switch to damned string parsing in v2.2
	// cauz InstallShield screwed me with their version resource
	// why does v2.04 report MinorVer=4 and v2.1 report MinorVer=1 ???
	//if (!TryGetVersion("Created With", "PackageForTheWeb %d.%[^. ]", &v1, &v2) &&
	//	!TryGetVersion("ProductVersion", "%d.%[^. ]", &v1, &v2))
	//	VersionProblem();

	if (!VerQueryValue(pVerBuf, "\\", &pInfo, &VerSize))
		WindowsError();
	
	v1 = HIWORD(pInfo->dwProductVersionMS);
	v2 = LOWORD(pInfo->dwProductVersionMS);
	
	// fix ins fuckup
	if (v1 == 2 && v2 == 1)
		v2 = 10;	// ver 2.1

	fprintf(stderr, "Package version %d.%02d\n", v1, v2);

	// some simple logic =)
	if (v1 == 1)
		Version = VER_1;
	else if (v1 == 2)
		if (v2 < 3)
			Version = VER_2;
		else if (v2 < 10)
			Version = VER_2_3;
		else
			Version = VER_2_10;
	else if (v1 > 2) {
		Version = VER_2_10;

		fprintf(stderr, "WARNING: Not tested with this version of PFTW, version 2.10+ assumed\n");
	
	} else
		WrongVersion();

	ReadFrom(hPackage, buf, 0x40);
	FileLen = GetFileSize(hPackage, NULL);
	
	if (FileLen < 0x40 || pMZ->e_lfanew < 0x40 || pMZ->e_lfanew > FileLen)
		FileNotWindows();

	whOfs = pMZ->e_lfanew;
	SetFilePointer(hPackage, whOfs, NULL, FILE_BEGIN);
	ReadFrom(hPackage, buf, sizeof(IMAGE_NT_HEADERS));

	if (pPE->Signature == IMAGE_NT_SIGNATURE) {
		PIMAGE_SECTION_HEADER pSec;
		DWORD SecSize;
		int i;
		
		SetFilePointer(hPackage, whOfs + FIELD_OFFSET(IMAGE_NT_HEADERS, OptionalHeader) + pPE->FileHeader.SizeOfOptionalHeader, NULL, FILE_BEGIN);
	
		SecSize = sizeof(IMAGE_SECTION_HEADER) * pPE->FileHeader.NumberOfSections;
		if (! (pSec = (LPVOID)LocalAlloc(LMEM_FIXED, SecSize)) )
			NoMemory();
		
		ReadFrom(hPackage, pSec, SecSize);

		if (Version == VER_1) {
			// look for _cabinet section first (Ver1)
			i = 0;
			while (i < pPE->FileHeader.NumberOfSections &&
				_strnicmp(pSec[i].Name, PFTW_DATASEG, sizeof(pSec[i].Name)) != 0)
					i++;
			
			if (i >= pPE->FileHeader.NumberOfSections)
				InvalidPackage();

			// this looks like Ver1 package
			ofsCabData = pSec[i].PointerToRawData;
			SetFilePointer(hPackage, ofsCabData, NULL, FILE_BEGIN);
			ReadFrom(hPackage, buf, sizeof(PFTWDATAHEADER));
			if (pPDH->Tag != PFTW_TAG)
				InvalidPackage();
		
		} else {
			// look for data Ver2 style
			DWORD PhysOfs = 0, PhysLen;
			PhysOfs = pSec[pPE->FileHeader.NumberOfSections - 1].PointerToRawData;
			PhysLen = pSec[pPE->FileHeader.NumberOfSections - 1].SizeOfRawData;
			ofsCabData = (PhysOfs + PhysLen + pPE->OptionalHeader.FileAlignment - 1) & -pPE->OptionalHeader.FileAlignment;
		}
			
		LocalFree(pSec);
		if (ofsCabData > FileLen)
			BrokenPackage();
			
		//ofsCabData += pPDH->ofsCabHdr + sizeof(PFTWDATAHEADER);
		//if (ofsCabData > FileLen)
		//	BrokenPackage();
	} else {
		NotPFTW();
	}

	//SetFilePointer(hPackage, ofsCabData, NULL, FILE_BEGIN);
	//ReadFrom(hPackage, &CabHdr, sizeof(CabHdr));
	//if (CabHdr.Tag != PFTW_CAB_TAG)
	//	NotPFTW();
	//if (ofsCabData + CabHdr.Length > FileLen)
	//	BrokenPackage();
}

void CantReadFile(int code)
{
	fprintf(stderr, "Can not read from file, error code %d\n", code);
	CleanExit(3);
}

void CantOpenFile(LPSTR filename)
{
	fprintf(stderr, "Could not open %s\n", filename);
	CleanExit(2);
}

void NotPFTW()
{
	fprintf(stderr, "This does not look like PackageForTheWeb file =)\nAre u sure u know what u are doing ?\n");
	CleanExit(4);
}

void InvalidPackage()
{
	fprintf(stderr, "Invalid or unsupported package file\n");
	CleanExit(9);
}

void ImpossibleToFind()
{
	fprintf(stderr, "Something is wrong - Impossible to find a password or unsupported version\n");
	CleanExit(21);
}

void BrokenPackage()
{
	fprintf(stderr, "Broken package file\n");
	CleanExit(19);
}

void NoMemory()
{
	fprintf(stderr, "Sorry, can not grab enough memory, giving up =)\n");
	CleanExit(6);
}

void FileNotWindows()
{
	fprintf(stderr, "Hmm...this file looks like a DOS exe\nIs there really PFTW for DOS ? =)\n");
	CleanExit(14);
}

void WrongVersion()
{
	fprintf(stderr, "Unsupported version or decryption problem\nSend me this file, plz...\n");
	CleanExit(15);
}

void VersionProblem()
{
	fprintf(stderr, "Cannot detect the version of PFTW used (possibly not PFTW at all)\n");
	CleanExit(16);
}

void WindowsError()
{
	DWORD Err = GetLastError();
	fprintf(stderr, "Error %d - No sane description available\n", Err);
	CleanExit(Err);
}

HANDLE OpenForRead(LPSTR filename)
{
	HANDLE hnd;

	hnd = CreateFile(filename,
					 GENERIC_READ,
					 FILE_SHARE_READ | FILE_SHARE_WRITE,
					 NULL,
					 OPEN_EXISTING,
					 FILE_FLAG_RANDOM_ACCESS,
					 NULL);
	
	if (hnd == INVALID_HANDLE_VALUE)
		CantOpenFile(filename);

	return hnd;
}

void ReadFrom(HANDLE hFile, LPVOID pBuf, DWORD cbRead)
{
	DWORD dwRead;

	if (!ReadFile(hFile, pBuf, cbRead, &dwRead, NULL) ||
		dwRead != cbRead)
		CantReadFile(GetLastError());
}
