; TITLE      : RecAV unpacker
; VERSION    : 1.0
; AUTHOR     : Christoph Gabler
; DATE       : 14.09.99
; PROG TYPE  : Simple int21 hooking unpacker
; REQUEST    : Unpacker was requested by Ralph Roth
; WORKS WITH : RecAV 1.02, 1.03 and more
; USED MUSIC : Megadeth [RISK]
; Updated    : 26.09.99 by Ralph, hearing Megadeth/Risk too :)

; ADDITIONAL INFORMATION :
; After writing the RecAV/RecSmall unpacker which was pretty ungeneric
; here comes a new generic RecAV unpacker which hooks INT21.
; The only ungeneric thing is the size detection. Now full 65KB+ support.


code segment
org  100h
assume cs:code,ds:code
.386p

CHRiSTOPH:

; The following mnemonics form together "CHRiSTOPH GABLER", personal sign
Inc Bx
Dec Ax
Push Dx
Imul Dx, [Bp+Di+54h], 504Fh      ; Reg modification, NOP
Dec Ax
Inc word ptr [Bx+41h]            ; BX always == 0 at runtime
Inc Dx
Dec Sp                           ; Of course no cli needed here
Inc Bp
Push Dx
Or Ax, 000Ah

Or Ax, 000Ah

Inc Sp                           ; Correct SP
Pop Dx                           ; Correct SP
Pop Dx                           ; Correct SP

Mov Ah, 9
Mov Dx, Offset screen
Int 21h

Xor Cx, Cx
Mov Cl, Ds:byte ptr [80h]
Cmp Cl, 0
Jne SyntaxOk

Mov Dx, Offset Errormsg4
Mov Ah, 9
Int 21h
Int 20h

FileError:
Mov Ah, 9
Mov Dx, Offset errormsg3
Int 21h
Int 20h

WriteError:
Mov Ah, 9
Mov Dx, Offset errormsg2
Int 21h
Mov Bp, 1234h
Mov Ah, 4Ch
Int 21h


SyntaxOk:
Xor Ax, Ax
Mov Di, 81h
Add Di, Cx
Stosb

Mov Dx, 82h
Mov Ax, 3D02h
Int 21h
Jc FileError
Mov Di, Ax

Mov Al, 2
Xor Cx, Cx
Xor Dx, Dx
Cwd
Mov Bx, Di
Mov Ah, 42h   ; Filepointer to end of file.
Int 21h
Mov DS:word ptr [FileSize], Ax
Mov DS:word ptr [FileSize+2], Dx

Mov Ax, 4200h ; Filepointer to begin.
Cwd
Xor Cx, Cx
Xor Dx, Dx
Mov Bx, Di    ; Save handle in BX
Int 21h

Mov Ebp, DS:dword ptr [FileSize]
Mov Si, Ds
ReadFile:
Mov Ah, 3Fh
Mov Bx, Di
Mov Dx, offset memoffset
Mov Cx, 2000h
Int 21h        ; Read whole file to CS:memoffset

;; --------------- REC/AV part --------------------------------------

Xor Bx, Bx
Mov Cx, 2000h
SeekLoop:
Cmp DS:dword ptr [memoffset+bx], '/CER'      ; REC/
Je RecAV_Ok
Inc Bx
Loop SeekLoop

Cmp Ebp, 2000h
Jbe FinishRead
Sub Ebp, 2000h
Jmp ReadFile
FinishRead:
Mov Ds, Si

Mov Ah, 3Eh
Mov Bx, Di
Int 21h
Mov Ah, 9
Mov Dx, Offset errormsg1
Int 21h
Int 20h

RecAV_Ok:

Mov Ax, 4200h ; Filepointer to begin.
Cwd
Xor Cx, Cx
Xor Dx, Dx
Mov Bx, Di    ; Save handle in BX
Int 21h

Mov Ah, 3Fh
Mov Dx, Offset memoffset
Mov Cx, 20h
Int 21h

Mov Ah, 3Eh
Mov Bx, Di
Int 21h

Mov Ds, Si
Mov Ah, 9
Mov Dx, Offset stage1
Int 21h

Mov Ax, 3521h
Int 21h
Mov DS:word ptr [Int21_Es], Es
Mov DS:word ptr [Int21_Bx], Bx
Push Cs Cs
Pop Es Ds

Mov Ax, 2521h
Mov Dx, offset Hooked
Int 21h

mov CS:[SaveSS], SS
mov CS:[SaveSP], SP
mov word ptr InfoBlock+2, 80h
mov word ptr InfoBlock+4, CS
mov word ptr InfoBlock+6, 5Ch
mov word ptr InfoBlock+8, CS
mov word ptr InfoBlock+10, 6Ch
mov word ptr InfoBlock+12, CS
mov AX, CS
cli
mov SS, AX
mov SP, offset StackStart
sti
mov BX, offset StackStart
mov AH, 4Ah
int 21h
push CS
pop ES
mov DX, 82h
mov BX, offset InfoBlock
mov BP, 66h
mov AX, 04B00h                          ;; exec
int 21h

cli
mov SS, CS:[SaveSS]
mov SP, CS:[SaveSP]
sti
push CS
pop  DS

Mov Ax, 2521h
Mov Dx, DS:word ptr [Int21_Bx]
Push DS:word ptr [Int21_Es]
Pop Ds
Int 21h
Push Cs
Pop Ds

Mov Ah, 9
Cmp Bp, 1234h
Je ShitHappened

Mov Dx, Offset stage2
Int 21h

.exit   0

ShitHappened:

mov dx, offset errormsg5
int     21h

.exit   1


Hooked:

Mov CS:word ptr [Save_Es], Es
Mov CS:word ptr [Save_Bx], Bx

Cmp Ah, 3Eh                                             ; fclose
Jne DoInt21

Mov CS:word ptr [Save_Es], Es

Mov Si, Es
Pop Bx ; IP
Pop Es ; CS
Push Es Bx

Cmp ES:dword ptr [Bx], 0FAC08C1Fh                       ; cs:ip == ??
Jne DoInt21

Push Cs
Pop Ds

Mov CS:word ptr [Save_Es2], Si

;Call CS:dword ptr [Int21_Bx]  ; Close open file first

; Create unpacked.exe
Mov Ah, 3Ch
Mov Dx, offset newfile
Xor Cx, Cx
Int 21h
Jc WriteError
Mov Di, Ax

; update header

;+19h
Pop Bx ; IP
Pop Ds ; CS
Add Bx, 19h

Mov Ax, DS:word ptr [Bx+6]       ; IP
Mov CS:word ptr [memoffset+14h], Ax  ; to header
Mov Ax, DS:word ptr [Bx+8]       ; CS
Mov CS:word ptr [memoffset+16h], Ax  ; to header
Mov Ax, DS:word ptr [Bx+0Ch]     ; SS
Mov CS:word ptr [memoffset+0Eh], Ax  ; to header
Mov Ax, DS:word ptr [Bx+0Ah]     ; SP
Mov CS:word ptr [memoffset+10h], Ax  ; to header
Push Cs
Pop Ds

; Image+2 and +4

Sub DS:dword ptr [FileSize], 150h+84h   ; - recsav adding size (important!)
aDD DS:dword ptr [FileSize], 32d        ; fix bug

Mov Cx, DS:word ptr [FileSize]
Mov Ax, Cx
Mov Dx, Cx
And Ah, 1                       ; mod 512
Mov Cl, 9                       ; 2**9 = 512
Shr Dx, Cl
Inc Dx

Mov DS:word ptr [memoffset+2], Ax

Mov Cx, DS:word ptr [FileSize+2]
Mov Bx, Cx
Imul Cx, 7Fh
Add Dx, Cx
Mov DS:word ptr [memoffset+4], Dx
Add DS:word ptr [memoffset+4], Bx
Mov CS:dword ptr [memoffset+1Ch], ' RHC'
sUB DS:dword ptr [FileSize], 32d  ; fix bug

Push Cs
Pop Ds

; write header to disk
Mov Ah, 40h
Mov Dx, Offset memoffset
Mov Cx, 20h
Mov Bx, Di
Int 21h
Jc WriteError

; write image to disk
Mov Dx, CS:word ptr [Save_Es2]
Add Dx, 10h
Mov Ds, Dx
Mov Ebp, CS:dword ptr [FileSize]

Mov Bx, Di
Xor Dx, Dx
Cmp Ebp, 2000h
Jbe LastWrite

WriteFile:
Mov Bx, Di
Xor Dx, Dx
Mov Cx, 2000h
Mov Ah, 40h      ; Write unpacked image to disk
Int 21h
Jc WriteError
Mov Ax, Ds
Add Ax, 200h
Mov Ds, Ax
Sub Ebp, 2000h

Cmp Ebp, 2000h
Jbe LastWrite
Jmp WriteFile
LastWrite:
Mov Bx, Di
Xor Dx, Dx
Mov Cx, Bp
Mov Ah, 40h      ; Last write to disk
Int 21h
Jc WriteError

Push Cs
Pop Ds

Mov Ah, 3Eh
Mov Bx, Di
Call CS:dword ptr [Int21_Bx]

Mov Ah, 4Ch
Int 21h

DoInt21:
Mov Bx, CS:word ptr [Save_Bx]
Mov Es, CS:word ptr [Save_Es]

db 0EAh
Int21_Bx    db 0,0
Int21_Es    db 0,0
filesize    db 0,0,0,0
screen      db 0Dh,0Ah,'--=[ RecAV 1.03 unpacker, coded by Christoph Gabler ]=------------------------',0Dh,0Ah
            db         'Written for Ralph Roth on 14.09.99 for the REC/AV & REC/SMALL package',0Dh,0Ah,0Dh,0Ah,'$'

errormsg1   db 0Dh,0Ah,'This file was not encrypted using REC/AV.',0Dh,0Ah,'$'
errormsg2   db 'Fatal error occoured: Error while trying to write to unpacked.exe!',0Dh,0Ah,7,'$'
errormsg3   db 'Could not find file.',7,'$'
errormsg4   db 'Usage: UNREC.COM FILE.EXE',0Dh,0Ah,'$'
errormsg5   db 'Fatal error occured: Could not find REC/AV startup code!',13,10,7,"$"
stage1      db ' REC/AV was found!',0Dh,0Ah,'$'
stage2      db ' Unpacking EXE image ...',0Dh,0Ah
stage3      db ' Done! Result was saved in UNPACKED.EXE',0DH,0AH,'$'

InfoBlock       dw      0
                dd      0
                dd      0
                dd      0
StackStart      equ $+500h
SaveSP          dw      0
SaveSS          dw      0
Save_Bx  db 0,0
Save_Es  db 0,0
Save_Es2 db 0,0
newfile db 'UNPACKED.EXE', 0

memoffset:

Code Ends
End CHRiSTOPH
