; TITLE      : SDW386 1.78 unpacker
; VERSION    : 1.0
; AUTHOR     : Christoph Gabler
; DATE       : 14.10.99
; PROG TYPE  : Double int21 unpacker
; WORKS WITH : Shadow Com Crypter (SDW) 1.78 by MantiC0re
; USED MUSIC : Slayer, Nirvana & Hammerfall

; ADDITIONAL INFORMATION :
; This new UNSDW386 version is able to unpack SDW 1.78 under all OS and
; memory managers. Please also take a look at "OLDUNP.ASM" for the trapflag
; version of this.
; Version 1.78 of SDW386 is really a lot better then previous versions
; because the new encryption sheme + crc check.

code segment
org  100h
assume cs:code,ds:code
.386p

Start:

Inc Sp           ; D
Push Sp          ; T
Inc Di           ; G
Or Ax, 660Ah     ; 0Dh,0Ah

Inc Sp           ; Correct stack

Call Logo

Xor Bx, Bx
Mov Bl, Ds:byte ptr [80h]
Cmp Bl, 0
Jne SyntaxOk

Mov Dx, Offset Errormsg4
Mov Ah, 9
Int 21h
Int 20h

FileError:
Mov Ah, 9
Mov Dx, Offset errormsg3
Int 21h
Int 20h

SyntaxOk:
Mov DS:byte ptr [81h+Bx], 0

Mov Ax, 3D02h
Mov Dx, 82h
Int 21h
Jc FileError
Mov Di, Ax

Mov Bx, Ax
mov al, 02
xor cx, cx
xor dx, dx
mov ah, 42h   ; Filepointer to end of file.
Int 21h       
Mov CS:word ptr [FileSize], Ax
Cmp Ax, 0
Je FileError

cwd
mov ax, 4200h                ; Filepointer to begin.
Xor Cx, Cx
Xor Dx, Dx
Mov Bx, Di
int 21h

Mov Ah, 3Fh
Mov Bx, Di
Mov Dx, 2100h
Mov Cx, CS:word ptr [FileSize]
Int 21h                      ; Read whole file to CS+2000h:100h

Mov Ah, 3Eh
Mov Bx, Di
Int 21h                      ; Close file handle

Mov Ax, Cs
Add Ax, 200h
Mov Es, Ax

; Search for SDW386 1.78
Mov Cx, CS:word ptr [FileSize]
Mov Bx, 100h
Search:
Cmp ES:dword ptr [Bx], 2074C333h
Je SDWFound
Inc Bx
Loop Search
Mov Ah, 9
Mov Dx, Offset errormsg2
Int 21h
Int 20h
SDWFound:

Xor Si, Si
Xor Di, Di
Mov Cx, 0FFh
REPZ                     ; Fake PSP (dos environment)
MOVSB                    ; Move CX bytes from DS:SI to ES:DI

Mov Ah, 9
Mov Dx, Offset stage1
Int 21h

; hook int21 + int1a
Push 0
Pop Ds
Mov Ax, DS:word ptr [4*21h]
Mov CS:word ptr [Old21], Ax
Mov Ax, DS:word ptr [4*21h+2]
Mov CS:word ptr [Old21_2], Ax
Mov DS:word ptr [4*21h], offset int21handler
Mov DS:word ptr [4*21h+2], Cs

Mov Ax, DS:word ptr [4*1Ah]                     ; int1a used for pmode bypass
Mov Bx, DS:word ptr [4*1Ah+2]
Mov CS:word ptr [Old1a], Ax
Mov CS:word ptr [Old1a+2], Bx
Mov DS:word ptr [4*1Ah], offset int1ahandler
Mov DS:word ptr [4*1Ah+2], Cs

Push Ds
Push Cs
Pop Ds
Mov Ah, 9
Mov Dx, Offset stage2
Int 21h
Pop Ds

; launch victim
Push Es Es    ; CS+2000h=ES=DS=SS
Pop Ds Ss
Push Ds       ; victim CS
Push 100h     ; victim IP
Retf

Int21Handler:
Cmp Ax, 3306h ; Check for hooked function
Jne NormalINT21

Mov CS:word ptr [DS_], Ds
Mov CS:word ptr [BX_], Bx

Pop Bx
Pop Ds
Push Ds Bx
Mov DS:word ptr [Bx+104h], 099CDh

Mov DS:word ptr [Bx+76h+6-83h], 0A766h   ; restore cmspd (because of crc)
Mov DS:word ptr [Bx+76h-83h], 0675h      ; restore jne   (because of crc)

; set int99 handler
Push 0
Pop Ds
Mov DS:word ptr [4*99h], offset int99handler
Mov DS:word ptr [4*99h+2], Cs

Mov Ds, CS:word ptr [DS_]
Mov Bx, CS:word ptr [BX_]
Iret         ; back to caller

NormalINT21:
Cmp Ah, 4Ch
Je restore
db 0EAh      ; JMP FAR [normal int 21h]
Old21 db 0,0
Old21_2 db 0,0
Old10 db 0,0,0,0

Int1aHandler:
Cmp Ah, 2
Jne Back
Cmp Di, Si
Jne Back
Mov CS:word ptr [BX_], Bx
Mov CS:word ptr [DS_], Ds
Push Ds
Push Cs
Pop Ds
Mov Ah, 9
Mov Dx, Offset stage3
Int 21h
Pop Ds
Pop Bx ;IP
Pop Ds ;CS
Push Ds Bx
Mov DS:word ptr [Bx+76h], 9090h      ; check if pm manager present
Mov DS:word ptr [Bx+76h+6], 9090h    ; cmspd (INT 0Dh will otherwise be exec)
Mov Bx, CS:word ptr [BX_]
Mov Ds, CS:word ptr [DS_]
Back:
db 0EAh
Old1a db 0,0,0,0
Iret

int99handler:

Push Cs
Pop Ds

Mov Ah, 9
Mov Dx, Offset success
Int 21h

Mov Ah, 3Ch                      ; Create file
Xor Cx, Cx
Mov Dx, offset outfile
Int 21h
Mov Di, Ax

Push Es
Pop Ds

; size detection loop
Mov Si, 100h
Mov Cx, CS:word ptr [FileSize]
sizeloop:
Cmp DS:dword ptr [Si], 9C9D53F0h ; String
Je Sizefound
Inc Si
loop sizeloop
Mov Cx, CS:word ptr [FileSize]
Jmp Write

Sizefound:
Sub Si, 110h                     ; Calculate orig size
Mov Cx, Si

Write:
Mov Ah, 40h                      ; Write file
Mov Dx, 100h
Mov Bx, Di
Int 21h

Mov Ah, 3Eh                      ; Close file
Mov Bx, Di
Int 21h

restore:
Push 0
Pop ds
; restore int21
Mov Ax, CS:word ptr [Old21]
Mov Bx, CS:word ptr [Old21+2]
Mov DS:word ptr [4*21h], Ax
Mov DS:word ptr [4*21h+2], Bx

; restore int1a
Mov Ax, CS:word ptr [Old1a]
Mov Bx, CS:word ptr [Old1a+2]
Mov DS:word ptr [4*1Ah], Ax
Mov DS:word ptr [4*1Ah+2], Bx

Mov Al, 0F4h
Out 60h, Al

Mov Ax, 4C00h
Int 21h

FileSize db 0,0
outfile db 'UNPACKED.COM',0
errormsg2   db 'ERROR: FiLE WAS NOT PROTECTED USiNG SDW386','$'
errormsg3   db 'ERROR: FiLE WAS NOT FOUND','$'
errormsg4   db 'USAGE: UNSDW386 [FILE_TO_UNPACK] ','$'
stage1      db '  UNPACKiNG FiLE',0Dh,0Ah,'$'
stage2      db '  PASSiNG INTERNAL ENCRYPTiON',0Dh,0Ah,'$'
stage3      db '  PASSiNG IMAGE DECRYPTOR',0Dh,0Ah,'$'
success     db '  UNPACKED.COM WRiTTEN AND DONE!',0Dh,0Ah,'$'

; save regs
BX_ db 0,0
DS_ db 0,0

; Display the unpacking screen (pcompile + disasm)
Logo:
		push	cs
		pop	ds
		jmp	short loc_1
data_1		db	7
data_2		db	0Dh, 0Ah, '$'
data_3		db	0FFh
		db	24h
loc_1:
		mov	si,offset data_3
loc_2:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_3			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_1
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_2
loc_3:
		mov	ah,9
		mov	dx,offset data_2	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_4
data_4		db	9
data_5		db	0Dh, 0Ah, '$'
data_6		db	20h
		db	0C4h
		db	40 dup (0C4h)
		db	24h
loc_4:
		mov	si,offset data_6
loc_5:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_6			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_4
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_5
loc_6:
		mov	ah,9
		mov	dx,offset data_5	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_7
data_8		db	0Fh
data_9		db	0Dh, 0Ah, '$'
data_10		db	20h
		db	0CDh
                db      5 dup (0CDh)
		db	 10h, 10h
                db      ' UNPACKER FOR SDW386 1.78 '
		db	 11h, 11h,0CDh
                db      4 dup (0CDh)
		db	24h
loc_7:
		mov	si,offset data_10
loc_8:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_9			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_8
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_8
loc_9:
		mov	ah,9
		mov	dx,offset data_9	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_10
data_13		db	0Fh
data_14		db	0Dh, 0Ah, '$'
data_15		db	20h
		db	0CDh
		db	40 dup (0CDh)
		db	24h
loc_10:
		mov	si,offset data_15
loc_11:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_12			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_13
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_11
loc_12:
		mov	ah,9
		mov	dx,offset data_14	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_13
data_17		db	0Fh
data_18		db	0Dh, 0Ah, '$'
data_19		dw	2020h, 2020h, 2020h
		db	 20h,0FFh
                db      '  Coded by CHRiSTOPH / DTG'
		db	0FFh
                db      6 dup (0FFh)
		db	24h
loc_13:
		mov	si,offset data_19
loc_14:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_15			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_17
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_14
loc_15:
		mov	ah,9
		mov	dx,offset data_18	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_16
data_21		db	9
data_22		db	0Dh, 0Ah, '$'
data_23		db	20h
		db	0C4h
		db	40 dup (0C4h)
		db	24h
loc_16:
		mov	si,offset data_23
loc_17:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_18			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_21
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_17
loc_18:
		mov	ah,9
		mov	dx,offset data_22	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_19
data_25		db	0Fh
data_26		db	0Dh, 0Ah, '$'
data_27		db	0FFh
		db	24h
loc_19:
		mov	si,offset data_27
loc_20:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
		je	loc_21			; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
		mov	bl,data_25
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
		jmp	short loc_20
loc_21:
		mov	ah,9
		mov	dx,offset data_26	; ('')
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		push	cs
		pop	ds
		jmp	short loc_22
data_28		db	7
data_29		db	0Dh, 0Ah, '$'
data_30		db	0FFh
		db	'USAGE: UNSDW386 [FILE_TO_UNPACK]'
		db	'$'
loc_22:

		push	cs
		pop	ds
                jmp     short abc_1
abcd_1          db      7
abcd_2          db      0Dh, 0Ah, '$'
abcd_3          dw      4 dup (0FFFFh)
		db	0FFh, 24h
abc_1:
                mov     si,offset abcd_3
abc_2:
		mov	al,cs:[si]
		inc	si
		cmp	al,24h			; '$'
                je      abc_3                   ; Jump if equal
		mov	ah,9
		xor	bx,bx			; Zero register
                mov     bl,abcd_1
		mov	cx,1
		int	10h			; Video display   ah=functn 09h
						;  set char al & attrib bl @curs
						;   cx=# of chars to replicate
		mov	ah,3
		xor	bx,bx			; Zero register
		int	10h			; Video display   ah=functn 03h
						;  get cursor loc in dx, mode cx
		inc	dl
		mov	ah,2
		int	10h			; Video display   ah=functn 02h
						;  set cursor location in dx
                jmp     short abc_2
abc_3:
		mov	ah,9
                mov     dx,offset abcd_2        ; ('')
		int	21h			; DOS Services  ah=function 09h
Ret


code ends
end start
