/** 
 * @namespace   biewlib
 * @file        biewlib/sysdep/generic/__config.h
 * @brief       This file provides autoconfiguring project for any architecture.
 * @version     -
 * @remark      this source file is part of Binary vIEW project (BIEW).
 *              The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.
 *              All rights reserved. This software is redistributable under the
 *              licence given in the file "Licence.en" ("Licence.ru" in russian
 *              translation) distributed in the BIEW archive.
 * @note        Requires POSIX compatible development system
 *
 * @author      Nick Kurshev
 * @since       2000
 * @note        Development, fixes and improvements
 * @warning     Project needs with following macros:
 *              __WORDSIZE (16, 32, 64 e.t.c)
 *              __BYTE_ORDER (__LITTLE_ENDIAN or __BIG_ENDIAN)
 *              __intXX_t family (like int8_t uint_least32_t e.t.c)
**/
#ifndef ____CONFIG_H
#define ____CONFIG_H

#include <endian.h>
#include <stdint.h>

#endif
