;kernel32.dll imports
extrn	LoadLibraryA:PROC
extrn	GetProcAddress:PROC

extrn	ExitProcess:PROC
extrn	CreateFileA:PROC
extrn	CloseHandle:PROC
extrn	GlobalAlloc:PROC
extrn	GlobalFree:PROC

extrn	GetCommandLineA:PROC
extrn	GetModuleHandleA:PROC
extrn	GetModuleFileNameA:PROC
extrn	GetFileTime:PROC
extrn	SetFileTime:PROC
extrn	GetFileSize:PROC
extrn	GetFileAttributesA:PROC
extrn	SetFileAttributesA:PROC
extrn	SetFilePointer:PROC
extrn	SetEndOfFile:PROC
extrn	DeleteFileA:PROC

;extrn	WriteFile:PROC
;extrn	ReadFile:PROC

;;shell32.dll imports
;extrn	Shell_NotifyIconA:PROC
;extrn	DragQueryFileA:PROC
;extrn	DragFinish:PROC


.data?
fncountpos	dd ?
fnhandlpos	dd ?
libhandle	dd ?

.code
DoImport	proc
	mov	fncountpos, offset fncounts
	mov	fnhandlpos, offset fnhandles
	xor	ecx, ecx
	mov	cl, libcount
	mov	esi, offset libnames
	mov	edx, offset fnnames
ilibs:
	pushad
	push	esi
	call	LoadLibraryA
	mov	libhandle, eax
	popad
	mov	ebx, libhandle

	push	ecx
	push	esi
	mov	esi, fncountpos
	lodsb
	mov	fncountpos, esi
	pop	esi
	xor	ecx, ecx
	mov	cl, al

	ifunc:
		pushad
		push	edx
		push	ebx
		call	GetProcAddress
		mov	edi, fnhandlpos
		stosd
		mov	fnhandlpos, edi
		popad
		push	ecx
		mov	edi, edx
		xor	al, al
		mov	cl, -1
		repne	scasb
		mov	edx, edi
		pop	ecx
		loop	ifunc

	mov	cl, -1
	xor	al, al
	mov	edi, esi
	repne	scasb
	mov	esi, edi

	pop	ecx	
	loop	ilibs
	ret
DoImport	endp

.data
libnames:
kernel32	db 'kernel32',0
shell32		db 'shell32',0
user32		db 'user32',0
advapi32	db 'advapi32',0
gdi32		db 'gdi32',0
comdlg32	db 'comdlg32',0
comctl32	db 'comctl32',0
libcount	equ 6;7

fncounts:
kernel32_count	db 2
shell32_count	db 3
user32_count	db 34
advapi32_count	db 7
gdi32_count	db 2
comdlg32_count	db 2
comctl32_count	db 1 ;we don't need any function from this library, we only need it to be loaded

fnnames:
kernel32_dll:
db 'WriteFile',0
db 'ReadFile',0

shell32_dll:
db 'Shell_NotifyIconA',0
db 'DragQueryFileA',0
db 'DragFinish',0

user32_dll:
db 'SetWindowPos',0
db 'IsWindowEnabled',0
db 'SetFocus',0
db 'GetFocus',0
db 'FindWindowA',0
db 'EnableWindow',0
db 'RegisterClassA',0
db 'MessageBoxA',0
db 'LoadIconA',0
db 'LoadCursorA',0
db 'CreateWindowExA',0
db 'DefWindowProcA',0
db 'ShowWindow',0
db 'PostMessageA',0
db 'SendMessageA',0
db 'GetMessageA',0
db 'DispatchMessageA',0
db 'TranslateMessage',0
db 'BeginPaint',0
db 'EndPaint',0
db 'PostQuitMessage',0
db 'CreateMenu',0
db 'SetMenu',0
db 'DrawMenuBar',0
db 'AppendMenuA',0
db 'EnableMenuItem',0
db 'CheckMenuItem',0
db 'ModifyMenuA',0
db 'SetWindowTextA',0
db 'GetWindowTextA',0
db 'SetForegroundWindow',0
db 'GetWindowRect',0
db 'GetClientRect',0
db 'DrawIcon',0

advapi32_dll:
db 'RegCreateKeyExA',0
db 'RegSetValueExA',0
db 'RegCloseKey',0
db 'RegOpenKeyExA',0
db 'RegDeleteKeyA',0
db 'RegQueryValueExA',0
db 'RegEnumKeyExA',0

gdi32_dll:
db 'CreateFontA',0
db 'GetStockObject',0

comdlg32_dll:
db 'GetOpenFileNameA',0
db 'GetSaveFileNameA',0

comctl32_dll: ;we don't need any function from this library, we only need it to be loaded



.data?
fnhandles:
h_kernel32_dll:
WriteFile		dd ?
ReadFile		dd ?

h_shell32_dll:
Shell_NotifyIconA	dd ?
DragQueryFileA		dd ?
DragFinish		dd ?

h_user32_dll:
SetWindowPos		dd ?
IsWindowEnabled		dd ?
SetFocus		dd ?
GetFocus		dd ?
FindWindowA		dd ?
EnableWindow		dd ?
RegisterClassA		dd ?
MessageBoxA		dd ?
LoadIconA		dd ?
LoadCursorA		dd ?
CreateWindowExA		dd ?
DefWindowProcA		dd ?
ShowWindow		dd ?
PostMessageA		dd ?
SendMessageA		dd ?
GetMessageA		dd ?
DispatchMessageA	dd ?
TranslateMessage	dd ?
BeginPaint		dd ?
EndPaint		dd ?
PostQuitMessage		dd ?
CreateMenu		dd ?
SetMenu			dd ?
DrawMenuBar		dd ?
AppendMenuA		dd ?
EnableMenuItem		dd ?
CheckMenuItem		dd ?
ModifyMenuA		dd ?
SetWindowTextA		dd ?
GetWindowTextA		dd ?
SetForegroundWindow	dd ?
GetWindowRect		dd ?
GetClientRect		dd ?
DrawIcon		dd ?

h_advapi32_dll:
RegCreateKeyExA		dd ?
RegSetValueExA		dd ?
RegCloseKey		dd ?
RegOpenKeyExA		dd ?
RegDeleteKeyA		dd ?
RegQueryValueExA	dd ?
RegEnumKeyExA		dd ?

h_gdi32_dll:
CreateFontA		dd ?
GetStockObject		dd ?

h_comdlg32_dll:
GetOpenFileNameA	dd ?
GetSaveFileNameA	dd ?

h_comctl32_dll: ;we don't need any function from this library, we only need it to be loaded
none_function		dd ?