//
// This dll will be loaded into the target's process memory and
// it'll build the API stubs which will inform the GUI about API calls.
//

#include <windows.h>
#include <stddef.h>
#pragma pack (1) // very important
#pragma comment(linker,"/FILEALIGN:0x200 /MERGE:.rdata=.text /MERGE:.data=.text /SECTION:.text,EWR /IGNORE:4078")

#define WM_APICALL  WM_USER+0x1000

// structs
typedef struct
{
	PIMAGE_DOS_HEADER     pDosh;
	PIMAGE_NT_HEADERS     pPeh;
	DWORD                 ImageBase;
	DWORD                 SizeOfImage;
} sPEInfo;

typedef struct
{
	CHAR DllName[8];
	int  iCheckSize;
} sDllSkipList;

typedef struct
{
	//BYTE   Int3;
	BYTE   byPushadOpc;   // 0x60 pushad
	BYTE   byPushOpc;     // 0x68 push (dword)
	DWORD  dwPushAddr;    // Api number
	BYTE   byCallOpc;     // 0xE8 call (dword)
	DWORD  dwCallAddr;    // address of "TrappedApiCall"
	BYTE   byPopadOpc;    // 0x61 popad
	BYTE   byJmpOpcApi;   // 0xE9 jmp (dword)
	DWORD  dwJmpApiAddr;  // jmp to the real Api function
} sApiStub;

// the functions
extern "C" VOID __stdcall TrappedApiCall(DWORD dwApiNum);
BOOL InitApiStubStruct(sApiStub &tmpApiStub);
BOOL BuildApiStub(DWORD* dwApiThunkAddr,DWORD dwApiNum);
BOOL HookApis();

// constants
const PSTR          SSDialogTitle        = "[ SoftSnoop 0.3 ] by yoda/f2f";
const PSTR          TRAPFUNCTION_NAME    = "TrappedApiCall";
const sDllSkipList  DllSkipList[]        = {{"MFC",3},{"MSVCRT",6}};
const int           DLLSKIPCOUNT         = 2;

// varialbes
PVOID                        pApiStubs,pApiStubMem;
HANDLE                       hDll;
HWND                         hSSDlg;
sPEInfo                      PEInfo;
PIMAGE_IMPORT_DESCRIPTOR     pIID;
DWORD                        *pDW;
sApiStub                     ApiStub;
DWORD                        dwTrapFunctAddr;


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  fdwReason, 
                       LPVOID lpReserved
					 )
{
	switch(fdwReason) 
    { 
        case DLL_PROCESS_ATTACH:
			hDll = hModule;
			// get the handle of the SS dialog 
			hSSDlg = FindWindow(NULL,SSDialogTitle);
			if (!hSSDlg)
			{
				MessageBoxA(
					0,
					"Could locate SoftSnoop Dialog :(",
					"Error",
					MB_ICONERROR | MB_SYSTEMMODAL);
				return FALSE;
			}
			if (!HookApis())
				return FALSE;
            break;

        case DLL_PROCESS_DETACH:
			// free the memory with the Api stubs
			GlobalFree(pApiStubMem);
            break;
	}
	return TRUE;
}

extern "C" VOID __stdcall TrappedApiCall(DWORD dwApiNum)
{
	// send the GUI a message with the index of the
	// called API
	SendMessage(hSSDlg,WM_APICALL,dwApiNum,NULL);
	return;
}

BOOL InitApiStubStruct(sApiStub &tmpApiStub)
{
	// paste the values which are always the same
	//tmpApiStub.Int3        = 0xCC;
	tmpApiStub.byPushOpc   = 0x68;
	tmpApiStub.byCallOpc   = 0xE8;
    tmpApiStub.byJmpOpcApi = 0xE9;
	tmpApiStub.byPopadOpc  = 0x61;
	tmpApiStub.byPushadOpc = 0x60;
	dwTrapFunctAddr = (DWORD)GetProcAddress((HINSTANCE)hDll,TRAPFUNCTION_NAME);
	if (!dwTrapFunctAddr)
		return FALSE;
	else
		return TRUE;
}

BOOL BuildApiStub(DWORD* dwApiThunkAddr,DWORD dwApiNum)
{
	// assemble a new API stub into the allocated memory
	ApiStub.dwPushAddr = dwApiNum;
	ApiStub.dwJmpApiAddr = *pDW - (DWORD)pApiStubs - offsetof(sApiStub,dwJmpApiAddr) - 4;
	ApiStub.dwCallAddr = dwTrapFunctAddr - (DWORD)pApiStubs - \
		offsetof(sApiStub,dwCallAddr) - 4;
	CopyMemory(pApiStubs,&ApiStub,sizeof(sApiStub));
	*pDW = (DWORD)pApiStubs;
	pApiStubs = (PVOID)((DWORD)pApiStubs + sizeof(sApiStub));
	return TRUE;
}

BOOL HookApis()
{
	DWORD        dwApiCount,dwOldProt;
	BOOL         bSkipDll;
	int          i;

	//__asm int 3
	__try
	{
		if (!InitApiStubStruct(ApiStub))
			return FALSE;

		// get some PE infos
		PEInfo.pDosh = (PIMAGE_DOS_HEADER)(GetModuleHandle(NULL));
		PEInfo.pPeh  = (PIMAGE_NT_HEADERS)((DWORD)PEInfo.pDosh + PEInfo.pDosh->e_lfanew);
		PEInfo.ImageBase = PEInfo.pPeh->OptionalHeader.ImageBase;
		PEInfo.SizeOfImage = PEInfo.pPeh->OptionalHeader.SizeOfImage;
		pIID = (PIMAGE_IMPORT_DESCRIPTOR)(PEInfo.pPeh->OptionalHeader.DataDirectory[1].\
			VirtualAddress + PEInfo.ImageBase);

		// get write access
		VirtualProtect(
			(VOID*)PEInfo.ImageBase,
			PEInfo.SizeOfImage,
			PAGE_READWRITE,
			&dwOldProt);

		// count the imports
		dwApiCount = 0;
		while (pIID->FirstThunk)
		{
			pDW = (DWORD*)(pIID->FirstThunk + PEInfo.ImageBase);	
			while (*pDW)
			{
				++dwApiCount;
				++pDW;
			}
			++pIID;
		}

		// get the needed mem
		pApiStubs = GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT,sizeof(sApiStub) * dwApiCount);
		if (!pApiStubs)
			return FALSE;
		pApiStubMem = pApiStubs; // make a copy for freeing it late
			
		// trap !
		pIID = (PIMAGE_IMPORT_DESCRIPTOR)(PEInfo.pPeh->OptionalHeader.DataDirectory[1].VirtualAddress +
			PEInfo.ImageBase);
		dwApiCount = 0;
		while (pIID->FirstThunk)
		{
			// process the thunks of this dll ?
			bSkipDll = FALSE;
			for (i=0; i<DLLSKIPCOUNT; i++)
				if (_strnicmp((CHAR*)&DllSkipList[i].DllName,
					(CHAR*)(PEInfo.ImageBase + pIID->Name),
					(size_t)DllSkipList[i].iCheckSize) == 0)
					bSkipDll = TRUE;
			// process the FirstThunk members
			pDW = (DWORD*)(pIID->FirstThunk + PEInfo.ImageBase);
			while (*pDW)
			{
				if (!bSkipDll)
					BuildApiStub(pDW,dwApiCount);
				++dwApiCount;
				++pDW;
			}
			++pIID;
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		GlobalFree(pApiStubMem);
		return FALSE;
	}
	return TRUE;
}
