
#include <windows.h>
#include "resource.h"
#include "BPMenu.h"
#include "SoftSnoop.h"
#include "OptionMenu.h"

// the functions
VOID  CreateBPDlg(HINSTANCE hInst,HANDLE hDlgOwner);
BOOL  CALLBACK BPDialogFunct(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL  SaveBPXList();

// variables
CHAR    cEditBuff[MAX_APILISTITEMLENGTH * 2],cBuff[40];
DWORD   i,dwListCnt;
HWND    hBPDlg;

VOID CreateBPDlg(HINSTANCE hInst,HANDLE hDlgOwner)
{
	// create a dlg;
	WNDCLASS wc;
	ZeroMemory(&wc,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wc.lpszClassName = "SS_BPMenu";
	RegisterClass(&wc);
	DialogBox(hInst,MAKEINTRESOURCE(IDD_BP),(HWND)hDlgOwner,BPDialogFunct);
	return;
}

BOOL CALLBACK BPDialogFunct(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	DWORD  dwSizeCheck,dwStrLen,dwBPX;
	CHAR*  pCH;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		hBPDlg = hDlg;
		// add the trapped api names to the listbox
		pCH = (PSTR)TrapApiNameBuff;
		while (*pCH != 0)
		{
			SendDlgItemMessage(hDlg,IDC_TRAPAPILIST,LB_ADDSTRING,NULL,(LPARAM)pCH);
			pCH += lstrlen(pCH);
			pCH++;
		}
		// add the breakpoint VA's to its listbox
		for(i=0; (INT)i<iBPXCnt; i++)
		{
			wsprintf(cBuff,"%X",(DWORD)BPXInfo[i].pVA);
			SendDlgItemMessage(hDlg,IDC_BPXLIST,LB_ADDSTRING,NULL,(LPARAM)(PSTR)cBuff);
		}
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_ADDTRAPAPI:
			if (GetDlgItemText(
				hDlg,
				IDC_EDITTRAPAPI,
				(PSTR)cEditBuff,
				sizeof(cEditBuff)) == 0)
			{
				MessageBeep(MB_ICONERROR);
				return TRUE;
			}
			SendDlgItemMessage(hDlg,IDC_TRAPAPILIST,LB_ADDSTRING,NULL,(LPARAM)cEditBuff);
			SetDlgItemText(hDlg,IDC_EDITTRAPAPI,"");
			break;

		case IDC_DELETETRAPAPI:
			i = SendDlgItemMessage(hDlg,IDC_TRAPAPILIST,LB_GETCURSEL,NULL,NULL);
			if ((int)i < 0)
			{
				MessageBeep(MB_ICONERROR);
				return TRUE;
			}
			SendDlgItemMessage(hDlg,IDC_TRAPAPILIST,LB_DELETESTRING,i,NULL);
			return TRUE;

		case IDC_ADDBPX:
			if (GetDlgItemText(
				hDlg,
				IDC_EDITBPX,
				(PSTR)cEditBuff,
				sizeof(cEditBuff)) == 0)
			{
				MessageBeep(MB_ICONERROR);
				return TRUE;
			}
			dwBPX = Hexstr2Int((PSTR)cEditBuff);
			if (dwBPX == -1)
			{
				MessageBox(
					hDlg,
					"Invalid hex number !\nPlease enter a valid hex number\nwith a maximum of 8 characters.",
					"ERROR",
					MB_ICONERROR);
				return TRUE;
			}
			SendDlgItemMessage(hDlg,IDC_BPXLIST,LB_ADDSTRING,NULL,(LPARAM)cEditBuff);
			SetDlgItemText(hDlg,IDC_EDITBPX,"");
			return TRUE;

		case IDC_DELETEBPX:
			i = SendDlgItemMessage(hDlg,IDC_BPXLIST,LB_GETCURSEL,NULL,NULL);
			if ((int)i < 0)
			{
				MessageBeep(MB_ICONERROR);
				return TRUE;
			}
			SendDlgItemMessage(hDlg,IDC_BPXLIST,LB_DELETESTRING,i,NULL);
			return TRUE;

		case ID_SETBPS:
			if (!bDebugging)
			{
				MessageBox(hDlg,"This is only possible while debugging !","ERROR",\
					MB_ICONERROR);
				return TRUE;
			}
			if (!SaveBPXList())
				return TRUE;
			if (ProcessBPXList())
				MessageBox(hDlg,"Done",":)",MB_ICONINFORMATION);
			return TRUE;

		case ID_BPDLG_OK:
			// - save the api names -
			dwSizeCheck = 0;
			pCH = (CHAR*)TrapApiNameBuff;
			dwListCnt = SendDlgItemMessage(hDlg,IDC_TRAPAPILIST,LB_GETCOUNT,NULL,NULL);
			if (dwListCnt != 0)
			{
				for(i=0; i<dwListCnt; i++)
				{
					dwStrLen = SendDlgItemMessage(
						hDlg,
						IDC_TRAPAPILIST,
						LB_GETTEXT,
						i,
						(LPARAM)(PSTR)cEditBuff);
					dwSizeCheck += ++dwStrLen;
					// to many names ?
					if (dwSizeCheck+1 > TRAPAPIBUFFSIZE)
					{
						wsprintf(
							cBuff,
							"The API names are limited to %i characters !",
							TRAPAPIBUFFSIZE);
						MessageBox(hDlg,cBuff,"ERROR",MB_ICONERROR);
						TrapApiNameBuff[0] = 0;
						return TRUE;
					}
					// copy the name into the buffer
					strcpy(pCH,(PSTR)cEditBuff);
					pCH += dwStrLen;
				}
			}
			// NULL terminate the buffer
			*pCH = 0;

			if (!SaveBPXList())
				return TRUE;

			// quit
			EndDialog(hDlg,0);
			return TRUE;

		case ID_BPDLG_CANCEL:
			EndDialog(hDlg,0);
			return TRUE;
		}
		break;

	case WM_CLOSE:
		EndDialog(hDlg,0);
		return TRUE;
	}
	return FALSE;
}

BOOL SaveBPXList()
{
	// - save the breakpoint VA's -
	dwListCnt = SendDlgItemMessage(hBPDlg,IDC_BPXLIST,LB_GETCOUNT,NULL,NULL);
	// are there to many ?
	if (dwListCnt > MAX_INT3BPS)
	{
		wsprintf(
			cBuff,
			"The number of Int3-breakpoints is limited to %i !",
			MAX_INT3BPS);
		MessageBox(hBPDlg,cBuff,"ERROR",MB_ICONERROR);
		return FALSE;
	}
	// process the list
	iBPXCnt = dwListCnt;
	for(i=0; i<dwListCnt; i++)
	{
		SendDlgItemMessage(hBPDlg,IDC_BPXLIST,LB_GETTEXT,i,(LPARAM)(PSTR)cBuff);
		BPXInfo[i].pVA = (VOID*)Hexstr2Int((PSTR)cBuff);
	}			
	return TRUE;
}
