
#include <windows.h>
#include "resource.h"
#include "OptionMenu.h"
#include "SoftSnoop.h"

// the functions
VOID CreateOptionDlg(HINSTANCE hInst,HANDLE hDlgOwner);
BOOL CALLBACK OptionDialogFunct(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//variables
HINSTANCE    hOptInst;
HANDLE       hOptDlg,hDeleteButton,hEditButton,hAPIList,hAddButton,
             hAddDllB,hDeleteDllB,hDllList,hEditDll,hEditCmdLine;
char         cEditBoxBuff[MAX_PATH],MsgBuff[50];
WORD         i;
BOOL         bButtonState;

VOID CreateOptionDlg(HINSTANCE hInst,HANDLE hDlgOwner)
{
	hOptInst = hInst;

	// create a dlg;
	WNDCLASS wc;
	ZeroMemory(&wc,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wc.lpszClassName = "SS_Options";
	RegisterClass(&wc);
	DialogBox(hInst,MAKEINTRESOURCE(IDD_OPTIONS),(HWND)hDlgOwner,OptionDialogFunct);
	return;
}

BOOL CALLBACK OptionDialogFunct(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int iSelIndex,iStrLen;

	switch(uMsg)
	{
		case WM_INITDIALOG:
			// get some window handles
			hOptDlg = hDlg;
			hDeleteButton  = GetDlgItem(hDlg,IDC_DELETEAPI);
			hAddButton     = GetDlgItem(hDlg,IDC_ADDAPI);
			hEditButton    = GetDlgItem(hDlg,IDC_EDITAPI);
			hAPIList       = GetDlgItem(hDlg,IDC_APILIST);
			hEditCmdLine   = GetDlgItem(hDlg,IDC_CMDLINESTR);

			hDeleteDllB    = GetDlgItem(hDlg,IDC_DLLLIST);
			hAddDllB       = GetDlgItem(hDlg,IDC_ADDDLL);
			hDeleteDllB    = GetDlgItem(hDlg,IDC_DELETEDLL);
			hDllList       = GetDlgItem(hDlg,IDC_DLLLIST);
			hEditDll       = GetDlgItem(hDlg,IDC_EDITDLL);

			// process the options
			if (Option.wIgnoreAPINum != 0)
			{
				for (i=0; i<Option.wIgnoreAPINum; i++)
					SendDlgItemMessage(hDlg,IDC_APILIST,LB_ADDSTRING,NULL, \
					(LPARAM)Option.cIgnoreAPIs[i]);
			}
			if (Option.wIgnoreDllNum != 0)
			{
				for (i=0; i<Option.wIgnoreDllNum; i++)
					SendDlgItemMessage(hDlg,IDC_DLLLIST,LB_ADDSTRING,NULL, \
					(LPARAM)Option.cIgnoreDlls[i]);
			}

			if (!Option.bIgnoreAPIs)
				SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDC_IGNOREAPI,0),NULL);
			else
				CheckDlgButton(hDlg,IDC_IGNOREAPI,BST_CHECKED);

			if (!Option.bIgnoreDlls)
				SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDC_IGNOREDLL,0),NULL);
			else
				CheckDlgButton(hDlg,IDC_IGNOREDLL,BST_CHECKED);

			CheckDlgButton(hDlg,
				IDC_MOVEWIN,
				Option.bMoveWindow ? BST_CHECKED : BST_UNCHECKED);
			CheckDlgButton(hDlg,
				IDC_SHOWAPI,
				Option.bReportNameAPI ? BST_CHECKED : BST_UNCHECKED);			
			CheckDlgButton(hDlg,
				IDC_SHOWAPIORDINAL,
				Option.bReportOrdinalAPI ? BST_CHECKED : BST_UNCHECKED);
			CheckDlgButton(hDlg,
				IDC_SHOWDEBUG,
				Option.bShowDebugEvents ? BST_CHECKED : BST_UNCHECKED);
			CheckDlgButton(hDlg,
				IDC_HANDLEEXCEPT,
				Option.bHandleExceptions ? BST_CHECKED : BST_UNCHECKED);
			if(Option.bAdditionalCmdLine)
				CheckDlgButton(hDlg,IDC_CMDLINE,TRUE);
			else
				EnableWindow((HWND)hEditCmdLine,FALSE);
			SetDlgItemText(hDlg,IDC_CMDLINESTR,Option.cCmdLine);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case ID_OK:
					// - process the Api to ignore
					Option.wIgnoreAPINum = (WORD)SendDlgItemMessage(hDlg,IDC_APILIST,LB_GETCOUNT, \
						NULL,NULL);
					// are there to many APIs ???
					if (Option.wIgnoreAPINum > MAX_IGNOREAPINUM)
					{
						wsprintf(MsgBuff,"You can ignore a maximum of %i API's !", \
							MAX_IGNOREAPINUM);
						MessageBox(hDlg,MsgBuff,"Error",MB_ICONERROR);
						break;
					}
					// save the Api names
					for (i=0; i<Option.wIgnoreAPINum; i++)
						SendDlgItemMessage(hDlg,IDC_APILIST,LB_GETTEXT,i, \
						(LPARAM)Option.cIgnoreAPIs[i]);
					Option.wIgnoreAPINum = (WORD)SendDlgItemMessage(
						hDlg,
						IDC_APILIST,
						LB_GETCOUNT,
						NULL,
						NULL);
					// - process the Dlls to ignore
					Option.wIgnoreDllNum = (WORD)SendDlgItemMessage(
						hDlg,
						IDC_DLLLIST,
						LB_GETCOUNT,
						NULL,
						NULL);
					// are there to many Dlls ???
					if (Option.wIgnoreDllNum > MAX_IGNOREDLLNUM)
					{
						wsprintf(MsgBuff,"You can add a maximum of %i Dll's here !", \
							MAX_IGNOREDLLNUM);
						MessageBox(hDlg,MsgBuff,"Error",MB_ICONERROR);
						break;
					}
					// save the Dll names
					for (i=0; i<Option.wIgnoreDllNum; i++)
						SendDlgItemMessage(hDlg,IDC_DLLLIST,LB_GETTEXT,i, \
						(LPARAM)Option.cIgnoreDlls[i]);

					// process the rest
					Option.bIgnoreAPIs = IsDlgButtonChecked(hDlg,IDC_IGNOREAPI);
					Option.bIgnoreDlls = IsDlgButtonChecked(hDlg,IDC_IGNOREDLL);
					Option.bShowDebugEvents = IsDlgButtonChecked(hDlg,IDC_SHOWDEBUG);
					Option.bMoveWindow = IsDlgButtonChecked(hDlg,IDC_MOVEWIN);
					Option.bReportNameAPI = IsDlgButtonChecked(hDlg,IDC_SHOWAPI);
					Option.bReportOrdinalAPI = IsDlgButtonChecked(hDlg,IDC_SHOWAPIORDINAL);
					Option.bHandleExceptions = IsDlgButtonChecked(hDlg,IDC_HANDLEEXCEPT);
					// process the additional commandline
					Option.bAdditionalCmdLine = IsDlgButtonChecked(hDlg,IDC_CMDLINE);
					iStrLen = GetWindowTextLength((HWND)hEditCmdLine);
					if (iStrLen+1 > sizeof(Option.cCmdLine))
					{
						wsprintf(
							MsgBuff,
							"The length of the commandline parameters is limited to %i characters !",
							sizeof(Option.cCmdLine));
						MessageBox(hDlg,MsgBuff,"ERROR",MB_ICONERROR);
						return TRUE;
					}
					GetDlgItemText(hDlg,IDC_CMDLINESTR,Option.cCmdLine,\
						sizeof(Option.cCmdLine));
					// quit dialog
					EndDialog(hDlg,0);
					return TRUE;

				case ID_CANCEL:
					EndDialog(hDlg,0);
					return TRUE;

				case IDC_IGNOREAPI:
					bButtonState = IsDlgButtonChecked(hDlg,IDC_IGNOREAPI) ? TRUE : FALSE;
					EnableWindow((HWND)hAddButton,bButtonState);
					EnableWindow((HWND)hDeleteButton,bButtonState);
					EnableWindow((HWND)hEditButton,bButtonState);
					EnableWindow((HWND)hAPIList,bButtonState);
					return TRUE;

				case IDC_ADDAPI:
					// was sth entered ?
					GetDlgItemText(hDlg,IDC_EDITAPI,cEditBoxBuff,sizeof(cEditBoxBuff));
					if (cEditBoxBuff[0] == 0)
					{
						MessageBeep(MB_ICONERROR);
						return TRUE;
					}
					// check the length of the name
					if (lstrlen((CHAR*)&cEditBoxBuff) > MAX_APILISTITEMLENGTH)
					{
						wsprintf(
							MsgBuff,
							"The length of the API name is limited to %i characters !",
							MAX_APILISTITEMLENGTH);
						MessageBox(hDlg,MsgBuff,"Error",MB_ICONERROR);
						SetDlgItemText(hDlg,IDC_EDITAPI,"");
						return TRUE;
					}
					SendDlgItemMessage(hDlg,IDC_APILIST,LB_ADDSTRING,NULL,\
						(LPARAM)cEditBoxBuff);
					SetDlgItemText(hDlg,IDC_EDITAPI,"");
					return TRUE;

				case IDC_DELETEAPI:
					iSelIndex = SendDlgItemMessage(hDlg,IDC_APILIST,LB_GETCURSEL,NULL,NULL);
					if (iSelIndex < 0)
					{
						MessageBeep(MB_ICONERROR);
						return TRUE;
					}
					SendDlgItemMessage(hDlg,IDC_APILIST,LB_DELETESTRING,iSelIndex,NULL);
					return TRUE;

				case IDC_IGNOREDLL:
					bButtonState = IsDlgButtonChecked(hDlg,IDC_IGNOREDLL) ? TRUE : FALSE;
					EnableWindow((HWND)hAddDllB,bButtonState);
					EnableWindow((HWND)hDeleteDllB,bButtonState);
					EnableWindow((HWND)hEditDll,bButtonState);
					EnableWindow((HWND)hDllList,bButtonState);
					return TRUE;

				case IDC_ADDDLL:
					// was sth entered ?
					GetDlgItemText(hDlg,IDC_EDITDLL,cEditBoxBuff,sizeof(cEditBoxBuff));
					if (cEditBoxBuff[0] == 0)
					{
						MessageBeep(0);
						return TRUE;
					}
					// check the length of the name
					if (lstrlen((CHAR*)&cEditBoxBuff) > MAX_DLLNAMELENGTHOPT)
					{
						wsprintf(
							MsgBuff,
							"The length of the Dll name is limited to %i characters !",
							MAX_DLLNAMELENGTHOPT);
						MessageBox(hDlg,MsgBuff,"Error",MB_ICONERROR);
						SetDlgItemText(hDlg,IDC_EDITDLL,"");
						return TRUE;
					}
					SendDlgItemMessage(hDlg,IDC_DLLLIST,LB_ADDSTRING,NULL,\
						(LPARAM)cEditBoxBuff);
					SetDlgItemText(hDlg,IDC_EDITDLL,"");
					return TRUE;

				case IDC_DELETEDLL:
					iSelIndex = SendDlgItemMessage(hDlg,IDC_DLLLIST,LB_GETCURSEL,NULL,\
						NULL);
					if (iSelIndex < 0)
					{
						MessageBeep(MB_ICONERROR);
						return TRUE;
					}
					SendDlgItemMessage(hDlg,IDC_DLLLIST,LB_DELETESTRING,iSelIndex,NULL);
					return TRUE;

				case IDC_CMDLINE:
					bButtonState = IsDlgButtonChecked(hDlg,IDC_CMDLINE);
					EnableWindow(
						(HWND)hEditCmdLine,
						bButtonState);		
					if(bButtonState)
						SetFocus((HWND)hEditCmdLine);
					return TRUE;
			}
	}
	return FALSE;
}
