%include "util.mac"
%include "icedump.inc"
%include "vxdn.inc"
%include "wiat.inc"
%include "win32n.inc"
%include "common.inc"
%include "taskmod.inc"


bits 32


global GetStackHandle
global GetProcessHandle
global GetCurrentProcessID
global GetModuleHandle
global PageQuery


segment _LTEXT
GetStackHandle:
	mov	eax, [dClient_ESP]
	mov	eax, [eax]
	ret

GetProcessHandle:
	VxDCall	VWIN32_GetCurrentProcessHandle
	ret

;
; Retrieve Current Process ID.
;

;
;eax=PID.
;
GetCurrentProcessID:
	VxDCall	VWIN32_GetCurrentProcessHandle
	test	eax,eax
	jz	@F

	movzx	eax,word [eax+0x38]	; PDB.W16TDB
@@
	retn
;
; Retrieve ImageBase of given Name (Null for Main Base).
;

;
;ebp+8 : Name or 0.
;
;eax=ImageBase, 0 if failure.
;
GetModuleHandle:
	push	ebp
	mov	ebp, esp
	sub	esp, TASKENTRY_size+MAX_PATH+MODULEENTRY_size
	push	esi
	push	edi
	push	edx
	push	ecx
	push	ebx

;
; Setup registers [Name/Current PID].
;
	Call	GetCurrentProcessID

	mov	edx, eax
	mov	esi, [ebp+08h]

	test	esi, esi		; SelfBase ?
	jnz	.ScanThis

;
; Retrieve name of current PID.
;
	lea	ebx, [ebp-TASKENTRY_size]

	push	ebx
	Call	TaskFirst

.CmpTaskDB:
	test	eax, eax
	jz	.RetFailure

	cmp	[ebx+TASKENTRY.te_hTask], edx
	jz	.CopyFN

	push	ebx
	Call	TaskNext
	jmp	.CmpTaskDB

.CopyFN:
;
; Replicate name.
;
	lea	esi, [ebx+TASKENTRY.te_ProcName]
	lea	edi, [ebp-(TASKENTRY_size+MAX_PATH)]
	push	edi
	push	esi
	call	strcopy
	mov	esi, edi

.ScanThis:
	push	esi
	Call	CharUpper               ; Fool Proof Measure :)

;
; Retrieve Short name of Target.
;
	push	esi
	Call	ExtractNamePos
	add	esi, eax

;
; Browse Module List.
;
	lea	ebx, [ebp-(TASKENTRY_size+MAX_PATH+MODULEENTRY_size)]

	push	edx
	push	ebx
	Call	ModFirst

.CmpModShort:
	test	eax, eax
	jz	.RetFailure

;
; Found it ?.
;
	lea	eax, [ebx+MODULEENTRY.me_ModuleName]
	push	eax
	push	esi
	call	strcmp
	test	eax, eax
	jz	.OkFoundModule

	push	ebx
	Call	ModNext
	jmp	.CmpModShort

.OkFoundModule:
;
; Return hMod.
;
	mov	eax, [ebx+MODULEENTRY.me_hModule]

.RetFailure:
	pop	ebx
	pop	ecx
	pop	edx
	pop	edi
	pop	esi
	add	esp, TASKENTRY_size+MAX_PATH+MODULEENTRY_size
	pop     ebp
	retn	4

PageQuery:
	push	ebp
	mov	ebp, esp
	push	esi
	push	edi
	push	edx
	push	ecx
	push	ebx

	VMMCall	_PageQuery, dword [ebp+08h], dword [ebp+0Ch], dword [ebp+10h]

	pop	ebx
	pop	ecx
	pop	edx
	pop	edi
	pop	esi
	pop	ebp
	retn	0Ch
